drop procedure if exists SP_SET_POSTS_COLLECTION_CLONE;
create
    definer = skoiypp@`%` procedure SP_SET_POSTS_COLLECTION_CLONE(IN _id_collection int(10))
BEGIN

DECLARE _position INT;
DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF (SELECT count(1) FROM collections WHERE id_collection = _id_collection)
THEN
    
    SELECT count(position)+1 into _position FROM collections WHERE id_collection = _id_collection;

    INSERT into collections(management_name, publish_date,begin_date, end_date,domain,default_id_dossier,position,register_date)
        SELECT CONCAT('Copy of ',management_name), publish_date,begin_date, end_date,domain,default_id_dossier,_position,now() FROM collections WHERE id_collection = _id_collection; 
    SET p_last_id = last_insert_id();

	INSERT into dossiers_collections_related(id_dossier,id_collection,position,register_date) 
		 SELECT id_dossier,p_last_id,position,now() FROM dossiers_collections_related WHERE id_collection = _id_collection;

	INSERT into collections_l10n(id_collection,iso_language,name,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_watermark_image,register_date)
		 SELECT p_last_id,iso_language,name,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_watermark_image,now() FROM collections_l10n WHERE id_collection = _id_collection;
                
   CALL SP_SET_POSTS_COLLECTION_CLONE_L10N(p_last_id,_id_collection);

   SELECT id_collection,management_name, publish_date,begin_date, end_date,domain,default_id_dossier, position,FN_GET_POSTS_DOSSIERS_ON_COLLECTIONS_NUM(id_collection) as total, state, register_date FROM collections WHERE id_collection = p_last_id;

ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

