create
    definer = skoiypp@`%` function FN_GET_ASSETS_IS_FILE_TYPE(_id_asset int(10), _type varchar(255)) returns tinyint(1)
BEGIN

DECLARE _is tinyint(1);
DECLARE _in varchar(255);

IF(SELECT id_asset FROM assets WHERE id_asset = _id_asset)
THEN
	
	IF(FIND_IN_SET('AUDIO',_type))
	THEN
        SET _in = CONCAT_WS(',',_in,'mp3');
	END IF;
	
	IF(FIND_IN_SET('IMAGE',_type))
	THEN
		SET _in = CONCAT_WS(',',_in,'png','gif','bmp','jpeg','jpg','jpe','jfif');
	END IF;
	
	IF(FIND_IN_SET('DOC',_type))
	THEN
            SET _in = CONCAT_WS(',',_in,'psd','eps','xls','xlsx','doc','docx','ppt','pptx','pdf','application/pdf');
	END IF;
	
	IF(FIND_IN_SET('PDF',_type))
	THEN
            SET _in = CONCAT_WS(',',_in,'pdf','application/pdf');
	END IF;
	
	IF(FIND_IN_SET('COMPRESS',_type))    
	THEN
        SET _in = CONCAT_WS(',',_in,'zip');
	END IF;
	
	IF(FIND_IN_SET('RAW',_type))    
	THEN
            SET _in = CONCAT_WS(',',_in,'nef','dng','tif');
	END IF;
	
    SELECT count(1) into _is FROM assets WHERE id_asset = _id_asset AND FIND_IN_SET(extension,_in);
ELSE
	SET _is = 0;
END IF;

IF(_is > 0)
THEN
	SET _is = 1;
END IF;

RETURN _is;

END;

