create
    definer = skoiypp@`%` function FN_GET_VIDEO_SEARCH(_id int(10), _field varchar(255), _query varchar(255)) returns int(10)
BEGIN

DECLARE _total int(10);

CASE
WHEN _field = 'PROFILE' THEN SELECT count(1) into _total FROM video_profiles_l10n WHERE (title like _query OR description like _query) AND id_profile = _id ;
WHEN _field = 'PROFILE_BODY' THEN SELECT count(1) into _total FROM video_profiles_l10n vp, video_profiles_l10n_body vpb WHERE vpb.id_l10n = vp.id_l10n AND (title like _query OR description like _query) AND id_profile = _id;
WHEN _field = 'PROFILE_TAGS' THEN SELECT count(1) into _total FROM video_profiles_l10n vp, video_profiles_l10n_tags_related vpt WHERE vpt.id_l10n = vp.id_l10n AND id_profile = _id AND id_tag in (SELECT id_tag FROM video_tags WHERE name like _query AND public = 1);
WHEN _field = 'VIDEO' THEN SELECT count(1) into _total FROM videos WHERE name like _query AND id_video = _id AND deleted = 0;
WHEN _field = 'PLAYLIST' THEN SELECT count(1) into _total FROM playlists_l10n WHERE name like _query AND description like _query AND id_playlist = _id;
WHEN _field = 'CHANNEL' THEN SELECT count(1) into _total FROM channels_l10n WHERE name like _query AND description like _query AND id_channel = _id;
ELSE SET _total = 0;
END CASE;

RETURN _total;

END;

