create
    definer = skoiypp@`%` function FN_GET_VIDEO_TRANSCODING_CODE(_type varchar(10), _field int(10),
                                                                 _vcodec varchar(192), _acodec varchar(192),
                                                                 _format varchar(192), _scale_w int(10),
                                                                 _scale_h int(10), _aspect_w int(10), _aspect_h int(10),
                                                                 _profile varchar(192),
                                                                 _level varchar(192)) returns varchar(255)
BEGIN

DECLARE _code varchar(255);
DECLARE _strict varchar(255);

IF(_vcodec = 'libx264')
THEN
SET _profile = CONCAT('-profile:v ',_profile);
SET _level = CONCAT('-level ',_level);
SET _strict = ' -strict -2 ';
ELSE 
SET _profile = '';
SET _level = '';
SET _strict = '';
END IF;

IF(_type = 'lm')
THEN
CASE
	WHEN _field = 144 THEN 	SET _code = CONCAT('-deinterlace -vf scale=',_scale_w,':',_scale_h,' -aspect ',_aspect_w,':',_aspect_h,' -vcodec ',_vcodec,' -b:v 224k -maxrate 250k -bufsize 500k -r 23.98 -g 48 ',_profile,' ',_level,' -f ',_format,' -acodec ',_acodec,' ',_strict,' -b:a 48k -ac 1 -vsync 1 -sc_threshold 0 ');
	WHEN _field = 270 THEN 	SET _code = CONCAT('-deinterlace -vf scale=',_scale_w,':',_scale_h,' -aspect ',_aspect_w,':',_aspect_h,' -vcodec ',_vcodec,' -b:v 400k -maxrate 500k -bufsize 1000k -r 23.98 -g 48 ',_profile,' ',_level,' -f ',_format,' -acodec ',_acodec,' ',_strict,' -b:a 64k -vsync 1 -sc_threshold 0 ');
	ELSE SET _code = '';
END CASE;
END IF;

IF(_type = 'm')
THEN
CASE
	WHEN _field = 360 THEN 	SET _code = CONCAT('-deinterlace -vf scale=',_scale_w,':',_scale_h,' -aspect ',_aspect_w,':',_aspect_h,' -vcodec ',_vcodec,' -b:v 450k -maxrate 700k -bufsize 1400k -r 23.98 -g 48 ',_profile,' ',_level,' -f ',_format,' -acodec ',_acodec,' ',_strict,' -b:a 64k -vsync 1 -sc_threshold 0 ');
	WHEN _field = 540 THEN 	SET _code = CONCAT('-deinterlace -vf scale=',_scale_w,':',_scale_h,' -aspect ',_aspect_w,':',_aspect_h,' -vcodec ',_vcodec,' -b:v 750k -maxrate 1100k -bufsize 2200k -r 23.98 -g 48 ',_profile,' ',_level,' -f ',_format,' -acodec ',_acodec,' ',_strict,' -b:a 64k -vsync 1 -sc_threshold 0 ');
	ELSE SET _code = '';
END CASE;
END IF;

IF(_type = 'w')
THEN
CASE
	WHEN _field = 270 THEN 	SET _code = CONCAT('-deinterlace -vf scale=',_scale_w,':',_scale_h,' -aspect ',_aspect_w,':',_aspect_h,' -vcodec ',_vcodec,' -b:v 400k -maxrate 500k -bufsize 1000k -r 23.98 -g 48 ',_profile,' ',_level,' -f ',_format,' -acodec ',_acodec,' ',_strict, ' -vsync 1 -sc_threshold 0 ');
	WHEN _field = 360 THEN 	SET _code = CONCAT('-deinterlace -vf scale=',_scale_w,':',_scale_h,' -aspect ',_aspect_w,':',_aspect_h,' -vcodec ',_vcodec,' -b:v 650k -maxrate 800k -bufsize 1600k -r 23.98 -g 48 ',_profile,' ',_level,' -f ',_format,' -acodec ',_acodec,' ',_strict, ' -vsync 1 -sc_threshold 0 ');
	WHEN _field = 540 THEN 	SET _code = CONCAT('-deinterlace -vf scale=',_scale_w,':',_scale_h,' -aspect ',_aspect_w,':',_aspect_h,' -vcodec ',_vcodec,' -b:v 1000k -maxrate 1450k -bufsize 2900k -r 23.98 -g 48 ',_profile,' ',_level,' -f ',_format,' -acodec ',_acodec,'  ',_strict, ' -vsync 1 -sc_threshold 0 ');
	WHEN _field = 720 THEN 	SET _code = CONCAT('-deinterlace -vf scale=',_scale_w,':',_scale_h,' -aspect ',_aspect_w,':',_aspect_h,' -vcodec ',_vcodec,' -b:v 1500k -maxrate 1900k -bufsize 3800k -r 23.98 -g 48 ',_profile,' ',_level,' -f ',_format,' -acodec ',_acodec,' ',_strict, ' -vsync 1 -sc_threshold 0 ');
	WHEN _field = 1080 THEN 	SET _code = CONCAT('-deinterlace -vf scale=',_scale_w,':',_scale_h,' -aspect ',_aspect_w,':',_aspect_h,' -vcodec ',_vcodec,' -b:v 3000k -maxrate 5000k -bufsize 10000k -r 23.98 -g 48 ',_profile,' ',_level,' -f ',_format,' -acodec ',_acodec,' ',_strict, ' -vsync 1 -sc_threshold 0 ');
	ELSE SET _code = '';
END CASE;
END IF;


RETURN _code;

END;

