create
    definer = skoiy@`%` procedure SP_DEL_LIVE_COMPOSED(IN _id_composed int)
BEGIN

DECLARE last_id_profile INT;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF (SELECT count(1) FROM video_composed WHERE id_composed = _id_composed AND FN_GET_VIDEO_IS_LIVE_COMPOSED(id_composed) = 1)
THEN
    
    SELECT id_profile into last_id_profile FROM video_composed WHERE id_composed = _id_composed;
    SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(20,_id_composed) into _empty;
    
    DELETE FROM video_composed WHERE id_composed = _id_composed;

	CALL SP_VIDEO_CHANGE_LIVE_PROFILE_STATE(last_id_profile,@result_profile);
        
	CALL SP_VIDEO_CHANGE_VIDEO_PLAYLIST_POSITION(_id_composed,@result_playlist);

    
    IF(@result_profile = -1 || @result_playlist = -1)
    THEN
		SELECT -1 as return_code;
		ROLLBACK;
    END IF;
  
    SELECT 0 as return_code;

ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

