create
    definer = skoiypp@`%` procedure SP_GET_ADS_CAMPAIGNS_RULES_VIDEO_TAGS_COUNT(IN _field int(10), IN _query varchar(192), IN _filter varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;


SET @_name = CONCAT("%",_query,"%");
SET @_id_video = _filter;
SET @_id_profile = _filter;
SET @_id_tag = _filter;
SET @_num_x = _filter;

SET sqlcommand = "SELECT count(1) as total FROM video_tags pt ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 1 AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 0 AND name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag in (SELECT distinct id_tag FROM video_videos_tags_related) AND name like @_name ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag in (SELECT distinct id_tag FROM video_profiles_l10n_tags_related) AND name like @_name ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag in (SELECT distinct id_tag FROM video_videos_tags_related WHERE id_video = @_id_video) AND name like @_name ");
WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag in (SELECT distinct id_tag FROM video_profiles_l10n_tags_related vptr, video_profiles_l10n vl10n WHERE vl10n.id_l10n = vptr.id_l10n AND vl10n.id_profile = @_id_profile) AND name like @_name ");
WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name_stripped in (SELECT name_stripped FROM (SELECT count(1) as total,name_stripped FROM video_tags GROUP BY name_stripped) as tt WHERE total > 1) AND name like @_name ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE (FN_GET_VIDEO_TOTAL_COMPOSES_BY_ID_TAG(id_tag)) = @_num_x AND name like @_name ");
WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag like @_id_tag ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;  
        
COMMIT;

END;

