create
    definer = skoiypp@`%` procedure SP_GET_ADS_CAMPAIGNS_TAGS_RELATED(IN _id_campaign int, IN _field int(10),
                                                                      IN _field_snd int(10), IN _field_trd int(10),
                                                                      IN _query varchar(192), IN _filter varchar(192),
                                                                      IN _filter_snd varchar(192),
                                                                      IN _filter_trd varchar(192),
                                                                      IN _limit_sys_a bigint, IN _limit_sys_b bigint)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;



START TRANSACTION;

SET @_id_campaign = _id_campaign;
SET @_name = CONCAT("%",_query,"%");
SET @_cfilter = _filter;
SET @_filter = CONCAT("%",_filter,"%");

SET @id_campaign = _filter_snd;
SET @id_composed = _filter_snd;
SET @id_external_ad_tag = _filter_snd;
SET @id_ad = _filter_snd;

SET @_limit_sys_a = _limit_sys_a;
SET @_limit_sys_b = _limit_sys_b;

IF(_id_campaign < 1)
THEN
	SET sqlcommand = "SELECT at.id_tag,at.name,name_stripped, public, (SELECT count(1) FROM ads_campaigns_tags_related actr_sub WHERE id_tag = at.id_tag AND actr_sub.id_campaign in (SELECT id_campaign FROM ads_campaigns ac WHERE 1=1  ";
	
	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.id_campaign = @_id_campaign ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_campaign in (SELECT distinct id_campaign FROM ads_campaigns_video_composed_related WHERE id_composed = @id_composed) ) ");			
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_campaign in (SELECT distinct id_campaign FROM ads_campaigns_groups WHERE id_campaign_group in (SELECT id_campaign_group FROM ads_campaigns_groups_external_ad_tags)) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_campaign in (SELECT distinct id_campaign FROM ads_campaigns_groups WHERE id_campaign_group in (SELECT id_campaign_group FROM ads_campaigns_groups_external_ad_tags AND id_external_ad_tag = @id_external_ad_tag)) ");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_campaign in (SELECT distinct id_campaign FROM ads_campaigns_groups WHERE id_campaign_group in (SELECT id_campaign_group FROM ads_campaigns_groups_ads_videos)) ");
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_campaign in (SELECT distinct id_campaign FROM ads_campaigns_groups WHERE id_campaign_group in (SELECT id_campaign_group FROM ads_campaigns_groups_ads_videos AND id_ad = @id_ad))  ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	CASE
	WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND ac.name like @_name ");
	WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @_cfilter) AND (ac.name like @_name) ");
	WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state <> @_cfilter) AND (ac.name like @_name) ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
	END CASE;

	SET sqlcommand = CONCAT(sqlcommand," )) as total_campaigns FROM ads_campaigns_tags_related actr, ads_tags at, ads_campaigns ac2 WHERE at.id_tag = actr.id_tag AND ac2.id_campaign = actr.id_campaign GROUP BY id_tag ORDER by name ");

	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;
ELSE
	IF EXISTS(SELECT id_campaign FROM ads_campaigns_tags_related WHERE id_campaign = _id_campaign)
	THEN
		SELECT at.id_tag,at.name,name_stripped, public, (SELECT count(1) FROM ads_campaigns_tags_related WHERE id_tag = at.id_tag) as total_campaigns FROM ads_campaigns_tags_related actr, ads_tags at, ads_campaigns ac WHERE at.id_tag = actr.id_tag AND ac.id_campaign = actr.id_campaign AND actr.id_campaign = _id_campaign;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;
        
COMMIT;

END;

