create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_CLIPS_DATES(IN _id_directory int, IN _field int(10),
                                                               IN _field_snd int(10), IN _field_trd int(10),
                                                               IN _query varchar(192), IN _filter varchar(192),
                                                               IN _filter_snd varchar(192), IN _filter_trd varchar(192),
                                                               IN _limit_sys_a bigint, IN _limit_sys_b bigint)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_video = _filter_snd;
SET @_id_clip = _filter_snd;
SET @_name = CONCAT("%",_query,"%");
SET @_cfilter = _filter;
SET @_cfilter_snd = _field_snd;
SET @_filter = CONCAT("%",_filter,"%");

SET @_limit_sys_a = _limit_sys_a;
SET @_limit_sys_b = _limit_sys_b;
SET @_id_directory = _id_directory;

	SET sqlcommand = "SELECT year(register_date) as year, month(register_date) as month,count(1) as total FROM archive_clips ac WHERE ac.deleted = 0 ";

	IF(_id_directory > 0)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND ac.id_directory = @_id_directory ");
	END IF;

	IF (_field_snd > 0)
	THEN
		CASE
		WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.id_video = @_id_video ) ");
		WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.id_clip = @_id_clip ) ");
		WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.id_video = (SELECT id_video FROM archive_clips WHERE id_clip = @_id_clip ) ) ");
		WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.id_clip in (SELECT distinct id_clip FROM archive_transfers_clips_related) ) ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	IF (_query <> '')
	THEN
		SET sqlcommand =  CONCAT(sqlcommand, " AND ac.name like @_name ");
	END IF;

	SET sqlcommand =  CONCAT(sqlcommand, " GROUP BY year,month ORDER by year,month ");

	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;

COMMIT;

END;

