create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_VIDEOS(IN _room varchar(5), IN _id_user int(10),
                                                          IN _id_directory int, IN _field int(10),
                                                          IN _field_snd int(10), IN _field_trd int(10),
                                                          IN _query varchar(192), IN _filter varchar(192),
                                                          IN _filter_snd varchar(192), IN _filter_trd varchar(192),
                                                          IN _limit_sys_a bigint, IN _limit_sys_b bigint,
                                                          IN _limit_a int(10), IN _limit_b int(10),
                                                          IN _order_by int(10), IN _order int(10))
BEGIN



DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
	IF(_room = '')
	THEN
	  SELECT count(1) into _limit_b FROM archive_videos WHERE deleted = 0;
	ELSE
	  SELECT count(1) into _limit_b FROM archive_videos WHERE deleted = 0 AND FN_GET_ARCHIVE_VIDEO_IN_ROOM(id_video,_id_user,_room) = 1;
	END IF;
END IF;

SET @room = _room;
SET @id_user = _id_user;

SET @_name = CONCAT("%",_query,"%");
SET @_cfilter = _filter;
SET @_filter = CONCAT("%",_filter,"%");
SET @_filename = CONCAT("%",_filter_snd,"%");

SET @_tags_stripped = CONCAT("%",_query,"%");

SET @_tags_group = REPLACE(_filter_trd,'%','');

SET @id_video = _filter_snd;
SET @_room = _filter_snd;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;
SET @_limit_sys_a = _limit_sys_a;
SET @_limit_sys_b = _limit_sys_b;
SET @_id_directory = _id_directory;

SET @_year = year(_filter);
SET @_month = month(_filter);
SET @_day = day(_filter);


IF(_id_directory = -1)
THEN
	SET sqlcommand = "SELECT id_video,id_directory,id_storage,id_cdn,name,filename,seconds,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,framerate,framecount,width,height,ratio,state,FN_GET_ARCHIVE_ROOMS_GROUPED(id_video,@id_user) as rooms,register_date,FN_GET_ARCHIVE_VIDEO_HAS_CLIPS(id_video) as has_clips, FN_GET_ARCHIVE_VIDEO_IN_TRANSFER(id_video) as in_transfer,FN_GET_ARCHIVE_VIDEO_HAS_PREVIEW(id_video) has_preview,FN_GET_ARCHIVE_VIDEO_THUMBNAIL(id_video) as thumbnail, FN_GET_ARCHIVE_VIDEOS_TAGS_GROUPED(v.id_video) as tags,FN_GET_ARCHIVE_VIDEO_TOTAL_CLIPS(id_video) as total_clips FROM archive_videos v WHERE id_directory is null AND deleted = 0 ";
	IF (_room <> '')
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND FN_GET_ARCHIVE_VIDEO_IN_ROOM(id_video,@id_user,@room) = 1 ");
	END IF;
	
	SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC LIMIT ?,?");

	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b;

ELSE

	IF (_id_directory = 0) OR (SELECT count(1) FROM archive_videos_directories WHERE id_directory = _id_directory)
	THEN

	SET sqlcommand = "SELECT id_video,id_directory,id_storage,id_cdn,name,filename,seconds,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,framerate,framecount,width,height,ratio,state,FN_GET_ARCHIVE_ROOMS_GROUPED(id_video,@id_user) as rooms,register_date,FN_GET_ARCHIVE_VIDEO_HAS_CLIPS(id_video) as has_clips, FN_GET_ARCHIVE_VIDEO_IN_TRANSFER(id_video) as in_transfer,FN_GET_ARCHIVE_VIDEO_HAS_PREVIEW(id_video) has_preview,FN_GET_ARCHIVE_VIDEO_THUMBNAIL(id_video) as thumbnail, FN_GET_ARCHIVE_VIDEOS_TAGS_GROUPED(v.id_video) as tags,FN_GET_ARCHIVE_VIDEO_TOTAL_CLIPS(id_video) as total_clips FROM archive_videos v WHERE deleted = 0 ";
	
	IF (_room <> '')
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND FN_GET_ARCHIVE_VIDEO_IN_ROOM(id_video,@id_user,@room) = 1 ");
	END IF;

	IF (_id_directory > 0 AND _field <> 14)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND id_directory = @_id_directory ");
	END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_video = @id_video ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_video in (SELECT distinct id_video FROM archive_clips) ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_video in (SELECT distinct id_video FROM archive_transfers_videos_related) ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_video in (SELECT distinct id_video FROM archive_videos_segment_tags_related) ) ");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_video in (SELECT distinct id_video FROM archive_rooms_related) ) ");
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_video in (SELECT distinct id_video FROM archive_rooms_related AND room = @_room) ) ");			
			WHEN _field_snd = 106 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND filename like @_filename ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	IF (_field_trd = 1000)
	THEN
		SET sqlcommand =  CONCAT(sqlcommand, " AND id_video in (SELECT id_video FROM archive_videos_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) ) ");    
	END IF;

	CASE
	WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (name like @_name OR ((SELECT count(1) FROM archive_tags vt, archive_videos_tags_related vvtr WHERE vt.id_tag = vvtr.id_tag AND vvtr.id_video = v.id_video AND name_stripped like @_tags_stripped) > 0)) ");
	WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
	WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) AND (name like @_name ) ");
	WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year) AND (name like @_name) ");
	WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @_cfilter) AND (name like @_name) ");
	WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (height like @_filter) AND (name like @_name) ");
	WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ratio like @_filter) AND (name like @_name) ");
	WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (mime_type like @_filter) AND (name like @_name) ");
	WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (size BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (name like @_name ) ");
	WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (seconds BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (name like @_name ) ");
	WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (bitrate BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (name like @_name ) ");

	WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) AND day(register_date) = @_day) ");
	WHEN _field = 12 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) ");
	WHEN _field = 13 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year) ");

	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
	END CASE;

		CASE
			WHEN _order_by = 10000 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY name DESC ");
			WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY name ASC ");
			WHEN _order_by = 10001 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date DESC ");
			WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date ASC ");
			WHEN _order_by = 10002 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY size DESC ");
			WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY size ASC ");
			WHEN _order_by = 10003 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY extension DESC ");
			WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY extension ASC ");
			WHEN _order_by = 10004 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY seconds DESC ");
			WHEN _order_by = 11004 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY seconds ASC ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC  ");
		END CASE;

	SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b;
		
	ELSE
	    SELECT -2 as return_code;
	END IF;
END IF;        
COMMIT;

END;

