create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_VIDEOS_SEGMENT_TAGS_RELATED_COUNT(IN _field INT, IN _filter varchar(192))
BEGIN

DECLARE _id_video INT(10);
DECLARE _id_tag INT(10);
DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET _id_video = _filter;
SET _id_tag = _filter;
SET @_tags_group = CONCAT("%",_filter,"%");

IF(_field = 1)
THEN
	IF EXISTS(SELECT id_video FROM archive_videos_segment_tags_related WHERE id_video = _id_video)
	THEN
		SELECT count(1) as total FROM archive_videos_segment_tags_related vvstr, archive_tags vt, archive_videos av, archive_videos_previews avp WHERE avp.id_video = av.id_video AND vt.id_tag = vvstr.id_tag AND av.id_video = vvstr.id_video AND av.deleted = 0 AND vvstr.id_video = _id_video;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;

IF(_field = 2)
THEN
	IF EXISTS(SELECT id_video FROM archive_videos_segment_tags_related WHERE id_tag = _id_tag)
	THEN
		SELECT count(1) as total FROM archive_videos_segment_tags_related vvstr, archive_tags vt, archive_videos av, archive_videos_previews avp WHERE avp.id_video = av.id_video AND vt.id_tag = vvstr.id_tag AND av.id_video = vvstr.id_video AND av.deleted = 0 AND vvstr.id_tag = _id_tag;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;

IF(_field = 3)
THEN
	SET sqlcommand = "SELECT count(1) as total FROM (SELECT count(1) 
	FROM archive_videos_segment_tags_related vvstr, archive_tags vt, archive_videos av, archive_videos_previews avp WHERE avp.id_video = av.id_video AND vt.id_tag = vvstr.id_tag AND av.id_video = vvstr.id_video AND av.deleted = 0 
	AND FN_GET_ARCHIVE_VIDEOS_INSTREAM_TAGS_GROUPED(vvstr.id_video,vvstr.seconds_in,vvstr.seconds_out,2) like @_tags_group GROUP by vvstr.id_video,vvstr.seconds_in,vvstr.seconds_out) as tt";
	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;
END IF;
        
COMMIT;

END;

