create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_ALBUMS_TAGS(IN _field int(10), IN _query varchar(192),
                                                              IN _filter varchar(192), IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM albums_tags;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_id_album = _filter;
SET @_id_tag = _filter;
SET @_num_x = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_tag, name,name_stripped, public, FN_GET_ASSETS_TAGS_TOTAL_ALBUMS(id_tag) as total FROM albums_tags pt ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 1 AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 0 AND name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag in (SELECT distinct id_tag FROM albums_tags_related) AND name like @_name ");

WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag in (SELECT distinct id_tag FROM albums_tags_related WHERE id_album = @_id_album) AND name like @_name ");

WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name_stripped in (SELECT name_stripped FROM (SELECT count(1) as total,name_stripped FROM albums_tags GROUP BY name_stripped) as tt WHERE total > 1) AND name like @_name ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE (FN_GET_ASSETS_TAGS_TOTAL_ALBUMS(id_tag)) = @_num_x AND name like @_name ");
WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag like @_id_tag ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
        
COMMIT;

END;

