create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_DATES(IN _room varchar(5), IN _id_user int(10), IN _id_directory int,
                                                        IN _field int(10), IN _field_snd int(10), IN _field_trd int(10),
                                                        IN _query varchar(192), IN _filter varchar(192),
                                                        IN _filter_snd varchar(192), IN _filter_trd varchar(192),
                                                        IN _limit_sys_a bigint, IN _limit_sys_b bigint)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @room = _room;
SET @id_user = _id_user;

SET @_id_asset = _filter_snd;
SET @_id_album = _filter_snd;
SET @_room = _filter_snd;
SET @_name = CONCAT("%",_query,"%");
SET @_id_directory = _id_directory;

	SET sqlcommand = "SELECT year(a.created_date) as year, month(a.created_date) as month,count(1) as total FROM assets a WHERE a.deleted = 0  AND year(a.created_date) <> 0 ";

	IF (_room <> '')
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND FN_GET_ASSETS_ASSET_IN_ROOM(a.id_asset,@id_user,@room) = 1 ");
	END IF;

	IF(_id_directory > 0)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND a.id_directory = @_id_directory ");
	END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.id_asset = @_id_asset ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.id_asset in (SELECT distinct id_asset FROM assets_albums_related) ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.id_asset in (SELECT distinct id_asset FROM assets_transfers_related) ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.id_asset in (SELECT distinct id_asset FROM assets_rooms_related) ) ");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.id_asset in (SELECT distinct id_asset FROM assets_rooms_related AND room = @_room) ) ");
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.id_asset in (SELECT distinct id_asset FROM assets_albums_related WHERE id_album = @_id_album) ) ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	IF (_query <> '')
	THEN
		SET sqlcommand =  CONCAT(sqlcommand, " AND a.name like @_name ");
	END IF;

	SET sqlcommand =  CONCAT(sqlcommand, " GROUP BY year,month ORDER by year,month ");

	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;

COMMIT;

END;

