create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_EMBED_RELATED(IN _field int(10), IN _filter varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id = _filter;
SET @_code = _filter;

IF EXISTS (SELECT id FROM assets_embeds WHERE (id = _filter OR code = _filter))
THEN

	SET sqlcommand = "SELECT ae.id,type,variant,code,source_type,source_id,format,ae.name,active,deleted,aeo.id_option,option_name,option_value,option_type FROM assets_embeds ae, assets_embeds_options_related aeor, assets_embeds_options aeo
	WHERE ae.id = aeor.id AND aeo.id_option = aeor.id_option  ";

	CASE
			WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND ae.id = @_id ");
			WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND code = @_code ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " AND ae.id = @_id ");
	END CASE;

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt; 

	ELSE
	    SELECT -2 as return_code;
	END IF;

COMMIT;

END;

