create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_LABELS(IN _field int(10), IN _query varchar(192),
                                                         IN _filter varchar(192), IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM assets_labels;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_id_asset = _filter;
SET @_id_label = _filter;
SET @_num_x = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_label, name,name_stripped, public,FN_GET_ASSETS_LABELS_TOTAL_ASSETS(id_label) as total_assets FROM assets_labels pt ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 1 AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 0 AND name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_label in (SELECT distinct id_label FROM assets_labels_related) AND name like @_name ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_label in (SELECT distinct id_label FROM assets_labels_related WHERE id_asset = @_id_asset) AND name like @_name ");

WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name_stripped in (SELECT name_stripped FROM (SELECT count(1) as total,name_stripped FROM assets_labels GROUP BY name_stripped) as tt WHERE total > 1) AND name like @_name ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE (FN_GET_ASSETS_LABELS_TOTAL_ASSETS(id_label)) = @_num_x AND name like @_name ");
WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_label like @_id_label ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
        
COMMIT;

END;

