create
    definer = skoiypp@`%` procedure SP_GET_LIVE_CHANNELS_BY_COMPOSED(IN _id_composed int)
BEGIN


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS(SELECT id_composed FROM video_composed WHERE id_composed = _id_composed)
THEN 
    SELECT id_channel, management_name,publish_date,begin_date,end_date, domain as domain, default_id_playlist,position, register_date, FN_GET_VIDEO_PLAYLISTS_ON_CHANNELS_NUM(id_channel) as total,FN_GET_VIDEO_CHANNEL_HAS_LIVE_CONTENT(id_channel) as has_live,FN_GET_VIDEO_CHANNEL_HAS_VIDEO_CONTENT(id_channel) as has_vod,state
        FROM channels WHERE id_channel in (SELECT id_channel FROM playlists_channels_related WHERE id_playlist in (SELECT id_playlist FROM video_composed_playlists_related WHERE id_composed = _id_composed));
ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

