create
    definer = skoiypp@`%` procedure SP_GET_LIVE_COMPOSES_ON_PLAYLISTS_COUNT(IN _id_playlist int, IN _field int(10), IN _query varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_playlist = _id_playlist;
SET @_title = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_state = _query;


SET sqlcommand = "SELECT count(1) as total FROM (
SELECT vc.id_composed FROM video_composed vc, video_profiles vp,video_profiles_l10n vpl10n, video_composed_playlists_related vcpr
WHERE vc.id_profile = vp.id_profile AND vp.id_profile = vpl10n.id_profile AND vc.id_composed = vcpr.id_composed AND FN_GET_VIDEO_IS_DELETED(id_video) = 0 AND vcpr.id_playlist = @_id_playlist ";

CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like @_title OR description like @_description OR ((SELECT count(1) FROM video_tags vt, video_profiles_l10n_tags_related vptr WHERE vt.id_tag = vptr.id_tag AND vptr.id_l10n = vpl10n.id_l10n AND name_stripped like @_tags_stripped) > 0)) ");
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like @_title ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND ((SELECT count(1) FROM video_tags vt, video_profiles_l10n_tags_related vptr WHERE vt.id_tag = vptr.id_tag AND vptr.id_l10n = vpl10n.id_l10n AND name_stripped like @_tags_stripped) > 0) ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND vc.state = @_state ");
ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
END CASE;

SET sqlcommand = CONCAT(sqlcommand," GROUP BY vc.id_composed) as tt ");
SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;  

COMMIT;

END;

