create
    definer = skoiypp@`%` procedure SP_GET_LIVE_PLAYLISTS(IN _query varchar(192), IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM playlists;
END IF;

SET @_query = _query;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_playlist, management_name, publish_date, begin_date, end_date, register_date, FN_GET_VIDEO_COMPOSES_ON_PLAYLISTS_NUM(id_playlist) as total,FN_GET_VIDEO_PLAYLIST_HAS_LIVE_CONTENT(id_playlist) as has_live,FN_GET_VIDEO_PLAYLIST_HAS_VIDEO_CONTENT(id_playlist) as has_vod,FN_GET_VIDEO_IS_PLAYLISTS_ON_CHANNEL(id_playlist) as on_channel, state
    FROM playlists "; 

IF(_query <> '')
THEN
   SET @_query = CONCAT("%",_query,"%");
   SET sqlcommand = CONCAT(sqlcommand," WHERE (management_name like @_query) ");
END IF;

SET sqlcommand = CONCAT(sqlcommand," ORDER BY management_name LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;
        
COMMIT;

END;

