create
    definer = skoiypp@`%` procedure SP_GET_LIVE_STICKERS_RELATED(IN _field int(10), IN _query varchar(192),
                                                                 IN _filter varchar(192), IN _limit_a int,
                                                                 IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM video_stickers_related;
END IF;

SET @_title = CONCAT("%",_query,"%");
SET @_id_sticker = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_sticker,vsr.id_composed,vsr.id_playlist,vsr.id_channel,FN_GET_VIDEO_IS_LIVE_COMPOSED(vc.id_composed) as type, vc.id_composed,vc.id_profile,vc.id_video,id_live,FN_GET_VIDEO_DIRECTORY(vc.id_video) as id_directory,FN_GET_VIDEO_THUMBNAIL(vc.id_video) as thumbnail, image,set_thumbnail, title, description, FN_GET_VIDEO_NAME(vc.id_video) as name,FN_GET_VIDEO_SECONDS(vc.id_video) as seconds,vsr.position,vc.state,vsr.state as sticker_state, vsr.begin_date,vsr.end_date,set_thumbnail,set_inside_social,set_autoplay,set_play_inline,set_play_mark,set_webvtt,vcpr.register_date
FROM video_stickers_related vsr, video_composed vc, video_profiles vp,video_profiles_l10n vpl10n, video_composed_playlists_related vcpr
WHERE vc.id_profile = vp.id_profile AND vp.id_profile = vpl10n.id_profile AND vc.id_composed = vcpr.id_composed AND FN_GET_VIDEO_IS_DELETED(id_video) = 0 AND vc.id_composed = vsr.id_composed AND id_sticker = @_id_sticker ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like @_title ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " GROUP BY vc.id_composed ORDER BY vsr.position ASC LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
        
COMMIT;

END;

