create
    definer = skoiypp@`%` procedure SP_GET_POSTS(IN _field int(10), IN _field_snd int(10), IN _field_trd int(10),
                                                 IN _query varchar(192), IN _filter varchar(192),
                                                 IN _filter_snd varchar(192), IN _filter_trd varchar(192),
                                                 IN _limit_sys_a bigint, IN _limit_sys_b bigint,
                                                 IN _iso_lang varchar(10), IN _limit_a int(10), IN _limit_b int(10),
                                                 IN _order int(10), IN _order_by int(10))
BEGIN



DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1 OR _limit_b = 0)
THEN
	IF(_iso_lang = '')
	THEN
		SELECT count(1) into _limit_b FROM posts_l10n;
	ELSE
		SELECT count(1) into _limit_b FROM posts_l10n WHERE iso_language = _iso_lang;
	END IF;
END IF;

SET @_body = CONCAT("%",_query,"%");
SET @_title = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_iso_lang = _iso_lang;

SET @_tags_group = CONCAT("%",_filter_trd,"%");

SET @_filename = CONCAT("%",_filter_snd,"%");
SET @id_album = _filter_snd;
SET @id_asset = _filter_snd;
SET @id_composed = _filter_snd;
SET @id_author = _filter_snd;
SET @id_post = _filter_snd;
SET @id_dossier = _filter_snd;
SET @id_type = _filter_snd;
SET @state = _filter_snd;
SET @label = _filter_snd;
SET @id_label = _filter_snd;
SET @id_tag = _filter_snd;
SET @id_sticker = _filter_snd;

SET @_limit_sys_a = _limit_sys_a;
SET @_limit_sys_b = _limit_sys_b;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET @_year = year(_filter);
SET @_month = month(_filter);

IF(_iso_lang = '')
THEN
	SET sqlcommand = "SELECT id_l10n,id_type,pln.id_post,iso_language,draft,FN_GET_POSTS_L10N_ISO_GROUPED(1,pln.id_post) as iso_grouped,FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n,2) as tags_grouped,headline, title, description,image,image_caption,image_align,0 as id_asset,'' as image_width, '' as image_height,meta_title,meta_description,meta_image,0 as meta_id_asset,meta_url,image_title,image_alter_text,meta_keywords,meta_play_mark,color, publish_date,begin_date,end_date, pln.update_date,p.register_date, state, 0 as position FROM posts_l10n pln, posts p WHERE p.id_post = pln.id_post ";
ELSE
	SET sqlcommand = "SELECT id_l10n,id_type,pln.id_post,iso_language,draft,FN_GET_POSTS_L10N_ISO_GROUPED(1,pln.id_post) as iso_grouped,FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n,2) as tags_grouped,headline, title, description,image,image_caption,image_align,0 as id_asset,'' as image_width, '' as image_height,meta_title,meta_description,meta_image,0 as meta_id_asset,meta_url,image_title,image_alter_text,meta_keywords,meta_play_mark,color, publish_date,begin_date,end_date, pln.update_date,p.register_date, state, 0 as position FROM posts_l10n pln, posts p WHERE p.id_post = pln.id_post AND iso_language = @_iso_lang ";
END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_post = @id_post ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_authors WHERE id_author = @id_author) ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_videos WHERE id_composed = @id_composed) ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND ((id_l10n in (SELECT id_l10n FROM posts_l10n_photos WHERE id_asset = @id_asset) ) OR (FN_GET_ASSETS_ID_BY_FILENAME(image) = @id_asset))");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_albums WHERE id_album = @id_album) ) ");						
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_post in (SELECT id_post FROM posts_dossiers_related WHERE id_dossier = @id_dossier) ) ");
			WHEN _field_snd = 106 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND ((id_l10n in (SELECT id_l10n FROM posts_l10n_photos WHERE id_asset in (SELECT id_asset FROM assets WHERE filename like @_filename))) OR (image like @_filename))");
			WHEN _field_snd = 107 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_tags_related WHERE id_tag = @id_tag) ) ");
			WHEN _field_snd = 108 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_labels_related WHERE id_label = @id_label) ) ");

			WHEN _field_snd = 109 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_authors)) ");
			WHEN _field_snd = 110 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_videos)) ");
			WHEN _field_snd = 111 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_photos)) ");
			WHEN _field_snd = 112 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_albums)) ");						
			WHEN _field_snd = 113 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_tags_related)) ");						
			WHEN _field_snd = 114 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_labels_related) ) ");
			WHEN _field_snd = 115 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_post in (SELECT id_post FROM posts_dossiers_related)) ");
			WHEN _field_snd = 117 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_post in (SELECT id_post FROM posts_stickers_related WHERE id_sticker = @id_sticker) ) ");
			WHEN _field_snd = 118 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_post in (SELECT id_post FROM posts_stickers_related)) ");


			WHEN _field_snd = 209 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n not in (SELECT id_l10n FROM posts_l10n_authors)) ");
			WHEN _field_snd = 210 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n not in (SELECT id_l10n FROM posts_l10n_videos)) ");
			WHEN _field_snd = 211 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n not in (SELECT id_l10n FROM posts_l10n_photos)) ");
			WHEN _field_snd = 212 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n not in (SELECT id_l10n FROM posts_l10n_albums)) ");						
			WHEN _field_snd = 213 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n not in (SELECT id_l10n FROM posts_l10n_tags_related)) ");						
			WHEN _field_snd = 214 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n not in (SELECT id_l10n FROM posts_l10n_labels_related) ) ");
			WHEN _field_snd = 215 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_post not in (SELECT id_post FROM posts_dossiers_related)) ");
			WHEN _field_snd = 216 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_post not in (SELECT id_post FROM posts_stickers_related)) ");

			WHEN _field_snd = 116 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @state ) ");
            WHEN _field_snd = 119 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_type = @id_type ) ");

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	IF (_field_trd = 1000)
	THEN
		SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n,1) like @_tags_group ) ");
	END IF;

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1 OR ((SELECT count(1) FROM posts_tags pt, posts_l10n_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like @_tags_stripped) > 0)) ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like @_title ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(p.register_date) = @_year AND month(p.register_date) = @_month) AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1) ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(p.register_date) = @_year) AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1) ");

WHEN _field = 18 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (begin_date >= from_unixtime(@_limit_sys_a) AND (end_date = '0000-00-00 00:00:00' OR end_date <= from_unixtime(@_limit_sys_b)))  ");
ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ");

CASE

WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY title ASC");
WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY p.register_date ASC");
WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY publish_date ASC");

WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY title DESC");
WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY p.register_date DESC");
WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY publish_date DESC");

ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY p.register_date DESC");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

EXECUTE stmt USING @_limit_a,@_limit_b;
        
COMMIT;

END;

