create
    definer = skoiypp@`%` procedure SP_GET_POSTS_COLLECTIONS_COUNT(IN _field int(10), IN _query varchar(192), IN _filter varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_name = CONCAT("%",_query,"%");
SET @_id_collection = _filter;
SET @_state = _filter;
SET @_id_tag = _filter;

SET sqlcommand = " SELECT count(1) as total FROM collections WHERE 1=1 ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND management_name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND state = @_state AND management_name like @_name ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_collection in (SELECT id_collection FROM dossiers_collections_related WHERE id_dossier = @_id_dossier) ");
WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_collection in (SELECT id_collection FROM dossiers_collections_related WHERE id_dossier in (SELECT id_dossier FROM posts_dossiers_related WHERE id_post = @_id_post)) ");

WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_collection = @_id_collection ");
WHEN _field = 17 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_collection in (SELECT id_collection FROM collections_l10n WHERE id_l10n in (SELECT id_l10n FROM collections_l10n_tags_related WHERE id_tag = @_id_tag) )) ");

ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;  
    
COMMIT;

END;

