create
    definer = skoiypp@`%` procedure SP_GET_POSTS_COLLECTIONS_TAGS(IN _field int(10), IN _query varchar(192),
                                                                  IN _filter varchar(192), IN _limit_a int(10),
                                                                  IN _limit_b int(10), IN _order int(10),
                                                                  IN _order_by int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM collections_tags;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_id_collection = _filter;
SET @_id_tag = _filter;
SET @_num_x = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_tag, name,name_stripped, public, FN_GET_POSTS_TAGS_TOTAL_COLLECTIONS(id_tag) as total,register_date FROM collections_tags pt ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 1 AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 0 AND name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag in (SELECT distinct id_tag FROM collections_l10n_tags_related) AND name like @_name ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag not in (SELECT distinct id_tag FROM collections_l10n_tags_related) AND name like @_name ");

WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag in (SELECT distinct id_tag FROM collections_l10n_tags_related WHERE id_l10n in (SELECT id_l10n FROM collections_l10n WHERE id_collection = @_id_collection)) AND name like @_name ");

WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name_stripped in (SELECT name_stripped FROM (SELECT count(1) as total,name_stripped FROM collections_tags GROUP BY name_stripped) as tt WHERE total > 1) AND name like @_name ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE (FN_GET_POSTS_TAGS_TOTAL_COLLECTIONS(id_tag)) = @_num_x AND name like @_name ");
WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag like @_id_tag ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

CASE
WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC");
WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date ASC");
WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total ASC");

WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name DESC");
WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total DESC");

ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
        
COMMIT;

END;

