create
    definer = skoiypp@`%` procedure SP_GET_POSTS_DOSSIERS_ON_COLLECTION_COUNT(IN _id_collection int(10),
                                                                              IN _field int(10), IN _query varchar(192),
                                                                              IN _filter varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
  SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_collection = _id_collection;

SET @_name = CONCAT("%",_query,"%");
SET @_id_dossier = _filter;
SET @_state = _filter;

SET sqlcommand = "SELECT count(1) as total 
    FROM dossiers WHERE id_dossier in (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection = @_id_collection) "; 

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND management_name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND state = @_state AND management_name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_POSTS_IS_DOSSIERS_ON_COLLECTION(id_dossier) = 1 AND management_name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_POSTS_IS_DOSSIERS_ON_COLLECTION(id_dossier) = 0 AND management_name like @_name ");

WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_dossier like @_id_dossier ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;  
    
COMMIT;

END;

