create
    definer = skoiypp@`%` procedure SP_GET_POSTS_L10N_BODY(IN _id_l10n INT(10), IN _field int(10),
                                                           IN _query varchar(192), IN _filter varchar(192))
BEGIN

-- call SP_GET_POSTS_L10N_BODY(412,6,"",0)

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS(SELECT id_l10n FROM posts_l10n_body WHERE id_l10n = _id_l10n)
THEN

SET @_body = CONCAT("%",_query,"%");
SET @_id_l10n = _id_l10n;
SET @_restricted = _filter;
SET @_draft = _filter;
SET @_block_type = _filter;

SET sqlcommand = "SELECT id_body,id_l10n,body, position, settings, restricted,draft,block_type,update_date,register_date FROM posts_l10n_body WHERE id_l10n = @_id_l10n ";

	CASE
		WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND body like @_body ");
		WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND restricted = @_restricted ");
		WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND draft = @_draft ");
		WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND block_type = @_block_type ");
		WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND block_type <> @_block_type ");
        WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND lcase(block_type) not in ('figure','embed','sbs') ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, "");
	END CASE;

SET sqlcommand = CONCAT(sqlcommand, " ORDER by position");    
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;    

ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

