create
    definer = skoiypp@`%` procedure SP_GET_POSTS_STICKERS_RELATED(IN _field int(10), IN _field_snd int(10),
                                                                  IN _field_trd int(10), IN _query varchar(192),
                                                                  IN _filter varchar(192), IN _filter_snd varchar(192),
                                                                  IN _filter_trd varchar(192), IN _order int(10),
                                                                  IN _order_by int(10), IN _limit_a int(10),
                                                                  IN _limit_b int(10))
BEGIN

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM posts_stickers_related;
END IF;

SET @_title = CONCAT("%",_query,"%");
SET @_id_sticker = _filter;
SET @_id_post = _filter;

SET @id_post = _filter_snd;
SET @state = _filter_snd;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

IF(_field = 1000)
THEN
	SET sqlcommand = "SELECT distinct psr.id_sticker,ps.name,ps.name_stripped,FN_GET_POSTS_STICKERS_TOTAL_ITEMS(ps.id_sticker) as total,psr.id_post,'' as title,'' as description,'' as image,'' as image_align,psr.begin_date,psr.end_date,psr.state,psr.position,psr.register_date
	FROM posts_stickers_related psr, posts_l10n pl10n, posts_stickers ps WHERE psr.id_post = pl10n.id_post AND ps.id_sticker = psr.id_sticker AND psr.id_post = @_id_post ";
ELSE
    SET sqlcommand = "SELECT psr.id_sticker,ps.name,ps.name_stripped,FN_GET_POSTS_STICKERS_TOTAL_ITEMS(ps.id_sticker) as total,psr.id_post,pl10n.title,pl10n.description,pl10n.image,pl10n.image_align,psr.begin_date,psr.end_date,psr.state,psr.position,psr.register_date
	FROM posts_stickers_related psr, posts_l10n pl10n, posts_stickers ps WHERE psr.id_post = pl10n.id_post AND ps.id_sticker = psr.id_sticker AND ps.id_sticker = @_id_sticker ";
END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (psr.id_post = @id_post ) ");
			WHEN _field_snd = 116 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (psr.state = @state ) ");

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;


CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND pl10n.title like @_title ");

ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

IF(_field = 1000)
THEN
	SET sqlcommand = CONCAT(sqlcommand, " ORDER BY psr.position ASC LIMIT ?,?");
ELSE
	SET sqlcommand = CONCAT(sqlcommand, " GROUP BY pl10n.id_post ORDER BY psr.position ASC LIMIT ?,?");
END IF;

SET @sqlcommand = sqlcommand;   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
        
COMMIT;

END;

