create
    definer = skoiypp@`%` procedure SP_GET_POSTS_TAGS(IN _field int(10), IN _query varchar(192), IN _limit_a int,
                                                      IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM posts_tags;
END IF;

SET @_query = CONCAT("%",_query,"%");
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_tag, name,name_stripped, public, (SELECT count(1) FROM posts_tags_related WHERE id_tag = pt.id_tag) as total FROM posts_tags pt ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like ? ORDER BY name LIMIT ?,?");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 1 AND name like ? ORDER BY name LIMIT ?,?");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 0 AND name like ? ORDER BY name LIMIT ?,?");
ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name LIMIT ?,?");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
 
CASE
WHEN _field = 1 THEN
EXECUTE stmt USING @_query,@_limit_a,@_limit_b;
WHEN _field = 2 THEN
EXECUTE stmt USING @_query,@_limit_a,@_limit_b;
WHEN _field = 3 THEN
EXECUTE stmt USING @_query,@_limit_a,@_limit_b;
ELSE 
EXECUTE stmt USING @_limit_a,@_limit_b;    
END CASE;    
        
COMMIT;

END;

