create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_POSTS()
BEGIN

DECLARE _last_publish DATETIME;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(SELECT count(1) FROM posts_publish_log WHERE date(end_publish_date) <> '0000-00-00')
THEN
	SELECT end_publish_date into _last_publish FROM posts_publish_log WHERE date(end_publish_date) <> '0000-00-00' ORDER by id_publish desc LIMIT 0,1;
ELSE
	SET _last_publish = '0000-00-00 00:00:00';
END IF;




SELECT 1 as type,1 as action_type,p.id_post as id, id_sync,id_rev_sync, p.update_date, p.register_date FROM posts p, posts_l10n pl10n WHERE pl10n.id_post = p.id_post AND id_sync = '' AND pl10n.state = 5
UNION 
SELECT 2 as type,1 as action_type,id_dossier as id, id_sync,id_rev_sync, update_date, register_date FROM dossiers WHERE id_sync = '' AND id_dossier in (SELECT id_dossier FROM dossiers_collections_related)
UNION 
SELECT 3 as type,1 as action_type,id_collection as id, id_sync,id_rev_sync, update_date, register_date FROM collections WHERE id_sync = ''




UNION 
SELECT 1 as type,3 as action_type,id_post as id, id_sync,id_rev_sync,'','' FROM posts_sync_deleted WHERE register_date > _last_publish AND id_post > 0 AND last_sync_date = '0000-00-00 00:00:00'
UNION 
SELECT 2 as type,3 as action_type,id_dossier as id, id_sync,id_rev_sync,'','' FROM posts_sync_deleted WHERE register_date > _last_publish AND id_dossier > 0 AND last_sync_date = '0000-00-00 00:00:00'
UNION 
SELECT 3 as type,3 as action_type,id_collection as id, id_sync,id_rev_sync,'','' FROM posts_sync_deleted WHERE register_date > _last_publish AND id_collection > 0 AND last_sync_date = '0000-00-00 00:00:00'
    


UNION
SELECT 1 as type,action_type,p.id_post as id, p.id_sync,p.id_rev_sync, p.update_date, p.register_date FROM posts p, posts_l10n pl10n,posts_sync_updated psy WHERE psy.id_post = p.id_post AND pl10n.id_post = p.id_post
UNION
SELECT 2 as type,action_type,d.id_dossier as id, d.id_sync,d.id_rev_sync, d.update_date, d.register_date FROM dossiers d, posts_sync_updated psy WHERE psy.id_dossier = d.id_dossier
UNION
SELECT 3 as type,action_type,c.id_collection as id, c.id_sync,c.id_rev_sync, c.update_date, c.register_date FROM collections c, posts_sync_updated psy WHERE psy.id_collection = c.id_collection;


DELETE FROM posts_sync_updated;

COMMIT;

END;

