create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_POSTS_AUTHORS(IN _id_collection int(10), IN _iso_lang varchar(10))
BEGIN


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SELECT pa.id_author,name,email,photo,website,facebook,twitter,linkedin,instagram,skype,
(SELECT role FROM posts_authors_l10n WHERE id_author = pa.id_author AND iso_language = _iso_lang) as role,
(SELECT biography FROM posts_authors_l10n WHERE id_author = pa.id_author AND iso_language = _iso_lang) as biography,
pa.register_date,
(SELECT count(1) as total FROM posts_l10n_authors pla WHERE id_author = pa.id_author AND id_l10n in (SELECT id_l10n FROM posts_dossiers_related pdr, posts_l10n pn WHERE pn.id_post = pdr.id_post AND id_dossier in (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection = _id_collection)
AND pn.iso_language = _iso_lang AND state = 5)) as total FROM posts_authors pa
WHERE pa.id_author in (SELECT id_author FROM posts_l10n_authors WHERE id_l10n in (SELECT id_l10n FROM posts_dossiers_related pdr, posts_l10n pn WHERE pn.id_post = pdr.id_post AND id_dossier in (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection = _id_collection)
AND pn.iso_language = _iso_lang AND state = 5)) order by name;

COMMIT;

END;

