create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_POSTS_SEARCH_COUNT(IN _id_collection int(10), IN _id_dossier int(10),
                                                                      IN _field int(10), IN _query varchar(192),
                                                                      IN _filter varchar(192), IN _iso_lang varchar(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_collection = _id_collection;
SET @_id_dossier = _id_dossier;

SET @_title = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_iso_lang = _iso_lang;

SET @_year = year(_filter);
SET @_month = month(_filter);

IF EXISTS(SELECT id_collection FROM collections WHERE id_collection = _id_collection)
THEN

	IF(_id_dossier = -1)
	THEN
		SET sqlcommand = "SELECT count(1) as total FROM posts_l10n pln, posts_dossiers_related pdr, dossiers_collections_related dcr
WHERE pdr.id_post = pln.id_post AND pdr.id_dossier = dcr.id_dossier AND dcr.id_collection = ? AND iso_language = ? AND state = 5 ";
	ELSE
		SET sqlcommand = "SELECT count(1) as total FROM posts_l10n pln, posts_dossiers_related pdr, dossiers_collections_related dcr
WHERE pdr.id_post = pln.id_post AND pdr.id_dossier = dcr.id_dossier AND dcr.id_collection = ? AND iso_language = ? AND dcr.id_dossier = ? AND state = 5 ";
	END IF;


	CASE
	WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like ? OR description like ? OR ((SELECT count(1) FROM posts_tags pt, posts_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like ?) > 0)) ");
	WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like ? ");
	WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like ? ");
	WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n) like ?) AND (title like ? OR description like ?) ");
	WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(pln.register_date) = ? AND month(pln.register_date) = ?) AND (title like ? OR description like ?) ");
	WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(pln.register_date) = ?) AND (title like ? OR description like ?) ");
	WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like ? OR description like ?) ");
	WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND pln.id_l10n in (SELECT id_l10n FROM posts_l10n_authors WHERE id_author = ?) AND (title like ? OR description like ?)");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
	END CASE;

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;

	IF(_id_dossier = -1)
	THEN
		CASE
		WHEN _field = 0 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_title,@_description,@_tags_stripped;
		WHEN _field = 1 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_title;
		WHEN _field = 2 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_description;
		WHEN _field = 3 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_filter,@_title,@_description;
		WHEN _field = 4 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_year,@_month,@_title,@_description;
		WHEN _field = 5 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_year,@_title,@_description;
		WHEN _field = 6 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_title,@_description;
		WHEN _field = 7 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_cfilter,@_title,@_description;
		ELSE 
		EXECUTE stmt USING @_id_collection,@_iso_lang;    
		END CASE;    
	ELSE
		CASE
		WHEN _field = 0 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_title,@_description,@_tags_stripped;
		WHEN _field = 1 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_title;
		WHEN _field = 2 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_description;
		WHEN _field = 3 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_filter,@_title,@_description;
		WHEN _field = 4 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_year,@_month,@_title,@_description;
		WHEN _field = 5 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_year,@_title,@_description;
		WHEN _field = 6 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_title,@_description;
		WHEN _field = 7 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_cfilter,@_title,@_description;
		ELSE 
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier;    
		END CASE;  
	END IF;

ELSE
	SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

