create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_POSTS_STICKER_FEED_SOURCES(IN _id_sticker INT(10))
BEGIN

DECLARE _source_type INT;
DECLARE _auto_feed_order INT;
DECLARE _maximum_items INT;
DECLARE _active INT;
DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS (SELECT id_sticker FROM posts_stickers WHERE id_sticker = _id_sticker)
THEN

SELECT auto_feed_order,active,maximum_items into _auto_feed_order,_active,_maximum_items FROM posts_stickers WHERE id_sticker = _id_sticker AND active = 1 LIMIT 0,1;
SELECT source_type into _source_type FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker AND _active = 1 LIMIT 0,1;

SET @_id_Sticker = _id_sticker;
SET @_maximum_items = _maximum_items;

IF(_source_type = 1)
THEN
	
    SET @rownum=0;
	SET sqlcommand = "SELECT distinct id_post as id,@rownum:=@rownum+1 as position FROM posts_l10n WHERE state = 5 AND id_post in 
	(SELECT id_post FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker)";

END IF;

IF(_source_type = 10)
THEN
	
    SET @rownum=0;
	SET sqlcommand = "SELECT distinct id_post as id,@rownum:=@rownum+1 as position FROM posts_l10n WHERE state = 5 AND id_post in
	(SELECT id_post FROM posts_l10n WHERE id_l10n in 
	(SELECT id_l10n FROM posts_l10n_tags_related WHERE id_tag in 
	(SELECT id_tag FROM posts_tags WHERE id_tag in (SELECT id_post_tag FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker)
	)))";

END IF;

IF(_source_type = 2)
THEN
	
    SET @rownum=0;
	SET sqlcommand = "SELECT distinct id_post as id,@rownum:=@rownum+1 as position FROM posts_l10n WHERE state = 5 AND id_post in
	(SELECT id_post FROM posts_dossiers_related WHERE id_dossier in
	(SELECT id_dossier FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker))";

END IF;

IF(_source_type = 20)
THEN
	
    SET @rownum=0;
	SET sqlcommand = "SELECT distinct id_post as id,@rownum:=@rownum+1 as position FROM posts_l10n WHERE state = 5 AND id_post in
	(SELECT id_post FROM posts_dossiers_related WHERE id_dossier in
    (SELECT id_dossier FROM dossiers_l10n WHERE id_l10n in
    (SELECT id_l10n FROM dossiers_l10n_tags_related WHERE id_tag in
    (SELECT id_dossier_tag FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker)
    )))";
    
END IF;

IF(_source_type = 3)
THEN
	
	SET @rownum=0;
	SET sqlcommand = "SELECT distinct id_post as id,@rownum:=@rownum+1 as position FROM posts_l10n WHERE state = 5 AND id_post in 
	(SELECT id_post FROM posts_dossiers_related WHERE id_dossier in
    (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection in
    (SELECT id_collection FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker)
    ))";
    
END IF;

IF(_source_type = 30)
THEN
	
    SET @rownum=0;
	SET sqlcommand = "SELECT distinct id_post as id,@rownum:=@rownum+1 as position FROM posts_l10n WHERE state = 5 AND id_post in 
	(SELECT id_post FROM posts_dossiers_related WHERE id_dossier in
    (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection in
    (SELECT id_collection FROM collections_l10n WHERE  id_l10n in
    (SELECT id_l10n FROM collections_l10n_tags_related WHERE id_tag in
    (SELECT id_collection_tag FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker)
    ))))";

END IF;

IF(_source_type = 4)
THEN
	
    SET @rownum=0;
	SET sqlcommand = "SELECT distinct id_post as id,@rownum:=@rownum+1 as position FROM posts_l10n WHERE state = 5 AND id_post in
	(SELECT id_post FROM posts_l10n WHERE id_l10n in 
	(SELECT id_l10n FROM posts_l10n_authors WHERE id_author in 
	(SELECT id_author FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker)
	))";

END IF;

IF(_source_type is null OR _source_type not in (1,10,2,20,3,30,4))
THEN
	SELECT '' as id FROM posts_stickers_feeds_sources WHERE 0=1;
ELSE

SET sqlcommand = CONCAT(sqlcommand, " GROUP by id ");

CASE

WHEN _auto_feed_order = 11 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY title ASC");
WHEN _auto_feed_order = 3 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY publish_date DESC");

ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY publish_date DESC");
END CASE;


SET sqlcommand = CONCAT(sqlcommand, " LIMIT 0,?");
SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_maximum_items;

END IF;

ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

