create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_VIDEO_LATEST(IN _id_channel INT, IN _id_playlist INT)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_channel = _id_channel;
SET @_id_playlist = _id_playlist;


SET sqlcommand = "SELECT vc.id_composed,vc.id_profile,vc.id_video,id_directory,FN_GET_VIDEO_THUMBNAIL(vc.id_video) as thumbnail, image,publish_date,begin_date,end_date,set_thumbnail,set_inside_social,set_autoplay,set_play_inline,set_play_mark,vc.register_date, title, description, name,seconds,vc.state, 0 as is_live 
FROM video_composed vc, videos v, video_profiles vp, video_composed_playlists_related cvpr
WHERE cvpr.id_composed = vc.id_composed AND vc.id_video = v.id_video AND vc.id_profile = vp.id_profile AND vc.state = 5 ";

IF(_id_channel <> -1)
THEN
    SET sqlcommand = CONCAT(sqlcommand," AND id_playlist in (SELECT id_playlist FROM playlists_channels_related WHERE id_channel = ?) ");
END IF;

IF(_id_playlist <> -1)
THEN
    SET sqlcommand = CONCAT(sqlcommand," AND id_playlist = ? ");
END IF;

	SET sqlcommand = CONCAT(sqlcommand," ORDER BY cvpr.position");

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

CASE
WHEN _id_channel <> -1 AND _id_playlist = -1 THEN
EXECUTE stmt USING @_id_channel;
WHEN _id_channel = -1 AND _id_playlist <> -1 THEN
EXECUTE stmt USING @_id_playlist;
WHEN _id_channel <> -1 AND _id_playlist <> -1 THEN
EXECUTE stmt USING @_id_channel,@_id_playlist;
ELSE 
EXECUTE stmt;    
END CASE; 

COMMIT;

END;

