create
    definer = skoiypp@`%` procedure SP_GET_TASK_ARCHIVE_VIDEO_PREVIEW_TO_PROCESS(IN _field int, IN _machine varchar(255))
BEGIN

DECLARE _id_queue INT;
DECLARE _id_account INT;
DECLARE _account_token varchar(255);
DECLARE _id_video INT;
DECLARE _output_path varchar(255);
DECLARE _command text;
DECLARE _video VARCHAR(255);

DECLARE _total_running INT;
DECLARE _max_running INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET _max_running = 3;

 SELECT id_queue, id_account, account_token, output_path, id_video, video,command into _id_queue, _id_account, _account_token, _output_path, _id_video, _video,_command FROM 
 archive_preview_video_queue WHERE is_running = 0 AND _total_running < _max_running ORDER BY attempts,first_try, register_date LIMIT 0,1;
 UPDATE archive_preview_video_queue SET is_running = 1, start = now(), attempts = attempts+1 WHERE id_queue = _id_queue;
 UPDATE archive_preview_video_queue SET first_try = now() WHERE id_queue = _id_queue AND attempts = 1;
 UPDATE archive_preview_video_queue SET machine = _machine WHERE id_queue = _id_queue;

	IF(_id_queue > 0)
	THEN
		SELECT _id_queue as id_queue, _id_account as id_account, _account_token as account_token, _output_path as output_path, _id_video as id_video, _video as video,_command as command;
	ELSE
		SELECT -2 as return_code;
	END IF;
    	        
COMMIT;

END;

