create
    definer = skoiypp@`%` procedure SP_GET_TASK_LIVE_CREATE_CLIP_TO_PROCESS(IN _field int, IN _machine varchar(255))
BEGIN

DECLARE _id_queue INT;
DECLARE _id_account INT;
DECLARE _account_token varchar(255);
DECLARE _command text;
DECLARE _server varchar(255);
DECLARE _application varchar(255);
DECLARE _stream varchar(255);
DECLARE _converter_start_time bigint(20);
DECLARE _converter_end_time bigint(20);
DECLARE _converter_duration bigint(20);
DECLARE _converter_time_type varchar(192);
DECLARE _converter_tolerance int(10);
DECLARE _converter_output_filename varchar(192);
DECLARE _converter_interleave_delay int(10);
DECLARE _converter_debug_conversions tinyint(1);
DECLARE _converter_default_file_destination varchar(192);
DECLARE _state varchar(192);
DECLARE _status_code varchar(192);
DECLARE _video_name varchar(255);
DECLARE _version varchar(255);
DECLARE _download varchar(255);
DECLARE _dvr_start_time bigint(20);


START TRANSACTION;

 SELECT id_queue, id_account,account_token,command,server,application,stream,converter_start_time,converter_end_time,converter_duration,converter_time_type,
converter_tolerance,converter_output_filename,converter_interleave_delay,converter_debug_conversions,converter_default_file_destination,state,status_code,video_name,version,download,dvr_start_time
into _id_queue, _id_account,_account_token,_command,_server,_application,_stream,_converter_start_time,_converter_end_time,_converter_duration,_converter_time_type,
_converter_tolerance,_converter_output_filename,_converter_interleave_delay,_converter_debug_conversions,_converter_default_file_destination,_state,_status_code,_video_name,_version,_download,_dvr_start_time
 FROM live_create_clip_queue WHERE is_running = 0 ORDER by version DESC LIMIT 0,1;

 UPDATE live_create_clip_queue SET is_running = 1, start = now(), attempts = attempts+1 WHERE id_queue = _id_queue;
 UPDATE live_create_clip_queue SET first_try = now() WHERE id_queue = _id_queue AND attempts = 1;
 UPDATE live_create_clip_queue SET machine = _machine WHERE id_queue = _id_queue;

	IF(_id_queue > 0)
	THEN
		SELECT _id_queue as id_queue, _id_account as id_account, _account_token as account_token, _command as command, _server as server,_application as application,_stream as stream,_converter_start_time as converter_start_time,_converter_end_time as converter_end_time,_converter_duration as converter_duration,_converter_time_type as converter_time_type,
_converter_tolerance as converter_tolerance,_converter_output_filename as converter_output_filename,_converter_interleave_delay as converter_interleave_delay,_converter_debug_conversions as converter_debug_conversions,_converter_default_file_destination as converter_default_file_destination,_state as state,_status_code as status_code, _video_name as video_name,
_version as version,_download as download, _dvr_start_time as dvr_start_time;
	ELSE
		SELECT -2 as return_code;
	END IF;
    	        
COMMIT;

END;

