create
    definer = skoiypp@`%` procedure SP_GET_VIDEO_COMPOSES(IN _id_directory int, IN _field int(10),
                                                          IN _field_snd int(10), IN _field_trd int(10),
                                                          IN _query varchar(192), IN _filter varchar(192),
                                                          IN _filter_snd varchar(192), IN _filter_trd varchar(192),
                                                          IN _limit_sys_a bigint, IN _limit_sys_b bigint,
                                                          IN _iso_lang varchar(10), IN _limit_a int(10),
                                                          IN _limit_b int(10), IN _order int(10), IN _order_by int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM video_composed;
	SET @_limit_b = _limit_b;
END IF;

SET @_id_directory = _id_directory;
SET @_title = CONCAT("%",_query,"%");
SET @_name = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;
SET @_tags_stripped = CONCAT("%",_query,"%");


SET @_tags_group = REPLACE(_filter_trd,'%','');

SET @id_video = _filter_snd;
SET @id_profile = _filter_snd;
SET @id_composed = _filter_snd;
SET @id_playlist = _filter_snd;
SET @state = _filter_snd;
SET @label = _filter_snd;
SET @id_label = _filter_snd;

SET @_limit_sys_a = _limit_sys_a;
SET @_limit_sys_b = _limit_sys_b;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET @_year = year(_filter);
SET @_month = month(_filter);

IF(_id_directory) > 0
THEN
	SET sqlcommand = "SELECT FN_GET_VIDEO_IS_LIVE_COMPOSED(vc.id_composed) as type,vc.id_composed,vc.id_profile,vc.id_video,id_live,id_directory,FN_GET_VIDEO_THUMBNAIL(vc.id_video) as thumbnail, image,publish_date,unpublish_date,begin_date,end_date,color,os_graphics_image,os_graphics_position,os_graphics_size,os_graphics_padding,set_thumbnail,set_inside_social,set_autoplay,set_play_inline,set_play_mark,set_webvtt,vc.register_date, title, description, name,seconds,vc.state,FN_GET_VIDEO_IS_COMPOSED_ON_STICKERS(vc.id_composed) as on_sticker
FROM video_composed vc, videos v, video_profiles vp, video_profiles_l10n vpl10n
WHERE vc.id_video = v.id_video AND vpl10n.id_profile = vp.id_profile AND vc.id_profile = vpl10n.id_profile AND id_directory = @_id_directory AND v.deleted = 0 ";
ELSE
	SET sqlcommand = "SELECT FN_GET_VIDEO_IS_LIVE_COMPOSED(vc.id_composed) as type,vc.id_composed,vc.id_profile,vc.id_video,id_live,id_directory,FN_GET_VIDEO_THUMBNAIL(vc.id_video) as thumbnail, image,publish_date,unpublish_date,begin_date,end_date,color,os_graphics_image,os_graphics_position,os_graphics_size,os_graphics_padding,set_thumbnail,set_inside_social,set_autoplay,set_play_inline,set_play_mark,set_webvtt,vc.register_date, title, description, name,seconds,vc.state,FN_GET_LIVE_IS_COMPOSED_ON_STICKERS(vc.id_composed) as on_sticker
FROM video_composed vc, videos v, video_profiles vp, video_profiles_l10n vpl10n
WHERE vc.id_video = v.id_video AND vpl10n.id_profile = vp.id_profile AND vc.id_profile = vpl10n.id_profile AND v.deleted = 0 ";
END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (vc.id_composed = @id_composed ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (vc.id_composed in (SELECT id_composed FROM video_composed WHERE id_video = @id_video) ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (vc.id_composed in (SELECT id_composed FROM video_composed WHERE id_profile = @id_profile) ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (vc.id_composed in (SELECT id_composed FROM video_composed_playlists_related WHERE id_playlist = @id_playlist) ) ");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @state ) ");
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (vc.id_composed in (SELECT id_composed FROM video_composed_playlists_related) ) ");

			WHEN _field_snd = 106 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (vc.id_composed in (SELECT id_composed FROM video_composed_labels_related) ) ");
			WHEN _field_snd = 107 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (vc.id_composed in (SELECT id_composed FROM video_composed_labels_related WHERE (id_label = @id_label OR id_label in (SELECT id_label FROM video_labels WHERE name_stripped = @label)) )) ");

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	IF (_field_trd = 1000)
	THEN
		
 		SET sqlcommand =  CONCAT(sqlcommand, " AND vpl10n.id_profile in ( SELECT id_profile FROM video_profiles_l10n WHERE id_l10n in (SELECT id_l10n FROM video_profiles_l10n_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) )) ");       
	END IF;

CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like @_title OR description like @_description OR name like @_name OR ((SELECT count(1) FROM video_tags vt, video_profiles_l10n_tags_related vptr WHERE vt.id_tag = vptr.id_tag AND vptr.id_l10n = vpl10n.id_l10n AND name_stripped like @_tags_stripped) > 0)) ");
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like @_title ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(vc.register_date) = @_year AND month(vc.register_date) = @_month) AND (title like @_title OR description like @_description OR name like @_name ) ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(vc.register_date) = @_year) AND (title like @_title OR description like @_description OR name like @_name ) ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_GET_VIDEO_PROFILE_TAGS_GROUPED(vp.id_profile) like @_filter) AND (title like @_title OR description like @_description OR name like @_name) ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND vc.state = @_cfilter AND (title like @_title OR description like @_description OR name like @_name ) ");
WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (height like @_filter) AND (title like @_title OR description like @_description OR name like @_name) ");
WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ratio like @_filter) AND (title like @_title OR description like @_description OR name like @_name) ");
WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (mime_type like @_filter) AND (title like @_title OR description like @_description OR name like @_name) ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (size BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (title like @_title OR description like @_description OR name like @_name ) ");
WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (seconds BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (title like @_title OR description like @_description OR name like @_name ) ");
WHEN _field = 12 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (bitrate BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (title like @_title OR description like @_description OR name like @_name ) ");
WHEN _field = 13 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND vc.id_composed in (SELECT id_composed FROM ads_campaigns_video_composed_related WHERE roll_in = 1) AND (title like @_title OR description like @_description OR name like @_name ) ");
WHEN _field = 14 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND vc.id_composed in (SELECT id_composed FROM ads_campaigns_video_composed_related) AND (title like @_title OR description like @_description OR name like @_name ) ");
WHEN _field = 15 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND vc.id_composed in (SELECT id_composed FROM ads_campaigns_video_composed_related WHERE roll_in = 3) AND (title like @_title OR description like @_description OR name like @_name ) ");
WHEN _field = 16 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND vc.id_composed in (SELECT id_composed FROM ads_campaigns_video_composed_related WHERE roll_in = 2) AND (title like @_title OR description like @_description OR name like @_name ) ");

WHEN _field = 17 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (publish_date >= from_unixtime(@_limit_sys_a) AND (unpublish_date = '0000-00-00 00:00:00' OR unpublish_date <= from_unixtime(@_limit_sys_b)))  ");
WHEN _field = 18 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (begin_date >= from_unixtime(@_limit_sys_a) AND (end_date = '0000-00-00 00:00:00' OR end_date <= from_unixtime(@_limit_sys_b)))  ");

ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1  ");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " AND FN_GET_VIDEO_IS_LIVE_PROFILE(vp.id_profile) = 0 ");
SET sqlcommand = CONCAT(sqlcommand," GROUP BY vc.id_composed ");

CASE

WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY title ASC");
WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY vc.register_date ASC");
WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY vc.publish_date ASC");
WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY vc.unpublish_date ASC");

WHEN _order_by = 10000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY title DESC");
WHEN _order_by = 10001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY vc.register_date DESC");
WHEN _order_by = 10002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY vc.publish_date DESC");
WHEN _order_by = 10003 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY vc.unpublish_date DESC");

ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY vc.register_date DESC");
END CASE;


 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b; 

COMMIT;

END;

