create
    definer = skoiypp@`%` procedure SP_GET_VIDEO_COMPOSES_ON_PLAYLISTS(IN _id_playlist int, IN _field int(10),
                                                                       IN _query varchar(192), IN _order tinyint,
                                                                       IN _order_by tinyint, IN _limit_a int,
                                                                       IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM video_composed_playlists_related WHERE id_playlist = _id_playlist;
	SET @_limit_b = _limit_b;
END IF;

SET @_id_playlist = _id_playlist;
SET @_title = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_state = _query;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT FN_GET_VIDEO_IS_LIVE_COMPOSED(vc.id_composed) as type, vc.id_composed,vc.id_profile,vc.id_video,id_live,FN_GET_VIDEO_DIRECTORY(vc.id_video) as id_directory,FN_GET_VIDEO_THUMBNAIL(vc.id_video) as thumbnail, image,set_thumbnail, title, description, FN_GET_VIDEO_NAME(vc.id_video) as name,FN_GET_VIDEO_SECONDS(vc.id_video) as seconds,position,vc.state,FN_GET_VIDEO_IS_COMPOSED_ON_STICKERS(vc.id_composed) as on_sticker,publish_date,unpublish_date, begin_date,end_date,color,os_graphics_image,os_graphics_position,os_graphics_size,os_graphics_padding,set_thumbnail,set_inside_social,set_autoplay,set_play_inline,set_play_mark,set_webvtt,vcpr.register_date
FROM video_composed vc, video_profiles vp,video_profiles_l10n vpl10n, video_composed_playlists_related vcpr
WHERE vc.id_profile = vp.id_profile AND vp.id_profile = vpl10n.id_profile AND vc.id_composed = vcpr.id_composed AND FN_GET_VIDEO_IS_DELETED(id_video) = 0 AND vcpr.id_playlist = @_id_playlist ";

CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like @_title OR description like @_description OR ((SELECT count(1) FROM video_tags vt, video_profiles_l10n_tags_related vptr WHERE vt.id_tag = vptr.id_tag AND vptr.id_l10n = vpl10n.id_l10n AND name_stripped like @_tags_stripped) > 0)) ");
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like @_title ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND ((SELECT count(1) FROM video_tags vt, video_profiles_l10n_tags_related vptr WHERE vt.id_tag = vptr.id_tag AND vptr.id_l10n = vpl10n.id_l10n AND name_stripped like @_tags_stripped) > 0) ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND vc.state = @_state ");
ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
END CASE;

 SET sqlcommand = CONCAT(sqlcommand," GROUP BY id_composed ");

CASE
WHEN _order_by = 1 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY title ASC");
WHEN _order_by = 2 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY vcpr.register_date ASC");
WHEN _order_by = 3 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY vc.publish_date ASC");
WHEN _order_by = 4 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY vc.unpublish_date ASC");

WHEN _order_by = 1 AND _order = 2 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY title DESC");
WHEN _order_by = 2 AND _order = 2 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY vcpr.register_date DESC");
WHEN _order_by = 3 AND _order = 2 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY vc.publish_date DESC");
WHEN _order_by = 4 AND _order = 2 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY vc.unpublish_date DESC");
ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY vcpr.position DESC");
END CASE;

 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;  

COMMIT;

END;

