create
    definer = skoiypp@`%` procedure SP_GET_VIDEO_EMBEDS(IN _field int(10), IN _query varchar(192),
                                                        IN _filter varchar(192), IN _limit_a int(10),
                                                        IN _limit_b int(10), IN _order_by int(10), IN _order int(10))
BEGIN
-- call SP_GET_VIDEO_EMBEDS(0,0,1,0,10,0,0)
DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF(_limit_b = -1)
THEN
	  SELECT count(1) into _limit_b FROM video_embeds;
END IF;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET @_id = _filter;
SET @_code = _filter;
SET @_id_composed = _filter;

SET @_format = _filter;

	SET sqlcommand = "SELECT id,code,source_type,source_id,format,type,variant,name,active,update_date,register_date FROM video_embeds WHERE deleted = 0 ";

	CASE
			WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id = @_id ");
			WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND code = @_code ");
			WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND format = @_format ");
      WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id in (SELECT id FROM video_embeds_video_composed_related WHERE id_composed = @_id_composed) ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
	END CASE;

		CASE
			WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY name ASC ");
			WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date ASC ");
			WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY format ASC ");
			WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY active ASC ");

			WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY name DESC ");
			WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date DESC ");
			WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY format DESC ");
			WHEN _order_by = 11003 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY active DESC ");

		ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC  ");
		END CASE;

	SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b; 

COMMIT;

END;

