create
    definer = skoiypp@`%` procedure SP_RULE_MAP_VIDEO(IN _id_video INT, IN _id_playlist INT, OUT _result INT)
BEGIN

DECLARE _idComposed INT;
DECLARE _idProfile INT;

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_name varchar(255);
DECLARE c_seconds INT;
DECLARE c_id_video INT;

DECLARE cursor_loader CURSOR FOR SELECT id_video,name,seconds FROM videos WHERE deleted = 0 AND id_video = _id_video AND id_video not in (SELECT id_video FROM video_composed WHERE id_video is not null);

DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SET _result = -1; -- SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

 -- cursor
   
    OPEN cursor_loader;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_loader INTO c_id_video,c_name,c_seconds;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	-- do the work
    
		INSERT into video_profiles(register_date) VALUES(now());
		SET _idProfile = last_insert_id();
        INSERT into video_profiles_l10n(id_profile,iso_language,title,meta_title,register_date) VALUES(_idProfile,'pt',c_name,c_name,now());
        INSERT into video_profiles_l10n(id_profile,iso_language,title,meta_title,register_date) VALUES(_idProfile,'en',c_name,c_name,now());
        
        INSERT into video_composed(id_profile,id_video,set_thumbnail,publish_date,begin_date,register_date) VALUES(_idProfile,c_id_video,1,now(),now(),now());
		SET _idComposed = last_insert_id();
        
        IF EXISTS (SELECT id_playlist FROM playlists WHERE id_playlist = _id_playlist)
        THEN
			INSERT into video_composed_playlists_related(id_playlist,id_composed,register_date) VALUES (_id_playlist,_idComposed,now()); 
            UPDATE video_composed SET state = 4 WHERE id_composed = _idComposed;
        END IF;
        
	-- end do the work
    
      END LOOP read_loop;

    CLOSE cursor_loader;
 -- end cursor    

	SET _result = 0;

-- COMMIT;

END;

