create
    definer = skoiypp@`%` procedure SP_SET_ACCOUNT(IN _id_account int(10), IN _account_token varchar(255),
                                                   IN _account_alias varchar(255), IN _company_name varchar(192),
                                                   IN _email varchar(192), IN _phone varchar(192),
                                                   IN _address varchar(255), IN _id_type_industry tinyint(3),
                                                   IN _country_iso char(2), IN _website varchar(192),
                                                   IN _timezone int(10), IN _verified tinyint(1), IN _active tinyint(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;

START TRANSACTION;

SET p_last_id = 0;

IF(_id_account <> -1)
THEN
	IF EXISTS(SELECT id_account FROM accounts WHERE id_account = _id_account)
	THEN
		IF EXISTS(SELECT id_account FROM accounts WHERE id_account = _id_account AND email = _email)
		THEN
			UPDATE accounts SET account_token = _account_token,account_alias = _account_alias, company_name = _company_name, email = _email, phone = _phone, address = _address, id_type_industry = _id_type_industry, country_iso = _country_iso, website = _website, timezone = _timezone, verified = _verified,active = _active, update_date = now() WHERE id_account = _id_account;
			SELECT 0 as return_code, id_account, account_token,account_alias, company_name, email, phone, address, id_type_industry, country_iso, website, timezone,verified, active FROM accounts WHERE id_account = _id_account;
		ELSE
			IF NOT EXISTS(SELECT id_account FROM accounts WHERE email = _email)
			THEN
				UPDATE accounts SET account_token = _account_token,account_alias = _account_alias, company_name = _company_name, email = _email, phone = _phone, address = _address, id_type_industry = _id_type_industry, country_iso = _country_iso, website = _website, timezone = _timezone,verified = _verified,active = _active, update_date = now() WHERE id_account = _id_account;
				SELECT 0 as return_code, id_account, account_token,account_alias, company_name, email, phone, address, id_type_industry, country_iso, website, timezone, verified, active FROM accounts WHERE id_account = _id_account;
			ELSE
				SELECT -2 as return_code;
			END IF;
		END IF;
	ELSE
		SELECT -2 as return_code;
	END IF;
ELSE
		INSERT into accounts(account_token, account_alias, company_name, email, phone, address, id_type_industry, country_iso, website, timezone, verified,active,register_date) VALUES (_account_token,_account_alias, _company_name, _email, _phone, _address, _id_type_industry, _country_iso, _website, _timezone,_verified,_active,now());
		SET p_last_id = last_insert_id();
		SELECT 0 as return_code, id_account, account_token, account_alias, company_name, email, phone, address, id_type_industry, country_iso, website, timezone, verified, active FROM accounts WHERE id_account = p_last_id;
END IF;

COMMIT;

END;

