create
    definer = skoiypp@`%` procedure SP_SET_ACCOUNT_SETUP(IN _id_account int)
BEGIN


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_account from accounts where id_account = _id_account)
THEN
	IF NOT EXISTS (SELECT id_account from bd_access_settings where id_account = _id_account)
	THEN
		CALL SP_SET_ACCOUNT_ACCESS_CONFIG(_id_account);
		CALL SP_SET_ACCOUNT_ACCESS_NOSQL_CONFIG(_id_account);

		INSERT INTO accounts_services(id_account,id_service,register_date) SELECT _id_account,id_service,now() FROM services WHERE is_default = 1;
		INSERT INTO accounts_logs_settings(id_account,active,source,register_date) VALUES(_id_account,1,'/mnt/data/platform/logs',now());
		INSERT INTO accounts_api_versions(id_account,id_api_version,register_date) VALUES(_id_account,2,now());


		 INSERT INTO accounts_other_settings(id_account,service_accounts_path,id_service_accounts,service_leads_path,id_service_leads,register_date) 
		 VALUES(_id_account,8,1,3,3,now())  ON DUPLICATE KEY UPDATE register_date = now(); 

		SELECT 0 as return_code;
	ELSE
		SELECT -2 as return_code;
	END IF;
ELSE
	SELECT -2 as return_code;
END IF;

COMMIT;

END;

