create
    definer = skoiypp@`%` procedure SP_SET_ACCOUNT_SETUP_SERVICE(IN _id_account int, IN _service varchar(255))
BEGIN

DECLARE _id_service INT(10);
DECLARE _cdn INT(10);
DECLARE _source INT(10);
DECLARE _source_raw_previews INT(10);
DECLARE _chunks INT(10);
DECLARE _oir_cache INT(10);
DECLARE _upload INT(10);
DECLARE _upload_max_size INT(10);
DECLARE _uptype INT(10);
DECLARE _internal_upload_max_size INT(10);
DECLARE _internal_uptype INT(10);
DECLARE _service_path INT(10);
DECLARE _upload_path INT(10);
DECLARE _internal_upload_path INT(10); 

DECLARE _cdn_thumbnail INT(10);
DECLARE _thumbnail INT(10);

DECLARE _versions INT(10);
DECLARE _quality INT(10);
DECLARE _transfer_path INT(10);

DECLARE _feeds_path INT(10);
DECLARE _sitemap_path INT(10);

DECLARE _h264 INT(10);
DECLARE _ogg INT(10);
DECLARE _webm INT(10);
DECLARE _web_version INT(10);
DECLARE _mobile_version INT(10);
DECLARE _default_version INT(10);

DECLARE _cdn_versions INT(10);
DECLARE _cdn_source INT(10);
DECLARE _cdn_webvtt_source INT(10);
DECLARE _webvtt_source INT(10);


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_account from accounts where id_account = _id_account)
THEN


IF(_service = 'ASSETS') THEN	
	IF( SELECT FN_GET_ACCOUNT_HAVE_SERVICE_ENABLED(_id_account,'assets') = 1 )
	THEN

		IF NOT EXISTS (SELECT id_account FROM accounts_assets_settings WHERE id_account = _id_account)
		THEN

			SET _id_service = 4;
			SET _cdn = 14;
			SET _source = 17;
			SET _source_raw_previews = 23;
			SET _chunks = 19;
			SET _oir_cache = 20;
			SET _upload = 18;
			SET _upload_max_size = 104857600;
			SET _uptype = 1;
			SET _internal_upload_max_size = 5242880;
			SET _internal_uptype = 1;
			SET _service_path = 2;
			SET _upload_path = 7;
			SET _internal_upload_path = 11; 

			INSERT INTO accounts_assets_settings
				  (id_account,id_service,cdn,source,source_raw_previews,chunks,oir_cache,upload,upload_max_size,uptype,internal_upload_max_size,internal_uptype,service_path,upload_path,internal_upload_path,register_date) 
			VALUES(_id_account,_id_service,_cdn,_source,_source_raw_previews,_chunks,_oir_cache,_upload,_upload_max_size,_uptype,_internal_upload_max_size,_internal_uptype,_service_path,_upload_path,_internal_upload_path,now()) ON DUPLICATE KEY UPDATE register_date = now(); 
			SELECT 0 as return_code;
		END IF;

	END IF;
END IF;

IF(_service = 'ARCHIVE') THEN	
	IF( SELECT FN_GET_ACCOUNT_HAVE_SERVICE_ENABLED(_id_account,'archive') = 1 )
	THEN

		IF NOT EXISTS (SELECT id_account FROM accounts_archive_settings WHERE id_account = _id_account)
		THEN

			SET _id_service = 5;
			SET _cdn = 12;
			SET _cdn_thumbnail = 12;
			SET _thumbnail = 14;
			SET _upload = 15;
			SET _chunks = 16;
			SET _oir_cache = 21;

			SET _upload_max_size = 10737418240;
			SET _uptype = 3;
			SET _versions = 10;
			SET _quality = 90;

			SET _service_path = 4;
			SET _upload_path = 7;
			SET _transfer_path = 6; 


			 INSERT INTO accounts_archive_settings(id_account,id_service,cdn,cdn_thumbnail,
			 thumbnail,upload,chunks,oir_cache,upload_max_size,uptype,versions,quality,service_path,upload_path,transfer_path,register_date) 
			 VALUES(_id_account,_id_service,_cdn,_cdn_thumbnail,
			 _thumbnail,_upload,_chunks,_oir_cache,_upload_max_size,_uptype,_versions,_quality,_service_path,_upload_path,_transfer_path,now()) ON DUPLICATE KEY UPDATE register_date = now();
			SELECT 0 as return_code;
		END IF;

	END IF;
END IF;

IF(_service = 'POSTS') THEN	
	IF( SELECT FN_GET_ACCOUNT_HAVE_SERVICE_ENABLED(_id_account,'posts') = 1 )
	THEN

		IF NOT EXISTS (SELECT id_account FROM accounts_posts_settings WHERE id_account = _id_account)
		THEN

			SET _id_service = 2;
			SET _internal_upload_max_size = 80000000;
			SET _internal_uptype = 1;
			SET _service_path = 1;
			SET _upload_path = 7;
			SET _internal_upload_path = 11;
			SET _feeds_path = 9;
			SET _sitemap_path = 10;

			INSERT INTO accounts_posts_settings(id_account,id_service,internal_upload_max_size,internal_uptype,service_path,upload_path,internal_upload_path,feeds_path,sitemap_path,register_date) 
			 VALUES(_id_account,_id_service,_internal_upload_max_size,_internal_uptype,_service_path,_upload_path,_internal_upload_path,_feeds_path,_sitemap_path,now())  ON DUPLICATE KEY UPDATE register_date = now();
			SELECT 0 as return_code;
		END IF;

	END IF;
END IF;

IF(_service = 'VIDEO') THEN	
	IF( SELECT FN_GET_ACCOUNT_HAVE_SERVICE_ENABLED(_id_account,'video') = 1 )
	THEN

		IF NOT EXISTS (SELECT id_account FROM accounts_video_settings WHERE id_account = _id_account)
		THEN

			SET _id_service = 6;
			SET _cdn = 7;
			SET _cdn_source = 6;
			SET _cdn_thumbnail = 13;
			SET _cdn_webvtt_source = 15;
			SET _source = 3;
			SET _versions = 4;
			SET _thumbnail = 5;
			SET _webvtt_source = 24;
			SET _upload = 6;
			SET _chunks = 7;
			SET _oir_cache = 22;
			SET _upload_max_size = 10737418240;
			SET _uptype = 2;
			SET _internal_upload_max_size = 5242880;
			SET _internal_uptype = 1;
			SET _quality = 90;
			SET _upload_path = 7;
			SET _internal_upload_path = 11;
			SET _service_path = 5;
			SET _feeds_path = 9;
			SET _sitemap_path = 10;
			SET _h264 = 1;
			SET _ogg = 0;
			SET _webm = 0;
			SET _web_version = 1;
			SET _mobile_version = 1;
			SET _default_version = 540;

			INSERT INTO accounts_video_settings(id_account,id_service,cdn, cdn_source,cdn_thumbnail,cdn_webvtt_source,source,versions,thumbnail,webvtt_source,upload,chunks,oir_cache,
			upload_max_size,uptype,internal_upload_max_size,internal_uptype,quality,upload_path,internal_upload_path,service_path,feeds_path,sitemap_path,h264,ogg,webm,web_version,mobile_version,default_version,register_date) 
			VALUES(_id_account,_id_service,_cdn, _cdn_source,_cdn_thumbnail,_cdn_webvtt_source,_source,_versions,_thumbnail,_webvtt_source,_upload,_chunks,_oir_cache,
			_upload_max_size,_uptype,_internal_upload_max_size,_internal_uptype,_quality,_upload_path,_internal_upload_path,_service_path,_feeds_path,_sitemap_path,_h264,_ogg,_webm,_web_version,_mobile_version,_default_version,now())  ON DUPLICATE KEY UPDATE register_date = now();
			SELECT 0 as return_code;
		END IF;

	END IF;
END IF;

IF(_service = 'ADS') THEN	
	IF( SELECT FN_GET_ACCOUNT_HAVE_SERVICE_ENABLED(_id_account,'ads') = 1 )
	THEN

		IF NOT EXISTS (SELECT id_account FROM accounts_ads_settings WHERE id_account = _id_account)
		THEN

			SET _id_service = 8;
			SET _cdn_versions = 7;
			SET _cdn_source = 6;
			SET _cdn_thumbnail = 13;
			SET _source = 25;
			SET _versions = 26;
			SET _thumbnail = 27;
			SET _upload = 28;
			SET _chunks = 29;
			SET _oir_cache = 30;
			SET _upload_max_size = 10737418240;
			SET _uptype = 2;
			SET _internal_upload_max_size = 5242880;
			SET _internal_uptype = 1;
			SET _quality = 90;
			SET _upload_path = 7;
			SET _internal_upload_path = 11;
			SET _service_path = 12;
			SET _h264 = 1;
			SET _ogg = 0;
			SET _webm = 0;
			SET _web_version = 1;
			SET _mobile_version = 1;
			SET _default_version = 540;

			INSERT INTO accounts_ads_settings(id_account,id_service,cdn_versions, cdn_source,cdn_thumbnail,source,versions,thumbnail,upload,chunks,oir_cache,
			upload_max_size,uptype,internal_upload_max_size,internal_uptype,quality,upload_path,internal_upload_path,service_path,h264,ogg,webm,web_version,mobile_version,default_version,register_date) 
			VALUES(_id_account,_id_service,_cdn_versions, _cdn_source,_cdn_thumbnail,_source,_versions,_thumbnail,_upload,_chunks,_oir_cache,
			_upload_max_size,_uptype,_internal_upload_max_size,_internal_uptype,_quality,_upload_path,_internal_upload_path,_service_path,_h264,_ogg,_webm,_web_version,_mobile_version,_default_version,now())  ON DUPLICATE KEY UPDATE register_date = now();
			SELECT 0 as return_code;
		END IF;

	END IF;
END IF;

IF(_service = 'LIVE') THEN	
	IF( SELECT FN_GET_ACCOUNT_HAVE_SERVICE_ENABLED(_id_account,'live') = 1 )
	THEN

		IF NOT EXISTS (SELECT id_account FROM accounts_live_settings WHERE id_account = _id_account)
		THEN

			SET _id_service = 7;
			SET _internal_upload_max_size = 5242880;
			SET _internal_uptype = 1;
			SET _internal_upload_path = 11;
			SET _service_path = 13;

			INSERT INTO accounts_live_settings(id_account,id_service,internal_upload_max_size,internal_uptype,internal_upload_path,service_path,register_date) 
			 VALUES(_id_account,_id_service,_internal_upload_max_size,_internal_uptype,_internal_upload_path,_service_path,now())  ON DUPLICATE KEY UPDATE register_date = now();
			SELECT 0 as return_code;
		END IF;

	END IF;
END IF;



























	
















ELSE
	SELECT -2 as return_code;
END IF;

COMMIT;

END;

