create
    definer = skoiypp@`%` procedure SP_SET_ADS_CAMPAIGNS(IN _id_campaign int, IN _name varchar(192),
                                                         IN _begin_date datetime, IN _end_date datetime)
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF(_id_campaign = 0 OR _id_campaign = -1)
THEN
        INSERT into ads_campaigns(name,begin_date,end_date,register_date) VALUES(_name,_begin_date,_end_date,now());        
        SET p_last_id = last_insert_id();
        SELECT id_campaign,name,begin_date,end_date,state,register_date,FN_GET_ADS_CAMPAIGNS_HAS_ADS_VIDEOS(id_campaign) as has_ad_videos,FN_GET_ADS_CAMPAIGNS_HAS_EXTERNAL_AD_TAG(id_campaign) as has_external_tag FROM ads_campaigns WHERE id_campaign = p_last_id; 
ELSE       
     IF EXISTS (SELECT id_campaign FROM ads_campaigns WHERE id_campaign = _id_campaign)
     THEN
		SELECT FN_SP_SET_PUBLISH_ADS_SYNC_UPDATE(10,_id_campaign) into _empty;
        UPDATE ads_campaigns SET name = _name,begin_date = _begin_date,end_date = _end_date, update_date = now() WHERE id_campaign = _id_campaign;
        SELECT id_campaign,name,begin_date,end_date,state,register_date,FN_GET_ADS_CAMPAIGNS_HAS_ADS_VIDEOS(id_campaign) as has_ad_videos,FN_GET_ADS_CAMPAIGNS_HAS_EXTERNAL_AD_TAG(id_campaign) as has_external_tag FROM ads_campaigns WHERE id_campaign = _id_campaign; 
     ELSE
        SELECT -2 as return_code;
     END IF;
END IF;
COMMIT;

END;

