create
    definer = skoiypp@`%` procedure SP_SET_ADS_CAMPAIGNS_VIDEO_COMPOSED(IN _id_campaign int, IN _id_composed int,
                                                                        IN _roll_in int, IN _seconds_in float(10, 2))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS (SELECT id_campaign FROM ads_campaigns WHERE id_campaign = _id_campaign) AND EXISTS (SELECT id_composed FROM video_composed WHERE id_composed = _id_composed)
THEN
    IF NOT EXISTS(SELECT id_campaign FROM ads_campaigns_video_composed_related WHERE id_campaign = _id_campaign AND id_composed = _id_composed AND roll_in = _roll_in AND seconds_in = _seconds_in)
    THEN
        INSERT INTO ads_campaigns_video_composed_related(id_campaign,id_composed,roll_in,seconds_in,register_date) VALUES(_id_campaign,_id_composed,_roll_in,_seconds_in,now());
		 SET p_last_id = last_insert_id();
		SELECT id_related,acvcr.id_campaign,ac.name,ac.begin_date,ac.end_date,id_composed,roll_in,seconds_in,acvcr.register_date,FN_GET_ADS_CAMPAIGNS_HAS_ADS_VIDEOS(ac.id_campaign) as has_ad_videos,FN_GET_ADS_CAMPAIGNS_HAS_EXTERNAL_AD_TAG(ac.id_campaign) as has_external_tag FROM ads_campaigns_video_composed_related acvcr, ads_campaigns ac WHERE acvcr.id_campaign =  ac.id_campaign AND id_related = p_last_id;
    ELSE
		 SELECT -3 as return_code;
    END IF;
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

