create
    definer = skoiypp@`%` procedure SP_SET_ADS_CAMPAIGN_CODE(IN _id_code int(10), IN _id_campaign int,
                                                             IN _name varchar(192), IN _code bigint,
                                                             IN _ratio varchar(8), IN _autoplay tinyint(1),
                                                             IN _start_expanded tinyint(1), IN _end_collapse tinyint(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS (SELECT id_campaign FROM ads_campaigns WHERE id_campaign = _id_campaign)
THEN
	
	SELECT FN_SP_SET_PUBLISH_ADS_SYNC_UPDATE(41,_id_campaign) into _empty;

	IF(_id_code = 0 OR _id_code = -1)
	THEN
	        INSERT into ads_campaigns_codes(id_campaign,name,code,ratio,autoplay,start_expanded,end_collapse,register_date) VALUES(_id_campaign,_name,_code,_ratio,_autoplay,_start_expanded,_end_collapse,now());        
	        SET p_last_id = last_insert_id();
	        SELECT id_code,id_campaign,name,code,ratio,autoplay,start_expanded,end_collapse,register_date FROM ads_campaigns_codes WHERE id_code = p_last_id; 
	ELSE       
	     IF EXISTS (SELECT id_code FROM ads_campaigns_codes WHERE id_code = _id_code)
	     THEN
	        UPDATE ads_campaigns_codes SET name = _name,code = code,ratio = _ratio,autoplay = _autoplay,start_expanded = _start_expanded,end_collapse = _end_collapse, update_date = now() WHERE id_code = _id_code AND id_campaign = _id_campaign;
	        SELECT id_code,id_campaign,name,code,ratio,autoplay,start_expanded,end_collapse,register_date FROM ads_campaigns_codes WHERE id_code = _id_code AND id_campaign = _id_campaign;
	     ELSE
	        SELECT -2 as return_code;
	     END IF;
	END IF;
	COMMIT;
ELSE
	SELECT -2 as return_code;
END IF;

COMMIT;

END;

