create
    definer = skoiypp@`%` procedure SP_SET_ARCHIVE_CLIPS_DIRECTORIES(IN _id_directory INT, IN _parent_id_directory INT,
                                                                     IN _name VARCHAR(192), IN _description text,
                                                                     IN _link VARCHAR(255))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF (_id_directory < 1)
THEN
	IF NOT EXISTS (SELECT id_directory FROM archive_clips_directories WHERE id_directory = 1)
	THEN
		INSERT INTO archive_clips_directories(id_directory,name,register_date) VALUES(1,'root',now());
		INSERT INTO archive_clips_directories(name,description,link,register_date) VALUES(_name,_description,_link,now());
		SET p_last_id = last_insert_id();
		INSERT INTO archive_clips_directories_parent_related(id_directory,parent_id_directory, register_date) VALUES(p_last_id,1,now()) ON DUPLICATE KEY UPDATE update_date = now();
		SELECT id_directory,name, description, link FROM archive_clips_directories WHERE id_directory = p_last_id;
	ELSE
		IF (_parent_id_directory < 1)
		THEN
			INSERT INTO archive_clips_directories(name,description,link,register_date) VALUES(_name,_description,_link,now());
			SET p_last_id = last_insert_id();
			INSERT INTO archive_clips_directories_parent_related(id_directory,parent_id_directory, register_date) VALUES(p_last_id,1,now()) ON DUPLICATE KEY UPDATE update_date = now();
			SELECT id_directory,name, description, link FROM archive_clips_directories WHERE id_directory = p_last_id;
		ELSE
			IF EXISTS (SELECT id_directory FROM archive_clips_directories WHERE id_directory = _parent_id_directory)
			THEN
				INSERT INTO archive_clips_directories(name,description,link,register_date) VALUES(_name,_description,_link,now());
				SET p_last_id = last_insert_id();
				INSERT INTO archive_clips_directories_parent_related(id_directory,parent_id_directory, register_date) VALUES(p_last_id,_parent_id_directory,now()) ON DUPLICATE KEY UPDATE update_date = now();
				SELECT id_directory,name, description, link FROM archive_clips_directories WHERE id_directory = p_last_id;
			ELSE
				SELECT -2 as return_code;
			END IF;
		
		END IF;

	END IF;

ELSE 
	IF NOT EXISTS (SELECT id_directory FROM archive_clips_directories WHERE id_directory = _id_directory)
	THEN
		SELECT -2 as return_code;
	ELSE
		IF (_id_directory = 1)
		THEN
			SELECT id_directory,name, description, link FROM archive_clips_directories WHERE id_directory = _id_directory;
		ELSE
			IF EXISTS (SELECT id_directory FROM archive_clips_directories WHERE id_directory = _parent_id_directory)
			THEN
				UPDATE archive_clips_directories SET name = _name,description = _description, link = _link, update_date = now() WHERE id_directory = _id_directory;
				UPDATE archive_clips_directories_parent_related SET parent_id_directory = _parent_id_directory WHERE id_directory = _id_directory;
				SELECT id_directory,name, description, link FROM archive_clips_directories WHERE id_directory = _id_directory;
			ELSE
				SELECT -2 as return_code;
			END IF;
		END IF;	

	END IF;
END IF;

COMMIT;

END;

