create
    definer = skoiypp@`%` procedure SP_SET_ARCHIVE_CLIP_PREVIEW(IN _id_clip INT(10), IN _file_name varchar(192),
                                                                IN _size BIGINT, IN _extension VARCHAR(8),
                                                                IN _bitrate BIGINT, IN _width INT(10),
                                                                IN _height INT(10), IN _id_storage int(10),
                                                                IN _id_cdn int(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS(SELECT id_clip FROM archive_clips WHERE id_clip = _id_clip)
THEN
	IF EXISTS(SELECT id_clip FROM archive_clips_previews WHERE id_clip = _id_clip)
	THEN
		UPDATE archive_clips_previews SET filename = _file_name, size = _size,extension = _extension,bitrate = _bitrate,width = _width,height = height WHERE id_clip = _id_clip;
		SELECT id_clip,id_storage,id_cdn,filename,size,extension,bitrate,width,height, register_date FROM archive_clips_previews WHERE id_clip = _id_clip;
	ELSE
		INSERT into archive_clips_previews(id_clip,id_storage,id_cdn,filename,size,extension,bitrate,width,height,register_date) 
		VALUES(_id_clip,_id_storage,_id_cdn,_file_name,_size,_extension,_bitrate,_width,_height,now());
		SET p_last_id = last_insert_id();
		SELECT id_clip,id_storage,id_cdn,filename,size,extension,bitrate,width,height, register_date FROM archive_clips_previews WHERE id_clip = p_last_id;
	END IF;
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

