create
    definer = skoiypp@`%` procedure SP_SET_ARCHIVE_PROJECT_FILE(IN _id_project int, IN _name varchar(192),
                                                                IN _file_name varchar(192), IN _extension varchar(8),
                                                                IN _mime_type varchar(192), IN _size bigint)
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS(SELECT id_project FROM archive_projects WHERE id_project = _id_project)
THEN
	INSERT into archive_projects_files_related(id_project,name,filename,extension,mime_type,size,register_date) VALUES(_id_project,_name,_file_name,_extension,_mime_type,_size,now());
	SET p_last_id = last_insert_id();
	SELECT id_project_file,id_project,name,filename,extension,mime_type,size,register_date FROM archive_projects_files_related WHERE id_project_file = p_last_id;
ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

