create
    definer = skoiypp@`%` procedure SP_SET_ASSETS_ALBUM(IN _id_album INT, IN _id_directory INT, IN _name VARCHAR(192),
                                                        IN _description text, IN _link VARCHAR(255),
                                                        IN _random TINYINT(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF (_id_directory = 0 OR _id_directory = 1 OR _id_directory = -1)
THEN
	SET _id_directory = 1;
END IF;

IF NOT EXISTS (SELECT id_directory FROM assets_directories WHERE id_directory = 1)
THEN
	INSERT INTO assets_directories(id_directory,name,register_date) VALUES(1,'root',now());
END IF;

IF(_id_album = 0 OR _id_album = -1)
THEN
   INSERT INTO albums(id_directory,name,description,link,random,register_date) VALUES(_id_directory,_name,_description,_link,_random,now());
   SET p_last_id = last_insert_id();
   SELECT id_album, id_directory,name, description, link, random FROM albums WHERE id_album = p_last_id;
ELSE
	IF EXISTS (SELECT id_album FROM albums WHERE id_album = _id_album)
	THEN	   
        SELECT FN_SP_SET_PUBLISH_ASSETS_SYNC_UPDATE(20,_id_album) into _empty;	
	    UPDATE albums SET name = _name,description = _description,id_directory = _id_directory, link = _link, random = _random, update_date = now() WHERE id_album = _id_album;
	    SELECT id_album, id_directory, name, description, link, random FROM albums WHERE id_album = _id_album;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;  
  
COMMIT;

END;

