create
    definer = skoiypp@`%` procedure SP_SET_LIVE_PLAYLISTS_TO_CHANNELS(IN _id_channel int, IN _id_playlist int, IN _position int)
BEGIN

DECLARE lastposition INT;
DECLARE _old_position INT;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;



START TRANSACTION;
    
IF EXISTS (SELECT id_channel FROM channels WHERE id_channel = _id_channel) AND EXISTS (SELECT id_playlist FROM playlists WHERE id_playlist = _id_playlist)
  THEN

  SELECT count(1) into lastposition FROM playlists_channels_related WHERE id_channel = _id_channel;
  SELECT position into _old_position FROM playlists_channels_related WHERE id_playlist = _id_playlist AND id_channel = _id_channel;

  IF(_position = lastposition)
  THEN
    SET _position = _position+1;
  END IF;

    IF NOT EXISTS (SELECT id_channel FROM playlists_channels_related WHERE id_channel = _id_channel AND id_playlist = _id_playlist)
    THEN
      INSERT INTO playlists_channels_related(id_channel,id_playlist,position,update_date,register_date) VALUES(_id_channel,_id_playlist,_position,now(),now());
      UPDATE playlists SET state = '4' WHERE id_playlist = _id_playlist AND state NOT IN ('5');
      SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(15,_id_channel) into _empty;
      SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(151,_id_playlist) into _empty;
    ELSE
      UPDATE playlists_channels_related SET position = _position, update_date = now() WHERE id_channel = _id_channel AND id_playlist = _id_playlist;
    END IF;
    
    
  IF(_position < _old_position)
  THEN
      SET @rownum=0;
      UPDATE playlists_channels_related p, (SELECT @rownum:=@rownum+1 rownum, playlists_channels_related.* FROM playlists_channels_related WHERE id_channel = _id_channel ORDER BY position,update_date DESC) r 
      SET p.position = r.rownum
      WHERE (p.id_playlist = r.id_playlist);
  ELSE
      SET @rownum=0;
      UPDATE playlists_channels_related p, (SELECT @rownum:=@rownum+1 rownum, playlists_channels_related.* FROM playlists_channels_related WHERE id_channel = _id_channel ORDER BY position,update_date ASC) r 
      SET p.position = r.rownum
      WHERE (p.id_playlist = r.id_playlist);
  END IF;

      SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(150,_id_playlist) into _empty;


    SELECT 0 as return_code;
    
ELSE
  SELECT -2 as return_code;
END IF;    

COMMIT;

END;

