create
    definer = skoiypp@`%` procedure SP_SET_LIVE_PLAYLIST_CLONE(IN _id_playlist int)
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF (SELECT count(1) FROM playlists WHERE id_playlist = _id_playlist)
THEN
    INSERT into playlists(management_name, publish_date,begin_date, end_date,register_date)
        SELECT CONCAT('Copy of ',management_name), publish_date,begin_date, end_date,now() FROM playlists WHERE id_playlist = _id_playlist; 
    SET p_last_id = last_insert_id();
    
	INSERT into video_composed_playlists_related(id_composed,id_playlist,position,register_date) 
		 SELECT id_composed,p_last_id,position,now() FROM video_composed_playlists_related WHERE id_playlist = _id_playlist;

	INSERT into playlists_l10n(id_playlist,iso_language,name,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,register_date)
		 SELECT p_last_id,iso_language,name,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,now() FROM playlists_l10n WHERE id_playlist = _id_playlist;
                
   CALL SP_SET_LIVE_PLAYLIST_CLONE_L10N(p_last_id,_id_playlist);

   SELECT id_playlist,management_name, publish_date,begin_date, end_date, state FROM playlists WHERE id_playlist = p_last_id;

ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

