create
    definer = skoiypp@`%` procedure SP_SET_POSTS_AUTHOR_L10N(IN _id_author_l10n INT(10), IN _id_author INT(10),
                                                             IN _iso_language VARCHAR(10), IN _name VARCHAR(255),
                                                             IN _email VARCHAR(255), IN _description TEXT,
                                                             IN _role VARCHAR(255), IN _biography TEXT,
                                                             IN _image VARCHAR(255), IN _image_align VARCHAR(255),
                                                             IN _image_title VARCHAR(255),
                                                             IN _image_alter_text VARCHAR(255),
                                                             IN _meta_title VARCHAR(255), IN _meta_description TEXT,
                                                             IN _meta_image VARCHAR(255), IN _meta_url VARCHAR(255),
                                                             IN _meta_keywords VARCHAR(255), IN _public TINYINT(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
    SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS (SELECT id_author FROM posts_authors WHERE id_author = _id_author)
THEN
	IF(_id_author_l10n = 0 OR _id_author_l10n = -1)
	THEN
		INSERT INTO posts_authors_l10n(id_author,iso_language,public,name,email,description,role,biography,image,image_align,meta_title,meta_description,meta_image,meta_url,image_title,image_alter_text,meta_keywords,register_date) 
		VALUES(_id_author,_iso_language,_public,_name,_email,_description,_role,_biography,_image,_image_align,_meta_title,_meta_description,_meta_image,_meta_url,_image_title,_image_alter_text,_meta_keywords,now());
		SET p_last_id = last_insert_id();
		SELECT id_author_l10n,id_author,public,iso_language,FN_GET_POSTS_L10N_ISO_GROUPED(4,id_author) as iso_grouped,name,email,description,role,biography,image,image_align,FN_GET_ASSETS_ID_BY_FILENAME(image) as id_asset,FN_GET_ASSETS_WIDTH_HEIGHT_BY_ID(1,FN_GET_ASSETS_ID_BY_FILENAME(image)) as image_width,FN_GET_ASSETS_WIDTH_HEIGHT_BY_ID(2,FN_GET_ASSETS_ID_BY_FILENAME(image)) as image_height,FN_GET_ASSETS_ID_BY_FILENAME(meta_image) as meta_id_asset,meta_title,meta_description,meta_image,meta_url,image_title,image_alter_text,meta_keywords,FN_GET_POSTS_AUTHORS_TOTAL_POSTS(id_author) as total,register_date FROM posts_authors_l10n WHERE id_author_l10n = p_last_id; 
	ELSE       
	     IF EXISTS (SELECT id_author_l10n FROM posts_authors_l10n WHERE id_author_l10n = _id_author_l10n)
	     THEN
	    	SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(81,_id_author) into _empty;
	        UPDATE posts_authors_l10n SET id_author = _id_author,iso_language = _iso_language,public = _public,name = _name,email = _email,description = _description,role = _role,biography = _biography,image = _image,image_align = _image_align,meta_title = _meta_title,meta_description = _meta_description,meta_image = _meta_image,meta_url = _meta_url,image_title = _image_title,image_alter_text = _image_alter_text,meta_keywords = _meta_keywords, update_date = now() WHERE id_author = _id_author AND id_author_l10n = _id_author_l10n;
			SELECT id_author_l10n,id_author,public,iso_language,FN_GET_POSTS_L10N_ISO_GROUPED(4,id_author) as iso_grouped,name,email,description,role,biography,image,image_align,FN_GET_ASSETS_ID_BY_FILENAME(image) as id_asset,FN_GET_ASSETS_WIDTH_HEIGHT_BY_ID(1,FN_GET_ASSETS_ID_BY_FILENAME(image)) as image_width,FN_GET_ASSETS_WIDTH_HEIGHT_BY_ID(2,FN_GET_ASSETS_ID_BY_FILENAME(image)) as image_height,FN_GET_ASSETS_ID_BY_FILENAME(meta_image) as meta_id_asset,meta_title,meta_description,meta_image,meta_url,image_title,image_alter_text,meta_keywords,FN_GET_POSTS_AUTHORS_TOTAL_POSTS(id_author) as total,register_date FROM posts_authors_l10n WHERE id_author_l10n = _id_author_l10n; 
	     ELSE
	        SELECT -2 as return_code;
	     END IF;
	END IF;
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

