create
    definer = skoiypp@`%` procedure SP_SET_POSTS_CLONE_L10N(IN _id_post int, IN _id_post_clone int)
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id_l10n INT;
DECLARE c_iso_language VARCHAR(10);
DECLARE exist_table varchar(10);

DECLARE cursor_l10n CURSOR FOR SELECT id_l10n,iso_language FROM posts_l10n WHERE id_post = _id_post;
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;

START TRANSACTION;

    
   
    OPEN cursor_l10n;
    IF(@result = -1)
        THEN
            SELECT -1 as return_code;
            ROLLBACK;
    END IF;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_l10n INTO c_id_l10n,c_iso_language;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	
               
	INSERT into posts_l10n_tags_related(id_tag,id_l10n,register_date) 
		 SELECT id_tag,c_id_l10n,now() FROM posts_l10n_tags_related WHERE id_l10n = (SELECT id_l10n FROM posts_l10n WHERE id_post = _id_post_clone AND iso_language = c_iso_language);

	INSERT into posts_l10n_labels_related(id_label,id_l10n,register_date) 
		 SELECT id_label,c_id_l10n,now() FROM posts_l10n_labels_related WHERE id_l10n = (SELECT id_l10n FROM posts_l10n WHERE id_post = _id_post_clone AND iso_language = c_iso_language);

	INSERT into posts_l10n_posts_related(id_post,id_l10n,register_date) 
		 SELECT id_post,c_id_l10n,now() FROM posts_l10n_posts_related WHERE id_l10n = (SELECT id_l10n FROM posts_l10n WHERE id_post = _id_post_clone AND iso_language = c_iso_language);

	INSERT into posts_l10n_custom_fields_related(id_key,variant_value,position,id_l10n,register_date) 
		 SELECT id_key,variant_value,position,c_id_l10n,now() FROM posts_l10n_custom_fields_related WHERE id_l10n = (SELECT id_l10n FROM posts_l10n WHERE id_post = _id_post_clone AND iso_language = c_iso_language);


	INSERT into posts_l10n_body(id_l10n,body,position, settings, restricted,draft,block_type,register_date)
		 SELECT c_id_l10n,body,position, settings, restricted,draft,block_type,now() FROM posts_l10n_body WHERE id_l10n = (SELECT id_l10n FROM posts_l10n WHERE id_post = _id_post_clone AND iso_language = c_iso_language);

	INSERT into posts_l10n_photos(id_asset,id_l10n,register_date) 
		 SELECT id_asset,c_id_l10n,now() FROM posts_l10n_photos WHERE id_l10n = (SELECT id_l10n FROM posts_l10n WHERE id_post = _id_post_clone AND iso_language = c_iso_language);

	INSERT into posts_l10n_audios(id_asset,id_l10n,register_date) 
		 SELECT id_asset,c_id_l10n,now() FROM posts_l10n_audios WHERE id_l10n = (SELECT id_l10n FROM posts_l10n WHERE id_post = _id_post_clone AND iso_language = c_iso_language);

	INSERT into posts_l10n_documents(id_asset,id_l10n,register_date) 
		 SELECT id_asset,c_id_l10n,now() FROM posts_l10n_documents WHERE id_l10n = (SELECT id_l10n FROM posts_l10n WHERE id_post = _id_post_clone AND iso_language = c_iso_language);

	INSERT into posts_l10n_videos(id_composed,id_l10n,register_date) 
		 SELECT id_composed,c_id_l10n,now() FROM posts_l10n_videos WHERE id_l10n = (SELECT id_l10n FROM posts_l10n WHERE id_post = _id_post_clone AND iso_language = c_iso_language);

	INSERT into posts_l10n_albums(id_album,id_l10n,register_date) 
		 SELECT id_album,c_id_l10n,now() FROM posts_l10n_albums WHERE id_l10n = (SELECT id_l10n FROM posts_l10n WHERE id_post = _id_post_clone AND iso_language = c_iso_language);

	INSERT into posts_l10n_authors(id_author,id_l10n,register_date) 
		 SELECT id_author,c_id_l10n,now() FROM posts_l10n_authors WHERE id_l10n = (SELECT id_l10n FROM posts_l10n WHERE id_post = _id_post_clone AND iso_language = c_iso_language);
              
	
    
      END LOOP read_loop;

    CLOSE cursor_l10n;
    

COMMIT;

END;

