create
    definer = skoiypp@`%` procedure SP_SET_POSTS_DOSSIERS(IN _id_dossier INT(10), IN _management_name VARCHAR(192),
                                                          IN _publish_date DATETIME, IN _begin_date DATETIME,
                                                          IN _end_date DATETIME)
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_id_dossier = 0 OR _id_dossier = -1)
THEN
   INSERT INTO dossiers(management_name,publish_date,begin_date,end_date,register_date) VALUES(_management_name,_publish_date,_begin_date,_end_date,now());
   SET p_last_id = last_insert_id();
   SELECT id_dossier,management_name, publish_date,begin_date, end_date,state,register_date,FN_GET_POSTS_L10N_ISO_GROUPED(2,id_dossier) as iso_grouped FROM dossiers WHERE id_dossier = p_last_id;
ELSE
	IF EXISTS (SELECT id_dossier FROM dossiers WHERE id_dossier = _id_dossier)
	THEN	   
		SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(11,_id_dossier) into _empty;
		UPDATE dossiers SET management_name = _management_name,publish_date = _publish_date,begin_date = _begin_date, end_date = _end_date, update_date = now() WHERE id_dossier = _id_dossier;
		SELECT id_dossier, management_name, begin_date, end_date,state,register_date,FN_GET_POSTS_L10N_ISO_GROUPED(2,id_dossier) as iso_grouped FROM dossiers WHERE id_dossier = _id_dossier;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;  
  
COMMIT;

END;

