create
    definer = skoiypp@`%` procedure SP_SET_POSTS_STICKERS_MENU_ITENS(IN _id_sticker int(10), IN _id_item int(10),
                                                                     IN _parent_id_item int(10), IN _name varchar(255),
                                                                     IN _description varchar(255),
                                                                     IN _item_type int(10), IN _item_action int(10),
                                                                     IN _item_value varchar(255),
                                                                     IN _image varchar(255), IN _color varchar(255),
                                                                     IN _tracking_parameters varchar(255),
                                                                     IN _position int(10))
BEGIN





DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


START TRANSACTION;

IF EXISTS (SELECT id_sticker FROM posts_stickers WHERE id_sticker = _id_sticker)
THEN

IF (_id_item < 1)
THEN
	IF NOT EXISTS (SELECT id_item FROM posts_stickers_menu_itens WHERE id_item = 1 AND id_sticker = _id_sticker)
	THEN
		INSERT INTO posts_stickers_menu_itens(id_sticker,id_item,name,register_date) VALUES(_id_sticker,1,'root',now());
        SELECT count(1) into @NextItemId FROM posts_stickers_menu_itens WHERE id_sticker = _id_sticker;
		SET @NextItemId = @NextItemId+1;

		INSERT INTO posts_stickers_menu_itens(id_item,id_sticker,name,description,item_type,item_action,item_value,image,color,tracking_parameters,position,register_date) 
        VALUES(@NextItemId,_id_sticker,_name,_description,_item_type,_item_action,_item_value,_image,_color,_tracking_parameters,_position,now());
		SET p_last_id = @NextItemId;
		
        INSERT INTO posts_stickers_menu_itens_parent_related(id_sticker,id_item,parent_id_item, register_date) VALUES(_id_sticker,p_last_id,1,now()) ON DUPLICATE KEY UPDATE update_date = now();
		SELECT id_sticker,id_item,name,description,item_type,item_action,item_value,image,color,tracking_parameters,position,register_date FROM posts_stickers_menu_itens WHERE id_item = p_last_id AND id_sticker = _id_sticker;
	ELSE
		IF (_parent_id_item < 1)
		THEN
                SELECT count(1) into @NextItemId FROM posts_stickers_menu_itens WHERE id_sticker = _id_sticker;
				SET @NextItemId = @NextItemId+1;
        
			INSERT INTO posts_stickers_menu_itens(id_item,id_sticker,name,description,item_type,item_action,item_value,image,color,tracking_parameters,position,register_date) 
            VALUES(@NextItemId,_id_sticker,_name,_description,_item_type,_item_action,_item_value,_image,_color,_tracking_parameters,_position,now());
			SET p_last_id = @NextItemId;
		
			INSERT INTO posts_stickers_menu_itens_parent_related(id_sticker,id_item,parent_id_item, register_date) VALUES(_id_sticker,p_last_id,1,now()) ON DUPLICATE KEY UPDATE update_date = now();
			SELECT id_sticker,id_item,name,description,item_type,item_action,item_value,image,color,tracking_parameters,position,register_date FROM posts_stickers_menu_itens WHERE id_item = p_last_id AND id_sticker = _id_sticker;
		ELSE
			IF EXISTS (SELECT id_item FROM posts_stickers_menu_itens WHERE id_item = _parent_id_item AND id_sticker = _id_sticker)
			THEN
               
                SELECT count(1) into @NextItemId FROM posts_stickers_menu_itens WHERE id_sticker = _id_sticker;
				SET @NextItemId = @NextItemId+1;
                
				INSERT INTO posts_stickers_menu_itens(id_item,id_sticker,name,description,item_type,item_action,item_value,image,color,tracking_parameters,position,register_date) VALUES(@NextItemId,_id_sticker,_name,_description,_item_type,_item_action,_item_value,_image,_color,_tracking_parameters,_position,now());
				SET p_last_id = @NextItemId;
				INSERT INTO posts_stickers_menu_itens_parent_related(id_sticker,id_item,parent_id_item, register_date) VALUES(_id_sticker,p_last_id,_parent_id_item,now()) ON DUPLICATE KEY UPDATE update_date = now();
				SELECT id_sticker,id_item,name,description,item_type,item_action,item_value,image,color,tracking_parameters,position,register_date FROM posts_stickers_menu_itens WHERE id_item = p_last_id AND id_sticker = _id_sticker;
			ELSE
				SELECT -2 as return_code;
			END IF;
		
		END IF;

	END IF;

ELSE 
	IF NOT EXISTS (SELECT id_item FROM posts_stickers_menu_itens WHERE id_item = _id_item AND id_sticker = _id_sticker)
	THEN
		SELECT -2 as return_code;
	ELSE
		IF (_id_item = 1)
		THEN
			SELECT id_sticker,id_item,name,description,item_type,item_action,item_value,image,color,tracking_parameters,position,register_date FROM posts_stickers_menu_itens WHERE id_item = _id_item AND id_sticker = _id_sticker;
		ELSE
			IF EXISTS (SELECT id_item FROM posts_stickers_menu_itens WHERE id_item = _parent_id_item)
			THEN
			    
				UPDATE posts_stickers_menu_itens SET name = _name,description = _description,item_type = _item_type,item_action = _item_action,item_value = _item_value,image = _image,color = _color,tracking_parameters = _tracking_parameters,position = _position, update_date = now() WHERE id_item = _id_item;
				UPDATE posts_stickers_menu_itens_parent_related SET parent_id_item = _parent_id_item WHERE id_item = _id_item;
				SELECT id_sticker,id_item,name,description,item_type,item_action,item_value,image,color,tracking_parameters,position,register_date FROM posts_stickers_menu_itens WHERE id_item = _id_item AND id_sticker = _id_sticker;
			ELSE
				SELECT -2 as return_code;
			END IF;
		END IF;	

	END IF;
END IF;

ELSE
	SELECT -2 as return_code;
END IF;

COMMIT;

END;

