create
    definer = skoiypp@`%` procedure SP_SET_POSTS_STICKER_RELATED(IN _id_sticker INT(10), IN _id_post INT(10),
                                                                 IN _position INT(10), IN _begin_date DATETIME,
                                                                 IN _end_date DATETIME, IN _color VARCHAR(255))
BEGIN

DECLARE lastposition INT;
DECLARE currentposition INT;
DECLARE _empty INT;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
    SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS (SELECT id_sticker FROM posts_stickers WHERE id_sticker = _id_sticker) AND EXISTS (SELECT id_post FROM posts WHERE id_post = _id_post)
THEN

	SELECT position into currentposition FROM posts_stickers_related WHERE id_sticker = _id_sticker AND id_post = _id_post;
    SELECT count(1) into lastposition FROM posts_stickers_related WHERE id_sticker = _id_sticker;
    
	IF(_position = 0 OR _position = -1)
	  THEN
		SET _position = lastposition+1;
	END IF;
  
    IF NOT EXISTS(SELECT id_sticker FROM posts_stickers_related WHERE id_sticker = _id_sticker AND id_post = _id_post)
    THEN
        INSERT INTO posts_stickers_related(id_sticker,id_post,position,begin_date,end_date,color,update_date,register_date) VALUES(_id_sticker,_id_post,_position,_begin_date,_end_date,_color,now(),now());
        
			SET @rownum=0;
			UPDATE posts_stickers_related c, (SELECT @rownum:=@rownum+1 rownum, posts_stickers_related.* FROM posts_stickers_related WHERE id_sticker = _id_sticker ORDER BY position,register_date desc) r 
			SET c.position = r.rownum
			WHERE (c.id_related = r.id_related);
			SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(70,_id_post) into _empty;
            
    ELSE
        
		UPDATE posts_stickers_related SET position = _position, begin_date = _begin_date,end_date = _end_date,color = _color, update_date = now() WHERE id_sticker = _id_sticker AND id_post = _id_post;
        
		IF(_position < currentposition)
		 THEN   
         
			SET @rownum=0;
			UPDATE posts_stickers_related c, (SELECT @rownum:=@rownum+1 rownum, posts_stickers_related.* FROM posts_stickers_related WHERE id_sticker = _id_sticker ORDER BY position,update_date desc) r 
			SET c.position = r.rownum
			WHERE (c.id_related = r.id_related);
            
			INSERT into posts_sync_updated_2(id_post,action_type,register_date) SELECT id_post,2,now() FROM posts 
        	WHERE id_post in (SELECT distinct id_post FROM posts_stickers_related WHERE id_sticker = _id_sticker AND position BETWEEN _position AND currentposition); 
            
		END IF;
        
        IF(_position > currentposition)
        THEN
        
			SET @rownum=0;
			UPDATE posts_stickers_related c, (SELECT @rownum:=@rownum+1 rownum, posts_stickers_related.* FROM posts_stickers_related WHERE id_sticker = _id_sticker ORDER BY position,update_date asc) r 
			SET c.position = r.rownum
			WHERE (c.id_related = r.id_related);
            
            INSERT into posts_sync_updated_2(id_post,action_type,register_date) SELECT id_post,2,now() FROM posts 
        	WHERE id_post in (SELECT distinct id_post FROM posts_stickers_related WHERE id_sticker = _id_sticker AND position BETWEEN currentposition AND _position); 
		END IF;
        
	END IF;
        
        SELECT 0 as return_code;

ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

