create
    definer = skoiypp@`%` procedure SP_SET_PUBLISH_ASSETS_SYNC(IN _id INT, IN _id_sync VARCHAR(255),
                                                               IN _id_rev_sync VARCHAR(255), IN _type TINYINT(1))
BEGIN


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_type = 1)
THEN
	IF (SELECT count(1) FROM assets WHERE id_asset = _id)
	THEN
		UPDATE assets SET id_sync = _id_sync, id_rev_sync = _id_rev_sync, update_date = now() WHERE id_asset = _id;
		SELECT id_asset,id_sync,id_rev_sync,register_date FROM assets WHERE id_asset = _id;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;

IF(_type = 2)
THEN
	IF (SELECT count(1) FROM albums WHERE id_album = _id)
	THEN
		UPDATE albums SET id_sync = _id_sync, id_rev_sync = _id_rev_sync WHERE id_album = _id;
		SELECT id_album,id_sync,id_rev_sync,register_date FROM albums WHERE id_album = _id;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;

IF(_type = 3)
THEN
	IF (SELECT count(1) FROM galleries WHERE id_gallery = _id)
	THEN
		UPDATE galleries SET id_sync = _id_sync, id_rev_sync = _id_rev_sync WHERE id_gallery = _id;
		SELECT id_gallery,id_sync,id_rev_sync,register_date FROM galleries WHERE id_gallery = _id;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;

IF(_type = 4)
THEN
	IF (SELECT count(1) FROM assets_directories WHERE id_directory = _id)
	THEN
		UPDATE assets_directories SET id_sync = _id_sync, id_rev_sync = _id_rev_sync WHERE id_directory = _id;
		SELECT id_directory,id_sync,id_rev_sync,register_date FROM assets_directories WHERE id_directory = _id;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;


IF(_type not in(1,2,3,4))
THEN
	SELECT -3 as return_code;
END IF;

COMMIT;

END;

