create
    definer = skoiypp@`%` procedure SP_SET_PUBLISH_VIDEO_MGO()
BEGIN


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

INSERT into video_publish_log_2(begin_publish_date) VALUES(now());



UPDATE video_composed SET begin_date = date(now()) WHERE begin_date <= date(now());
UPDATE playlists SET begin_date = date(now()) WHERE begin_date <= date(now());
UPDATE channels SET begin_date = date(now()) WHERE begin_date <= date(now());


CALL SP_SET_PUBLISH_VIDEO_CHANNELS_TO_OFFLINE();
CALL SP_SET_PUBLISH_VIDEO_PLAYLISTS_TO_OFFLINE();
CALL SP_SET_PUBLISH_VIDEO_COMPOSED_TO_OFFLINE();
CALL SP_SET_PUBLISH_VIDEO_STICKERS_TO_OFFLINE();


UPDATE channels SET state = 4 WHERE (begin_date > now() OR (end_date <= now() AND end_date <> '0000-00-00')) AND state = 5;

UPDATE channels SET state = 5 WHERE (begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now())) AND state = 4;

UPDATE playlists SET state = FN_GET_VIDEO_HIGHEST_STATE_CHANNELS(id_playlist) WHERE state in (4,5);


UPDATE playlists SET state = 4 WHERE (begin_date > now() OR (end_date <= now() AND end_date <> '0000-00-00')) AND state = 5;

UPDATE playlists SET state = 5 WHERE (begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now())) AND state = 4 AND FN_GET_VIDEO_IS_PLAYLISTS_ON_CHANNEL(id_playlist) > 0 AND FN_GET_VIDEO_HIGHEST_STATE_CHANNELS(id_playlist) = 5;




UPDATE video_composed SET state = 4 WHERE (begin_date > now() OR (end_date <= now() AND end_date <> '0000-00-00')) AND state = 5;

UPDATE video_composed SET state = 5 WHERE (begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now())) AND state = 4 AND FN_GET_VIDEO_HIGHEST_STATE_PLAYLISTS(id_composed) = 5;



UPDATE video_stickers_related SET state = 4 WHERE (begin_date > now() OR (end_date <= now() AND end_date <> '0000-00-00')) AND state = 5;

UPDATE video_stickers_related SET state = 4 WHERE id_composed in (SELECT id_composed FROM video_composed WHERE state <> 5);

UPDATE video_stickers_related SET state = 5 WHERE begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now()) AND state = 4;


call SP_SET_PUBLISH_COMPOSES_TO_SCHEDULE_ON_IDLE_PLAYLISTS();
call SP_SET_PUBLISH_PROFILE_STATE_TO_HIGHEST();

call SP_SET_PUBLISH_VIDEO_STICKERS_REORDER();
call SP_SET_PUBLISH_VIDEO_PLAYLISTS_CHANNELS_REORDER();
call SP_SET_PUBLISH_VIDEO_CHANNELS_REORDER();

	SELECT 0 as return_code;

COMMIT;

END;

