create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_SSO_CREATE_USER(IN _email varchar(255), IN _password varchar(255),
                                                                    IN _name varchar(255), IN _gender tinyint(2),
                                                                    IN _birthdate date, IN _country_iso varchar(255),
                                                                    IN _city varchar(255), IN _zipcode varchar(255))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _id_avatar INT UNSIGNED;
DECLARE _id_plan INT UNSIGNED;


DECLARE EXIT HANDLER FOR  1213 
BEGIN
	SELECT -1000 as return_code;
    rollback;
END;



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;


IF NOT EXISTS (SELECT id_user FROM users WHERE email = _email)
THEN

	SELECT id_plan into _id_plan FROM plans WHERE is_default = 1 LIMIT 0,1; 
    
        INSERT into users(id_plan,name,email,password,gender,birthdate,country_iso,city,zipcode,register_date)
        VALUES(_id_plan,_name,_email,_password,_gender,_birthdate,_country_iso,_city,_zipcode,now());
            SET p_last_id = last_insert_id();    
    
	SELECT id_avatar into _id_avatar FROM avatars WHERE is_default = 1 LIMIT 0,1; 
	INSERT into users_profiles(id_user,profile_name,id_avatar,lang,register_date) VALUES(p_last_id,_name,_id_avatar,'pt',now());
    
    SELECT id_user,FN_GET_OTT_PLAN(id_plan,1) as plan,FN_GET_OTT_PLAN(id_plan,2) as plan_stripped,name,email,gender,birthdate,identification,tax_number,nationality,country_iso,city,zipcode,active,verified,update_date, register_date FROM users WHERE id_user = p_last_id; 
    
ELSE
	SELECT -3 as return_code;
END IF;

COMMIT;

END;

