create
    definer = skoiypp@`%` procedure SP_SET_VIDEO_COMPOSED_TO_PLAYLISTS(IN _id_playlist INT, IN _id_composed INT, IN _position INT)
BEGIN

DECLARE lastposition INT;
DECLARE _old_position INT;
DECLARE _id_video INT;
DECLARE _id_profile INT;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_composed FROM video_composed WHERE id_composed = _id_composed) AND EXISTS (SELECT id_playlist FROM playlists WHERE id_playlist = _id_playlist)
THEN

  SELECT count(1) into lastposition FROM video_composed_playlists_related WHERE id_playlist = _id_playlist;
  SELECT position into _old_position FROM video_composed_playlists_related WHERE id_composed = _id_composed AND id_playlist = _id_playlist;
  
  IF(_position = lastposition)
  THEN
    SET _position = _position+1;
  END IF;

    IF NOT EXISTS(SELECT id_composed FROM video_composed_playlists_related WHERE id_composed = _id_composed AND id_playlist = _id_playlist)
    THEN
    
        IF(_position = 0)
        THEN
          SET _position = lastposition+1;
        END IF;
        SELECT id_profile, id_video into _id_profile, _id_video FROM video_composed WHERE id_composed = _id_composed;
        INSERT INTO video_composed_playlists_related(id_playlist,id_composed,position,update_date,register_date) VALUES(_id_playlist,_id_composed,_position,now(),now());
        UPDATE video_composed SET state = '4' WHERE id_composed = _id_composed AND state NOT IN ('5');
        UPDATE videos SET state = '4' WHERE id_video = _id_video AND state NOT IN ('5');
        UPDATE video_profiles_l10n SET state = '4' WHERE id_profile = _id_profile AND state NOT IN ('5');
            SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(16,_id_composed) into _empty;
        SELECT 0 as return_code;
        
        
    ELSE
    
        UPDATE video_composed_playlists_related SET position = _position, update_date = now() WHERE id_composed = _id_composed AND id_playlist = _id_playlist;
        
        IF(_position < _old_position)
        THEN
    			SET @rownum=0;
    			UPDATE video_composed_playlists_related p, (SELECT @rownum:=@rownum+1 rownum, video_composed_playlists_related.* FROM video_composed_playlists_related WHERE id_playlist = _id_playlist ORDER BY position,update_date DESC) r 
    			SET p.position = r.rownum
    			WHERE (p.id_composed = r.id_composed);
        ELSE
    			SET @rownum=0;
    			UPDATE video_composed_playlists_related p, (SELECT @rownum:=@rownum+1 rownum, video_composed_playlists_related.* FROM video_composed_playlists_related WHERE id_playlist = _id_playlist ORDER BY position,update_date ASC) r 
    			SET p.position = r.rownum
    			WHERE (p.id_composed = r.id_composed);
        END IF;
        
           
            
			IF(_position < _old_position)
            THEN
				INSERT into video_sync_updated(id_sync,id_rev_sync,id_composed,action_type,register_date) SELECT id_sync,id_rev_sync,id_composed,2,now() FROM video_composed 
				WHERE id_composed in (SELECT distinct id_composed FROM video_composed_playlists_related WHERE id_playlist = _id_playlist AND position BETWEEN _position AND _old_position); 
				INSERT into video_sync_updated(id_sync_player,id_rev_sync_player,id_composed,action_type,sync_type,register_date) SELECT id_sync,id_rev_sync,id_composed,2,2,now() FROM video_composed 
				WHERE id_composed in (SELECT distinct id_composed FROM video_composed_playlists_related WHERE id_playlist = _id_playlist AND position BETWEEN _position AND _old_position); 
			END IF;
			IF(_position > _old_position)
            THEN
				INSERT into video_sync_updated(id_sync,id_rev_sync,id_composed,action_type,register_date) SELECT id_sync,id_rev_sync,id_composed,2,now() FROM video_composed 
				WHERE id_composed in (SELECT distinct id_composed FROM video_composed_playlists_related WHERE id_playlist = _id_playlist AND position BETWEEN _old_position AND _position); 
				INSERT into video_sync_updated(id_sync_player,id_rev_sync_player,id_composed,action_type,sync_type,register_date) SELECT id_sync,id_rev_sync,id_composed,2,2,now() FROM video_composed 
				WHERE id_composed in (SELECT distinct id_composed FROM video_composed_playlists_related WHERE id_playlist = _id_playlist AND position BETWEEN _old_position AND _position); 
			END IF;
            
    END IF;

    SELECT 0 as return_code;

ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

