create
    definer = skoiypp@`%` procedure SP_SET_VIDEO_VERSIONS(IN _id_video int, IN _file_name varchar(192),
                                                          IN _extension varchar(8), IN _width int(10),
                                                          IN _height int(10), IN _version varchar(192),
                                                          IN _version_type varchar(192), IN _size bigint,
                                                          IN _bitrate bigint, IN _audio_bitrate bigint,
                                                          IN _default_version int(10), IN _id_storage int(10),
                                                          IN _id_cdn int(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _is_default TINYINT(1);


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;
SET _is_default = 0;

START TRANSACTION;

IF NOT EXISTS (SELECT id_video FROM video_versions WHERE id_video = _id_video AND version = _version AND version_type = _version_type)
THEN

IF(_version = _default_version)
THEN
	SET _is_default = 1;
END IF;

	INSERT into video_versions(id_video,id_storage,id_cdn,filename,extension,width,height,version,version_type,size,bitrate,audio_bitrate,is_default,register_date) VALUES(_id_video,_id_storage,_id_cdn,_file_name,_extension,_width,_height,_version,_version_type,_size,_bitrate,_audio_bitrate,_is_default,now());
	SET p_last_id = last_insert_id();
	SELECT id_version,id_video,id_storage,id_cdn,filename,extension,width,height,version,version_type,size,state,bitrate,audio_bitrate,is_default FROM video_versions WHERE id_version = p_last_id;
ELSE
	SELECT -2 as return_code;
END IF;

COMMIT;

END;

