DROP PROCEDURE IF EXISTS SP_SET_POSTS_L10N_TO_LABELS;
create
    definer = skoiypp@`%` procedure SP_SET_POSTS_L10N_TO_LABELS(IN _id_label int, IN _id_l10n int)
BEGIN



DECLARE exit handler for sqlexception
  BEGIN

    SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_label FROM posts_labels WHERE id_label = _id_label) AND EXISTS (SELECT id_l10n FROM posts_l10n WHERE id_l10n = _id_l10n)
THEN

    IF NOT EXISTS(SELECT id_label FROM posts_labels_related WHERE id_label = _id_label AND id_l10n = _id_l10n)
    THEN
        INSERT INTO posts_labels_related(id_label,id_l10n,position,register_date) VALUES(_id_label,_id_l10n,0,now());
		SELECT pl.id_label, name,name_stripped, public, FN_GET_POSTS_TOTAL_POSTS_BY_ID_LABEL(id_label) as total FROM posts_labels pl WHERE pl.id_label = _id_label;
    ELSE
         SELECT -3 as return_code;
    END IF;

ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

