create
    definer = skoiypp@`%` function FN_GET_ARCHIVE_PULL_PATH(_id_account int, _field varchar(255), _type varchar(255)) returns varchar(255)
BEGIN

  DECLARE _path varchar(255); 

IF(_type = 'STORAGE')
THEN
        CASE
        WHEN _field = 'VIDEOS' THEN
            SELECT FN_GET_ARCHIVE_STORAGE_PATH(source) into _path FROM accounts_archive_source_settings WHERE id_account = _id_account AND current_active = 1 ORDER BY id desc limit 0,1;
        WHEN _field = 'CLIPS' THEN
            SELECT FN_GET_ARCHIVE_STORAGE_PATH(source_clips) into _path FROM accounts_archive_source_clips_settings WHERE id_account = _id_account AND current_active = 1 ORDER BY id desc limit 0,1;
        WHEN _field = 'VIDEOS_PREVIEWS' THEN
            SELECT FN_GET_ARCHIVE_STORAGE_PATH(source_previews) into _path FROM accounts_archive_source_previews_settings WHERE id_account = _id_account AND current_active = 1 ORDER BY id desc limit 0,1;
        WHEN _field = 'CLIPS_PREVIEWS' THEN
            SELECT FN_GET_ARCHIVE_STORAGE_PATH(source_clips_previews) into _path FROM accounts_archive_source_clips_previews_settings WHERE id_account = _id_account AND current_active = 1 ORDER BY id desc limit 0,1;
		 ELSE
			 SELECT 0 into _path;    
        END CASE;
END IF;
IF(_type = 'CDN')
THEN
        CASE
        WHEN _field = 'VIDEOS' THEN
            SELECT FN_GET_CDN_ARCHIVE_PATH(cdn_source) into _path FROM accounts_archive_source_settings WHERE id_account = _id_account AND current_active = 1 ORDER BY id desc limit 0,1;
        WHEN _field = 'CLIPS' THEN
            SELECT FN_GET_CDN_ARCHIVE_PATH(cdn_source_clips) into _path FROM accounts_archive_source_clips_settings WHERE id_account = _id_account AND current_active = 1 ORDER BY id desc limit 0,1;
        WHEN _field = 'VIDEOS_PREVIEWS' THEN
            SELECT FN_GET_CDN_ARCHIVE_PATH(cdn_source_previews) into _path FROM accounts_archive_source_previews_settings WHERE id_account = _id_account AND current_active = 1 ORDER BY id desc limit 0,1;
        WHEN _field = 'CLIPS_PREVIEWS' THEN
            SELECT FN_GET_CDN_ARCHIVE_PATH(cdn_source_clips_previews) into _path FROM accounts_archive_source_clips_previews_settings WHERE id_account = _id_account AND current_active = 1 ORDER BY id desc limit 0,1;
		 ELSE
			 SELECT 0 into _path;    
        END CASE;
END IF;
      
RETURN _path;

END;

