create
    definer = skoiypp@`%` procedure SP_GET_ACCOUNT_LIVE_SERVER_SETTINGS(IN _id_account int, IN _id_live int,
                                                                        IN _field int(10), IN _query varchar(192),
                                                                        IN _filter varchar(192), IN _limit_a int,
                                                                        IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_query = _query;
SET @_id_account = _id_account;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;
SET @_id_live = _filter;
SET @_stream = _filter;
SET @_record = _filter;
SET @_dvr = _filter;

IF(_id_account = 0)
THEN
	SELECT id_live,FN_GET_CDN_LIVE_PATH(cdn_live) as cdn, name, application,server,stream,dvr,record,FN_GET_LIVE_HAS_CLIPPING_ACTIVE(id_live) as has_clipping FROM accounts_live_server_settings WHERE id_live = _id_live;
ELSE
IF EXISTS (SELECT id_account FROM accounts WHERE id_account = _id_account)
THEN

	IF(_id_live > 0 AND _field <> 1)
	THEN
		SELECT id_live,FN_GET_CDN_LIVE_PATH(cdn_live) as cdn, name, application,server,stream,dvr,record,FN_GET_LIVE_HAS_CLIPPING_ACTIVE(id_live) as has_clipping FROM accounts_live_server_settings WHERE id_account = _id_account AND id_live = _id_live;
	ELSE

		IF(_limit_b = -1)
		THEN
			SELECT count(1) into _limit_b FROM accounts_live_server_settings WHERE id_account = _id_account;
			SET @_limit_b = _limit_b;
		END IF;

		SET sqlcommand = "SELECT id_live,FN_GET_CDN_LIVE_PATH(cdn_live) as cdn, name, application,server,stream,dvr,record,FN_GET_LIVE_HAS_CLIPPING_ACTIVE(id_live) as has_clipping FROM accounts_live_server_settings WHERE id_account = @_id_account ";

	IF(_query <> '')
	THEN
	   SET @_query = CONCAT("%",_query,"%");
	   SET sqlcommand = CONCAT(sqlcommand," AND name like @_query ");
	END IF;

	CASE
	WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_live = @_id_live ");
	WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND stream = @_stream ");
	WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND record = @_record ");
	WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND dvr = @_dvr ");
	WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_LIVE_HAS_CLIPPING_ACTIVE(id_live) = 0 ");
	WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_LIVE_HAS_CLIPPING_ACTIVE(id_live) = 1 ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1  ");
	END CASE;

	SET sqlcommand = CONCAT(sqlcommand," ORDER BY name LIMIT ?,?");
	SET @sqlcommand = sqlcommand;
	   
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b;

	END IF;
ELSE
    SELECT -2 as return_code;
END IF;

END IF;

COMMIT;

END;

