create
    definer = skoiypp@`%` procedure SP_GET_ADS_EXTERNAL_AD_TAGS(IN _field int(10), IN _query varchar(192),
                                                                IN _filter varchar(192), IN _limit_a int,
                                                                IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM ads_external_ad_tags;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_id_campaign = _filter;
SET @_id_external_ad_tag = _filter;
SET @_num_x = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_external_ad_tag,name,tag,active, FN_GET_ADS_EXTERNAL_TAGS_TOTAL_CAMPAIGNS(id_external_ad_tag) as total_campaigns, register_date FROM ads_external_ad_tags aext ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE active = 1 AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE active = 0 AND name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_external_ad_tag in (SELECT distinct id_external_ad_tag FROM ads_campaigns_groups_external_ad_tags) AND name like @_name ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_external_ad_tag in (SELECT distinct id_external_ad_tag FROM ads_campaigns_groups_external_ad_tags WHERE id_campaign_group in (SELECT id_campaign_group FROM ads_campaigns_groups WHERE id_campaign = @_id_campaign) AND name like @_name ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_external_ad_tag = @_id_external_ad_tag ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
   
COMMIT;

END;

