create
    definer = skoiypp@`%` procedure SP_GET_ADS_VIDEOS_DATES(IN _id_directory int, IN _field int(10),
                                                            IN _field_snd int(10), IN _field_trd int(10),
                                                            IN _query varchar(192), IN _filter varchar(192),
                                                            IN _filter_snd varchar(192), IN _filter_trd varchar(192),
                                                            IN _limit_sys_a bigint, IN _limit_sys_b bigint)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_ad = _filter_snd;
SET @_name = CONCAT("%",_query,"%");
SET @_id_directory = _id_directory;

	SET sqlcommand = "SELECT year(register_date) as year, month(register_date) as month,count(1) as total FROM ads_videos av WHERE av.deleted = 0 ";

	IF(_id_directory > 0)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND av.id_directory = @_id_directory ");
	END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.id_ad = @_id_ad ) ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	IF (_query <> '')
	THEN
		SET sqlcommand =  CONCAT(sqlcommand, " AND av.name like @_name ");
	END IF;

	SET sqlcommand =  CONCAT(sqlcommand, " GROUP BY year,month ORDER by year,month ");

	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;

COMMIT;

END;

