create
    definer = skoiypp@`%` procedure SP_GET_ADS_VIDEOS_TAGS_RELATED(IN _id_ad int, IN _id_directory int,
                                                                   IN _field int(10), IN _field_snd int(10),
                                                                   IN _field_trd int(10), IN _query varchar(192),
                                                                   IN _filter varchar(192), IN _filter_snd varchar(192),
                                                                   IN _filter_trd varchar(192), IN _limit_sys_a bigint,
                                                                   IN _limit_sys_b bigint)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_ad = _id_ad;
SET @_id_ad = @_filter_snd;
SET @_name = CONCAT("%",_query,"%");
SET @_cfilter = _filter;
SET @_filter = CONCAT("%",_filter,"%");

SET @_limit_sys_a = _limit_sys_a;
SET @_limit_sys_b = _limit_sys_b;
SET @_id_directory = _id_directory;

IF(_id_ad < 1)
THEN
	SET sqlcommand = "SELECT at.id_tag,at.name,name_stripped, public, (SELECT count(1) FROM ads_videos_tags_related avtr_sub WHERE id_tag = at.id_tag AND avtr_sub.id_ad in (SELECT id_ad FROM ads_videos av WHERE av.deleted = 0  ";
	
	IF (_id_directory > 0)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND av.id_directory = @_id_directory ");
	END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.id_ad = @_id_ad ) ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	CASE
	WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND av.name like @_name ");
	WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.state = @_cfilter) AND (av.name like @_name) ");
	WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.height like @_filter) AND (av.name like @_name) ");
	WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.ratio like @_filter) AND (av.name like @_name) ");
	WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.mime_type like @_filter) AND (av.name like @_name) ");
	WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.size BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (av.name like @_name ) ");
	WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.seconds BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (av.name like @_name ) ");
	WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.bitrate BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (av.name like @_name ) ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
	END CASE;

	SET sqlcommand = CONCAT(sqlcommand," )) as total_ads FROM ads_videos_tags_related avtr, ads_tags at, ads_videos av2 WHERE at.id_tag = avtr.id_tag AND av2.id_ad = avtr.id_ad AND av2.deleted = 0 GROUP BY id_tag ORDER by name ");

	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;
ELSE
	IF EXISTS(SELECT id_ad FROM ads_videos_tags_related WHERE id_ad = _id_ad)
	THEN
		SELECT at.id_tag,at.name,name_stripped, public, (SELECT count(1) FROM ads_videos_tags_related WHERE id_tag = at.id_tag) as total_ads FROM ads_videos_tags_related avtr, ads_tags at, ads_videos av WHERE at.id_tag = avtr.id_tag AND av.id_ad = avtr.id_ad AND av.deleted = 0 AND avtr.id_ad = _id_ad;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;
        
COMMIT;

END;

