create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_SHARE_AND_DOWNLOAD_CONTENT(IN _id_shr_dld INT, IN _field INT,
                                                                              IN _limit_a int(10), IN _limit_b int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
	IF(_field = 1)
	THEN
		SELECT count(1) into _limit_b FROM archive_share_and_download_video_selected asdvs, archive_videos a WHERE asdvs.id_video = a.id_video AND id_shr_dld = _id_shr_dld AND a.deleted = 0;
	ELSE
		SELECT count(1) into _limit_b FROM archive_share_and_download_clip_selected asdcs, archive_clips a WHERE asdcs.id_clip = a.id_clip AND id_shr_dld = _id_shr_dld AND a.deleted = 0;
	END IF;
END IF;

SET @_id_shr_dld = _id_shr_dld;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

IF (SELECT count(1) FROM archive_share_and_download WHERE id_shr_dld = _id_shr_dld)
THEN

	IF(_field = 1)
	THEN
	SET sqlcommand = "SELECT id_video,id_directory,id_storage,id_cdn,name,filename,seconds,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,framerate,framecount,width,height,ratio,state,FN_GET_ARCHIVE_ROOMS_GROUPED(id_video,@id_user) as rooms,register_date,FN_GET_ARCHIVE_VIDEO_HAS_CLIPS(id_video) as has_clips, FN_GET_ARCHIVE_VIDEO_IN_TRANSFER(id_video) as in_transfer,FN_GET_ARCHIVE_VIDEO_HAS_PREVIEW(id_video) has_preview,FN_GET_ARCHIVE_VIDEO_THUMBNAIL(id_video) as thumbnail, FN_GET_ARCHIVE_VIDEOS_TAGS_GROUPED(v.id_video) as tags,FN_GET_ARCHIVE_VIDEO_TOTAL_CLIPS(id_video) as total_clips FROM archive_videos v WHERE deleted = 0
	 AND id_video in (SELECT id_video FROM archive_share_and_download_video_selected WHERE id_shr_dld = @_id_shr_dld) LIMIT ?,?";
	ELSE
	SET sqlcommand = "SELECT id_clip,id_directory,id_storage,id_cdn,FN_GET_ARCHIVE_VIDEO_WAS_DELETED(id_video) as id_video,name,filename,seconds,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,framerate,framecount,width,height,ratio,state,register_date,FN_GET_ARCHIVE_CLIP_HAS_RELATED(id_video) as has_related_clips, FN_GET_ARCHIVE_CLIP_IN_TRANSFER(id_clip) as in_transfer,FN_GET_ARCHIVE_CLIP_HAS_PREVIEW(id_clip) has_preview,FN_GET_ARCHIVE_CLIP_THUMBNAIL(id_clip) as thumbnail, FN_GET_ARCHIVE_CLIPS_TAGS_GROUPED(v.id_clip) as tags FROM archive_clips v WHERE deleted = 0 
	AND id_clip in (SELECT id_clip FROM archive_share_and_download_clip_selected WHERE id_shr_dld = @_id_shr_dld) LIMIT ?,?";
	END IF;

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b; 
ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

