create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_ALBUMS(IN _id_directory int(10), IN _field int(10),
                                                         IN _field_snd int(10), IN _field_trd int(10),
                                                         IN _query varchar(192), IN _filter varchar(192),
                                                         IN _filter_snd varchar(192), IN _filter_trd varchar(192),
                                                         IN _limit_a int, IN _limit_b int, IN _order_by int(10),
                                                         IN _order int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM albums;
END IF;

SET @_query = _query;
SET @_name = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_id_album = _filter_snd;
SET @_directories = _filter_trd;
SET @_tags_group = _filter_trd;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;
SET @_id_directory = _id_directory;

IF(_id_directory = -1)
THEN

	SET sqlcommand = "SELECT id_album,id_directory, name, description, link, random,FN_GET_ASSETS_NUM_IMAGENS_ON_ALBUMS(id_album) as total_images, FN_GET_ASSETS_LAST_IMAGE_ON_ALBUM(id_album) as cover_image, register_date FROM albums WHERE id_directory is null "; 
	SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name DESC LIMIT ?,?");

	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b;

ELSE

	IF (_id_directory = 0) OR (SELECT count(1) FROM assets_albums_directories WHERE id_directory = _id_directory)
	THEN

		SET sqlcommand = "SELECT id_album,id_directory, name, description, link, random,FN_GET_ASSETS_NUM_IMAGENS_ON_ALBUMS(id_album) as total_images, FN_GET_ASSETS_LAST_IMAGE_ON_ALBUM(id_album) as cover_image, register_date FROM albums WHERE FN_GET_ASSETS_ALBUM_DIRECTORY_IS_DELETED(id_directory) = 0 "; 

		IF (_id_directory > 0)
		THEN
		   SET sqlcommand = CONCAT(sqlcommand," AND id_directory = @_id_directory ");
		END IF;







		IF (_field_snd > 0)
		THEN
			CASE
				WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_album = @_id_album ) ");
			ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
			END CASE;
		END IF;
        
		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1000 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (FIND_IN_SET(id_directory, @_directories)) ");
				WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_album in (SELECT id_album FROM albums_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) ) ");	
			ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
			END CASE;
		END IF;

                
        	CASE
				WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (name like @_name OR description like @_description)");
				WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
				WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
			ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
			END CASE;
        
		CASE
			
			WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY name ASC ");
			WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date ASC ");
			WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY total_images ASC ");

			WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY name ASC ");
			WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date ASC ");
			WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY total_images ASC ");

			WHEN _order_by = 10000 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY name DESC ");
			WHEN _order_by = 10001 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date DESC ");
			
		ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC  ");
		END CASE;

		SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");
		SET @sqlcommand = sqlcommand;
		   
		PREPARE stmt FROM @sqlcommand;
		EXECUTE stmt USING @_limit_a,@_limit_b;

	ELSE
	    SELECT -2 as return_code;
	END IF;		

END IF;
        
COMMIT;

END;

