create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_ALBUMS_COUNT(IN _id_directory int(10), IN _field int(10),
                                                               IN _field_snd int(10), IN _field_trd int(10),
                                                               IN _query varchar(192), IN _filter varchar(192),
                                                               IN _filter_snd varchar(192), IN _filter_trd varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_query = _query;
SET @_name = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_id_album = _filter_snd;
SET @_directories = _filter_trd;
SET @_id_directory = _id_directory;
SET @_tags_group = _filter_trd;

IF(_id_directory = -1)
THEN

	SET sqlcommand = "SELECT count(1) as total FROM albums WHERE id_directory is null "; 

	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;

ELSE

	IF (_id_directory = 0) OR (SELECT count(1) FROM assets_albums_directories WHERE id_directory = _id_directory)
	THEN

		SET sqlcommand = "SELECT count(1) as total FROM albums WHERE FN_GET_ASSETS_ALBUM_DIRECTORY_IS_DELETED(id_directory) = 0 "; 

		IF (_id_directory > 0)
		THEN
		   SET sqlcommand = CONCAT(sqlcommand," AND id_directory = @_id_directory ");
		END IF;

		IF (_field_snd > 0)
		THEN
			CASE
				WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_album = @_id_album ) ");
			ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
			END CASE;
		END IF;
        
		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1000 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (FIND_IN_SET(id_directory, @_directories)) ");
				WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_album in (SELECT id_album FROM albums_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) ) ");				
			ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
			END CASE;
		END IF;

        	CASE
				WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (name like @_name OR description like @_description)");
				WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
				WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
			ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
			END CASE;
		   
	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;

	ELSE
	    SELECT -2 as return_code;
	END IF;		

END IF;
        
COMMIT;

END;

