create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_IPTC(IN _id_asset int(10))
BEGIN

DECLARE _Creator varchar(255);
DECLARE _CreatorJobtitle varchar(255);
DECLARE _CiAdrExtadr varchar(255);
DECLARE _CiAdrCity varchar(255);
DECLARE _CiAdrRegion varchar(255);
DECLARE _CiAdrPcode varchar(255); 
DECLARE _CiAdrCtry varchar(255); 
DECLARE _CiTelWork varchar(255);
DECLARE _CiEmailWork varchar(255); 
DECLARE _CiUrlWork varchar(255);

DECLARE _Headline varchar(255);
DECLARE _Description varchar(255);
DECLARE _Keywords varchar(255);
DECLARE _SubjectCode varchar(255);
DECLARE _DescriptionWriter varchar(255);

DECLARE _DateCreated datetime;
DECLARE _IntellectualGenre varchar(255);
DECLARE _Scene varchar(255);
DECLARE _Location varchar(255);
DECLARE _City varchar(255);
DECLARE _ProvinceState varchar(255);
DECLARE _Country varchar(255);
DECLARE _CountryCode varchar(255);

DECLARE _Title varchar(255);
DECLARE _JobID varchar(255);
DECLARE _Instructions varchar(255);
DECLARE _Credit varchar(255);
DECLARE _Source varchar(255);
DECLARE _CopyrightNotice varchar(255);
DECLARE _RightsUsageTerms varchar(255);

DECLARE _ArtworkOrObject varchar(255);
DECLARE _ArtworkOrObjectAOTitle varchar(255);
DECLARE _ArtworkOrObjectAODateCreated varchar(255);
DECLARE _ArtworkOrObjectAOCreator varchar(255);
DECLARE _ArtworkOrObjectAOSource varchar(255);
DECLARE _ArtworkOrObjectAOSourceInvNo varchar(255);
DECLARE _ArtworkOrObjectAOCopyrightNotice varchar(255);

DECLARE _PersonInImage varchar(255);
DECLARE _LocationCreatedSublocation varchar(255);
DECLARE _LocationCreatedCity varchar(255);   
DECLARE _LocationCreatedProvinceState varchar(255);
DECLARE _LocationCreatedCountryName varchar(255);
DECLARE _LocationCreatedCountryCode varchar(255);
DECLARE _LocationCreatedWorldRegion varchar(255);

DECLARE _LocationShownSublocation varchar(255);
DECLARE _LocationShownCity varchar(255);
DECLARE _LocationShownProvinceState varchar(255);
DECLARE _LocationShownCountryName varchar(255);
DECLARE _LocationShownCountryCode varchar(255);
DECLARE _LocationShownWorldRegion varchar(255);

DECLARE _AddlModelinfo varchar(255);
DECLARE _ModelAge varchar(255);
DECLARE _ModelReleaseID varchar(255);

DECLARE _OrganisationInImageName varchar(255);
DECLARE _OrganisationInImageCode varchar(255);
DECLARE _Event varchar(255);

DECLARE _ImageSupplier varchar(255);
DECLARE _ImageSupplierID varchar(255);
DECLARE _ImageSupplierImageID varchar(255);
DECLARE _RegistryID varchar(255);
DECLARE _RegistryIDRegOrgID varchar(255);
DECLARE _RegistryIDRegItemID varchar(255);
DECLARE _MaxAvailWidth varchar(255);
DECLARE _MaxAvailHeight varchar(255);
DECLARE _DigitalSourceType varchar(255);

DECLARE _ImageCreatorName varchar(255);
DECLARE _ImageCreatorID varchar(255);
DECLARE _CopyrightOwnerName varchar(255);
DECLARE _CopyrightOwnerID varchar(255);
DECLARE _LicensorName varchar(255);
DECLARE _LicensorID varchar(255);
DECLARE _LicensorTelephone1 varchar(255);
DECLARE _LicensorTelephone2 varchar(255);
DECLARE _LicensorEmail varchar(255);
DECLARE _PropertyReleaseID varchar(255);


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS(SELECT id_asset FROM assets WHERE id_asset = _id_asset)
THEN

	SELECT Creator,CreatorJobtitle,CiAdrExtadr,CiAdrCity,CiAdrRegion,CiAdrPcode,CiAdrCtry,CiTelWork,CiEmailWork,CiUrlWork 
	into _Creator,_CreatorJobtitle,_CiAdrExtadr,_CiAdrCity,_CiAdrRegion,_CiAdrPcode,_CiAdrCtry,_CiTelWork,_CiEmailWork,_CiUrlWork
	FROM assets_iptc_core_contact WHERE id_asset = _id_asset;

	SELECT Headline,Description,Keywords,SubjectCode,DescriptionWriter 
	into _Headline,_Description,_Keywords,_SubjectCode,_DescriptionWriter
	FROM assets_iptc_core_content WHERE id_asset = _id_asset;

	SELECT DateCreated,IntellectualGenre,Scene,Location,City,ProvinceState,Country,CountryCode 
	into _DateCreated,_IntellectualGenre,_Scene,_Location,_City,_ProvinceState,_Country,_CountryCode
	FROM assets_iptc_core_image WHERE id_asset = _id_asset;

    SELECT Title,JobID,Instructions,Credit,Source,CopyrightNotice,RightsUsageTerms 
	into _Title,_JobID,_Instructions,_Credit,_Source,_CopyrightNotice,_RightsUsageTerms    
    FROM assets_iptc_core_status WHERE id_asset = _id_asset;



	SELECT ArtworkOrObject,ArtworkOrObjectAOTitle,ArtworkOrObjectAODateCreated,ArtworkOrObjectAOCreator,ArtworkOrObjectAOSource,ArtworkOrObjectAOSourceInvNo,ArtworkOrObjectAOCopyrightNotice 
	into _ArtworkOrObject,_ArtworkOrObjectAOTitle,_ArtworkOrObjectAODateCreated,_ArtworkOrObjectAOCreator,_ArtworkOrObjectAOSource,_ArtworkOrObjectAOSourceInvNo,_ArtworkOrObjectAOCopyrightNotice
	FROM assets_iptc_extension_artwork WHERE id_asset = _id_asset;

    SELECT PersonInImage,LocationCreatedSublocation,LocationCreatedCity,LocationCreatedProvinceState,LocationCreatedCountryName,LocationCreatedCountryCode,LocationCreatedWorldRegion
    into _PersonInImage,_LocationCreatedSublocation,_LocationCreatedCity,_LocationCreatedProvinceState,_LocationCreatedCountryName,_LocationCreatedCountryCode,_LocationCreatedWorldRegion
    FROM assets_iptc_extension_location_created WHERE id_asset = _id_asset;

    SELECT LocationShownSublocation,LocationShownCity,LocationShownProvinceState,LocationShownCountryName,LocationShownCountryCode,LocationShownWorldRegion 
    into _LocationShownSublocation,_LocationShownCity,_LocationShownProvinceState,_LocationShownCountryName,_LocationShownCountryCode,_LocationShownWorldRegion
    FROM assets_iptc_extension_location_shown WHERE id_asset = _id_asset;

    SELECT AddlModelInfo,ModelAge,ModelReleaseID 
    into _AddlModelInfo,_ModelAge,_ModelReleaseID
    FROM assets_iptc_extension_models_image WHERE id_asset = _id_asset;

    SELECT OrganisationInImageName,OrganisationInImageCode,Event 
	into _OrganisationInImageName,_OrganisationInImageCode,_Event    
    FROM assets_iptc_extension_organisation WHERE id_asset = _id_asset;

    SELECT ImageSupplier,ImageSupplierID,ImageSupplierImageID,RegistryID,RegistryIDRegOrgID,RegistryIDRegItemID,MaxAvailWidth,MaxAvailHeight,DigitalSourceType 
    into _ImageSupplier,_ImageSupplierID,_ImageSupplierImageID,_RegistryID,_RegistryIDRegOrgID,_RegistryIDRegItemID,_MaxAvailWidth,_MaxAvailHeight,_DigitalSourceType
    FROM assets_iptc_extension_administrative_information WHERE id_asset = _id_asset;

    SELECT ImageCreatorName,ImageCreatorID,CopyrightOwnerName,CopyrightOwnerID,LicensorName,LicensorID,LicensorTelephone1,LicensorTelephone2,LicensorEmail,PropertyReleaseID 
    into _ImageCreatorName,_ImageCreatorID,_CopyrightOwnerName,_CopyrightOwnerID,_LicensorName,_LicensorID,_LicensorTelephone1,_LicensorTelephone2,_LicensorEmail,_PropertyReleaseID
    FROM assets_iptc_extension_rights_related WHERE id_asset = _id_asset;

    SELECT 
_id_asset as id_asset,
_Creator as Creator,
_CreatorJobtitle as CreatorJobtitle,
_CiAdrExtadr as CiAdrExtadr,
_CiAdrCity as CiAdrCity,
_CiAdrRegion as CiAdrRegion,
_CiAdrPcode as CiAdrPcode,
_CiAdrCtry as CiAdrCtry,
_CiTelWork as CiTelWork,
_CiEmailWork as CiEmailWork,
_CiUrlWork as CiUrlWork,
_Headline as Headline,
_Description as Description,
_Keywords as Keywords,
_SubjectCode as SubjectCode,
_DescriptionWriter as DescriptionWriter,
_DateCreated as DateCreated,
_IntellectualGenre as IntellectualGenre,
_Scene as Scene,
_Location as Location,
_City as City,
_ProvinceState as ProvinceState,
_Country as Country,
_CountryCode as CountryCode,
_Title as Title,
_JobID as JobID,
_Instructions as Instructions,
_Credit as Credit,
_Source as Source,
_CopyrightNotice as CopyrightNotice,
_RightsUsageTerms as RightsUsageTerms,
_ArtworkOrObject as ArtworkOrObject,
_ArtworkOrObjectAOTitle as ArtworkOrObjectAOTitle,
_ArtworkOrObjectAODateCreated as ArtworkOrObjectAODateCreated,
_ArtworkOrObjectAOCreator as ArtworkOrObjectAOCreator,
_ArtworkOrObjectAOSource as ArtworkOrObjectAOSource,
_ArtworkOrObjectAOSourceInvNo as ArtworkOrObjectAOSourceInvNo,
_ArtworkOrObjectAOCopyrightNotice as ArtworkOrObjectAOCopyrightNotice,
_PersonInImage as PersonInImage,
_LocationCreatedSublocation as LocationCreatedSublocation,
_LocationCreatedCity as LocationCreatedCity,
_LocationCreatedProvinceState as LocationCreatedProvinceState,
_LocationCreatedCountryName as LocationCreatedCountryName,
_LocationCreatedCountryCode as LocationCreatedCountryCode,
_LocationCreatedWorldRegion as LocationCreatedWorldRegion,
_LocationShownSublocation as LocationShownSublocation,
_LocationShownCity as LocationShownCity,
_LocationShownProvinceState as LocationShownProvinceState,
_LocationShownCountryName as LocationShownCountryName,
_LocationShownCountryCode as LocationShownCountryCode,
_LocationShownWorldRegion as LocationShownWorldRegion,
_AddlModelInfo as AddlModelInfo,
_ModelAge as ModelAge,
_ModelReleaseID as ModelReleaseID,
_OrganisationInImageName as OrganisationInImageName,
_OrganisationInImageCode as OrganisationInImageCode,
_Event as Event,
_ImageSupplier as ImageSupplier,
_ImageSupplierID as ImageSupplierID,
_ImageSupplierImageID as ImageSupplierImageID,
_RegistryID as RegistryID,
_RegistryIDRegOrgID as RegistryIDRegOrgID,
_RegistryIDRegItemID as RegistryIDRegItemID,
_MaxAvailWidth as MaxAvailWidth,
_MaxAvailHeight as MaxAvailHeight,
_DigitalSourceType as DigitalSourceType,
_ImageCreatorName as ImageCreatorName,
_ImageCreatorID as ImageCreatorID,
_CopyrightOwnerName as CopyrightOwnerName,
_CopyrightOwnerID as CopyrightOwnerID,
_LicensorName as LicensorName,
_LicensorID as LicensorID,
_LicensorTelephone1 as LicensorTelephone1,
_LicensorTelephone2 as LicensorTelephone2,
_LicensorEmail as LicensorEmail,
_PropertyReleaseID as PropertyReleaseID;

ELSE
	SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

