create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_SHARE_AND_DOWNLOADS_COUNT(IN _field int(10), IN _query varchar(192), IN _filter varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_query = CONCAT("%",_query,"%");
SET @_cfilter = _filter;

SET sqlcommand = "SELECT count(1) as total FROM assets_share_and_download "; 

CASE
WHEN _field = 1 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (name like @_query or code like @_query ) ");
WHEN _field = 2 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (name like @_query ) ");
WHEN _field = 3 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (code like @_query ) ");
WHEN _field = 4 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (active = @_cfilter ) ");
WHEN _field = 5 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (compress_enabled = @_cfilter ) ");
WHEN _field = 6 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (compress_running = @_cfilter ) ");
WHEN _field = 7 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (compress_completed = @_cfilter ) ");
WHEN _field = 8 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (compress_enabled = 1 AND compress_running = 0 AND compress_completed = 0) ");

ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;    
 
COMMIT;

END;

