create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_TAGS_RELATED(IN _room varchar(5), IN _id_user int(10),
                                                               IN _id_asset INT, IN _id_directory int(10),
                                                               IN _field int(10), IN _field_snd int(10),
                                                               IN _field_trd int(10), IN _query varchar(192),
                                                               IN _filter varchar(192), IN _filter_snd varchar(192),
                                                               IN _filter_trd varchar(192), IN _limit_sys_a bigint,
                                                               IN _limit_sys_b bigint)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @room = _room;
SET @id_user = _id_user;


SET @_id_asset = _filter_snd;
SET @_id_album = _filter_snd;
SET @_room = _filter_snd;
SET @label = _filter_snd;
SET @id_label = _filter_snd;

SET @_year = year(_filter);
SET @_month = month(_filter);

SET @_filterTypes = _filter_trd;
SET @_tags_group = _filter_trd;

SET @_name = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_cfilter = _filter;
SET @_filter = CONCAT("%",_filter,"%");

SET @_limit_sys_a = _limit_sys_a;
SET @_limit_sys_b = _limit_sys_b;
SET @_id_directory = _id_directory;

SET @_year = year(_filter);
SET @_month = month(_filter);
SET @_day = day(_filter);

IF(_query = '')
THEN
	SET _field = 99;
END IF;
	
IF(_id_asset < 1)
THEN

	SET sqlcommand = "SELECT at.id_tag,at.id_group,at.name,name_stripped, public, (SELECT count(1) FROM assets_tags_related atr_sub WHERE id_tag = at.id_tag AND atr_sub.id_asset in (SELECT id_asset FROM assets a WHERE a.deleted = 0  ";

	IF (_room <> '')
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND FN_GET_ASSETS_ASSET_IN_ROOM(a.id_asset,@id_user,@room) = 1 ");
	END IF;

	IF (_id_directory > 0)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND a.id_directory = @_id_directory ");
	END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.id_asset = @_id_asset ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.id_asset in (SELECT distinct id_asset FROM assets_albums_related) ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.id_asset in (SELECT distinct id_asset FROM assets_transfers_related) ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.id_asset in (SELECT distinct id_asset FROM assets_rooms_related) ) ");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.id_asset in (SELECT distinct id_asset FROM assets_rooms_related AND room = @_room) ) ");
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.id_asset in (SELECT distinct id_asset FROM assets_albums_related WHERE id_album = @_id_album) ) ");
			WHEN _field_snd = 106 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND filename like @_filename ");
			
            WHEN _field_snd = 107 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT id_asset FROM assets_labels_related) ) ");
			WHEN _field_snd = 108 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT id_asset FROM assets_labels_related WHERE (id_label = @id_label OR id_label in (SELECT id_label FROM assets_labels WHERE name_stripped = @label)) )) ");

			WHEN _field_snd = 114 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT distinct id_asset FROM posts_l10n_photos) ) ");
			WHEN _field_snd = 115 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT distinct id_asset FROM posts_l10n_photos WHERE id_l10n in (SELECT id_l10n FROM posts_l10n WHERE id_post = @_id_post)) OR filename in (SELECT image FROM posts_l10n WHERE id_post = @_id_post)) ");       
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;
    
	IF (_field_trd > 0)
	THEN
		CASE
			WHEN _field_trd = 1000 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_asset in (SELECT id_asset FROM assets_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) ) ");
			WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_ASSETS_IS_FILE_TYPE(id_asset,@_filterTypes) = 1 ");
			WHEN _field_trd = 2000 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_ASSETS_IS_FILE_TYPE(id_asset,'IMAGE') = 1 AND id_asset in (SELECT id_asset FROM assets_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) ) ");
			WHEN _field_trd = 2001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_ASSETS_IS_FILE_TYPE(id_asset,'AUDIO') = 1 AND id_asset in (SELECT id_asset FROM assets_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) ) ");
			WHEN _field_trd = 2002 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_ASSETS_IS_FILE_TYPE(id_asset,'DOC,COMPRESS') = 1 AND id_asset in (SELECT id_asset FROM assets_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) ) ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	CASE
	WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.name like @_name OR a.description like @_description OR FN_GET_ASSETS_SEARCH(a.id_asset,@_name) = 1) ");
	WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND a.name like @_name ");
	WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND a.description like @_description ");
	WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.name like @_name OR a.description like @_description) ");
	WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(a.register_date) = @_year AND month(a.register_date) = @_month) AND (a.name like @_name OR a.description like @_description) ");
	WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(a.register_date) = @_year) AND (a.name like @_name OR a.description like @_description) ");
	WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.state = @_cfilter) AND (a.name like @_name OR a.description like @_description) ");
	WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.mime_type like @_filter) AND (a.name like @_name OR a.description like @_description) ");
	WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (CONCAT(a.width,'x',a.height) like @_filter) AND (a.name like @_name OR a.description like @_description) ");
	WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (a.size BETWEEN @_limit_size_a AND @_limit_size_b) AND (a.name like @_name OR a.description like @_description) ");
    
	WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) AND day(register_date) = @_day) ");
	WHEN _field = 12 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) ");
	WHEN _field = 13 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year) ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
	END CASE;

	SET sqlcommand = CONCAT(sqlcommand," )) as total FROM assets_tags_related atr, assets_tags at, assets a2 WHERE at.id_tag = atr.id_tag AND a2.id_asset = atr.id_asset AND a2.deleted = 0 GROUP BY id_tag ORDER by name ");
	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;

ELSE
	IF EXISTS(SELECT id_asset FROM assets_tags_related WHERE id_asset = _id_asset)
	THEN
	    SELECT at.id_tag,id_group,name,name_stripped, public, (SELECT count(1) FROM assets_tags_related WHERE id_tag = at.id_tag) as total FROM assets_tags_related atr, assets_tags at WHERE at.id_tag = atr.id_tag AND atr.id_asset = _id_asset ORDER BY position;
	ELSE
	    SELECT -2 as return_code;
	END IF;
END IF;	
        
COMMIT;

END;

