create
    definer = skoiypp@`%` procedure SP_GET_LIVE_PLAYLISTS_ON_CHANNELS_COUNT(IN _id_channel int, IN _name varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_channel = _id_channel;

SET @_name = _name;

SET sqlcommand = "SELECT count(1) as total
	FROM playlists_channels_related pcr, playlists p WHERE p.id_playlist = pcr.id_playlist AND pcr.id_channel = ? ";

IF(_name <> '')
THEN
   SET @_name = CONCAT("%",_name,"%");
   SET sqlcommand = CONCAT(sqlcommand," AND (p.management_name like ? OR p.name like ? ) ");
END IF;

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

CASE
WHEN _name <> '' THEN
EXECUTE stmt USING @_id_channel,@_name,@_name;
ELSE 
EXECUTE stmt USING @_id_channel;    
END CASE;

COMMIT;

END;

