create
    definer = skoiypp@`%` procedure SP_GET_POSTS(IN _field int(10), IN _query varchar(192), IN _filter varchar(192),
                                                 IN _iso_lang varchar(10), IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1 OR _limit_b = 0)
THEN
	IF(_iso_lang = '')
	THEN
		SELECT count(1) into _limit_b FROM posts_l10n;
	ELSE
		SELECT count(1) into _limit_b FROM posts_l10n WHERE iso_language = _iso_lang;
	END IF;
END IF;

SET @_body = CONCAT("%",_query,"%");
SET @_title = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_iso_lang = _iso_lang;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET @_year = year(_filter);
SET @_month = month(_filter);

IF(_iso_lang = '')
THEN
	SET sqlcommand = "SELECT id_l10n,id_post,iso_language, title, description,image,meta_title,meta_description,meta_image,meta_url,image_title,image_alter_text,meta_keywords,meta_play_mark, publish_date,begin_date,end_date, register_date, state, FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n) as tags FROM posts_l10n pln WHERE 1=1 ";
ELSE
	SET sqlcommand = "SELECT id_l10n,id_post,iso_language, title, description,image,meta_title,meta_description,meta_image,meta_url,image_title,image_alter_text,meta_keywords,meta_play_mark, publish_date,begin_date,end_date, register_date, state, FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n) as tags FROM posts_l10n pln WHERE iso_language = @_iso_lang ";
END IF;


CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1 OR ((SELECT count(1) FROM posts_tags pt, posts_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like @_tags_stripped) > 0)) ");
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like @_title ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n) like @_filter) AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1) ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1) ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year) AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1) ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @_cfilter) AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1) ");
WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_l10n in (SELECT id_l10n FROM posts_l10n_authors WHERE id_author = @_cfilter) AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1) ");
ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " GROUP BY id_post ORDER BY register_date DESC LIMIT ?,?");
SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b; 

        
COMMIT;

END;

