create
    definer = skoiypp@`%` procedure SP_GET_POSTS_AUTHORS_COUNT(IN _field int(10), IN _field_snd int(10),
                                                               IN _field_trd int(10), IN _query varchar(192),
                                                               IN _filter varchar(192), IN _filter_snd varchar(192),
                                                               IN _filter_trd varchar(192), IN _iso_lang varchar(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_query = CONCAT("%",_query,"%");
SET @_name = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_role = CONCAT("%",_query,"%");

SET @_num_x = _filter;
SET @_filter = CONCAT("%",_filter,"%");

SET @email = CONCAT("%",_filter_snd,"%");
SET @id_author = _filter_snd;
SET @id_post = _filter_snd;

SET @_iso_lang = _iso_lang;


	IF(_iso_lang = '')
	THEN
   		 SET sqlcommand = "SELECT count(1) as total FROM ( SELECT id_author FROM posts_authors_l10n WHERE 1=1 ";
	ELSE
   		 SET sqlcommand = "SELECT count(1) as total FROM ( SELECT id_author FROM posts_authors_l10n WHERE iso_language = @_iso_lang ";
	END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_author = @id_author ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_author_l10n in (SELECT id_author_l10n FROM posts_l10n_authors WHERE id_l10n in (SELECT id_l10n FROM posts_l10n_authors pla, posts_l10n p WHERE p.id_l10n = pla.id_l10n AND p.id_post = @id_post)) ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (email like @email ) ");

			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_author_l10n in (SELECT id_author_l10n FROM posts_l10n_authors WHERE id_l10n in (SELECT id_l10n FROM posts_l10n_authors)) ) ");
			WHEN _field_snd = 202 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_author_l10n not in (SELECT id_author_l10n FROM posts_l10n_authors WHERE id_l10n in (SELECT id_l10n FROM posts_l10n_authors)) ) ");
			WHEN _field_snd = 113 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_author_l10n in (SELECT distinct id_author_l10n FROM posts_authors_variants_related) )");
			WHEN _field_snd = 213 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_author_l10n not in (SELECT distinct id_author_l10n FROM posts_authors_variants_related) )");

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;


CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (name like @_name OR description like @_description OR role like @_role) ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND public = 1 AND name like @_name ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND public = 0 AND name like @_name ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_POSTS_AUTHORS_TOTAL_POSTS(id_author) = @_num_x AND name like @_name ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;
  
SET sqlcommand = CONCAT(sqlcommand, " GROUP BY id_author) as tt ");  
  
SET @sqlcommand = sqlcommand;
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;  

COMMIT;

END;

