create
    definer = skoiypp@`%` procedure SP_GET_POSTS_COUNT(IN _field int(10), IN _query varchar(192),
                                                       IN _filter varchar(192), IN _iso_lang varchar(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_body = CONCAT("%",_query,"%");
SET @_title = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_iso_lang = _iso_lang;

SET @_tags_group = CONCAT("%",_filter_trd,"%");

SET @_filename = CONCAT("%",_filter_snd,"%");
SET @id_album = _filter_snd;
SET @id_asset = _filter_snd;
SET @id_composed = _filter_snd;
SET @id_author = _filter_snd;
SET @id_post = _filter_snd;
SET @id_dossier = _filter_snd;
SET @state = _filter_snd;
SET @label = _filter_snd;
SET @id_label = _filter_snd;

SET @_limit_sys_a = _limit_sys_a;
SET @_limit_sys_b = _limit_sys_b;

SET @_year = year(_filter);
SET @_month = month(_filter);

IF(_iso_lang = '')
THEN
	SET sqlcommand = "SELECT count(1) as total FROM posts_l10n pln WHERE 1=1 ";
ELSE
	SET sqlcommand = "SELECT count(1) as total FROM posts_l10n pln WHERE iso_language = @_iso_lang ";
END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_post = @id_post ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_authors WHERE id_author = @id_author) ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_videos WHERE id_composed = @id_composed) ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_photos WHERE id_asset = @id_asset) ) ");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_albums WHERE id_album = @id_album) ) ");						
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_post in (SELECT id_post FROM posts_dossiers_related WHERE id_dossier = @id_dossier) ) ");
			WHEN _field_snd = 106 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_photos WHERE id_asset in (SELECT id_asset FROM assets WHERE filename like @_filename))) ");

			WHEN _field_snd = 107 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_authors)) ");
			WHEN _field_snd = 108 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_videos)) ");
			WHEN _field_snd = 109 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_photos)) ");
			WHEN _field_snd = 110 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_albums)) ");						
			WHEN _field_snd = 111 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_post in (SELECT id_post FROM posts_dossiers_related)) ");

			WHEN _field_snd = 112 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @state ) ");
			WHEN _field_snd = 113 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_post in (SELECT id_post FROM posts_dossiers_related) ) ");

			WHEN _field_snd = 114 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_labels_related) ) ");
			WHEN _field_snd = 115 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_labels_related WHERE (id_label = @id_label OR id_label in (SELECT id_label FROM posts_labels WHERE name_stripped = @label)) )) ");


		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	IF (_field_trd = 1000)
	THEN
		SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n) like @_tags_group ) ");
	END IF;

CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1 OR ((SELECT count(1) FROM posts_tags pt, posts_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like @_tags_stripped) > 0)) ");
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like @_title ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n) like @_filter) AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1) ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1) ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year) AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1) ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @_cfilter) AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1) ");
WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_l10n in (SELECT id_l10n FROM posts_l10n_authors WHERE id_author = @_cfilter) AND (title like @_title OR description like @_description OR FN_GET_POSTS_SEARCH(id_l10n,@_body) = 1) ");

WHEN _field = 18 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (begin_date >= from_unixtime(@_limit_sys_a) AND (end_date = '0000-00-00 00:00:00' OR end_date <= from_unixtime(@_limit_sys_b)))  ");
ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " GROUP BY id_post ");
SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

EXECUTE stmt;
        
COMMIT;

END;

