create
    definer = skoiypp@`%` procedure SP_GET_POSTS_DOSSIERS_ON_COLLECTIONS(IN _id_collection int, IN _name varchar(192),
                                                                         IN _order tinyint, IN _order_by tinyint,
                                                                         IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_collection = _id_collection;

SET @_name = _name;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT dcr.id_collection, dcr.id_dossier, d.management_name, d.random, d.name, d.begin_date, d.end_date
	FROM dossiers_collections_related dcr, dossiers d WHERE d.id_dossier = dcr.id_dossier and dcr.id_collection = ? ";

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM dossiers_collections_related WHERE id_collection = _id_collection;
	SET @_limit_b = _limit_b;
END IF;

IF(_name <> '')
THEN
   SET @_name = CONCAT("%",_name,"%");
   SET sqlcommand = CONCAT(sqlcommand," AND (d.management_name like ? OR d.name like ? ) ");
END IF;

CASE
WHEN _order_by = 1 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, "ORDER BY d.management_name ASC");
WHEN _order_by = 1 AND _order = 2 THEN SET sqlcommand = CONCAT(sqlcommand, "ORDER BY d.management_name DESC");
ELSE SET sqlcommand = CONCAT(sqlcommand, "ORDER BY d.management_name ASC");
END CASE;

 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

CASE
WHEN _name <> '' THEN
EXECUTE stmt USING @_id_collection,@_name,@_name,@_limit_a,@_limit_b;
ELSE 
EXECUTE stmt USING @_id_collection,@_limit_a,@_limit_b;    
END CASE;

COMMIT;

END;

