create
    definer = skoiypp@`%` procedure SP_GET_POSTS_DOSSIERS_ON_COLLECTIONS_COUNT(IN _id_collection int, IN _name varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_collection = _id_collection;

SET @_name = _name;

SET sqlcommand = "SELECT count(1) as total
	FROM dossiers_collections_related dcr, dossiers d WHERE d.id_dossier = dcr.id_dossier and dcr.id_collection = ? ";

IF(_name <> '')
THEN
   SET @_name = CONCAT("%",_name,"%");
   SET sqlcommand = CONCAT(sqlcommand," AND (d.management_name like ? OR d.name like ? ) ");
END IF;

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

CASE
WHEN _name <> '' THEN
EXECUTE stmt USING @_id_collection,@_name,@_name;
ELSE 
EXECUTE stmt USING @_id_collection;    
END CASE;

COMMIT;

END;

