create
    definer = skoiypp@`%` procedure SP_GET_POSTS_ON_DOSSIERS_COUNT(IN _id_dossier int, IN _field int(10), IN _query varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_dossier = _id_dossier;
SET @_title = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_state = _query;

SET sqlcommand = " SELECT count(1) as total FROM posts p, posts_dossiers_related pdr, posts_l10n pln
 WHERE p.id_post = pdr.id_post AND pln.id_post = p.id_post AND pdr.id_dossier = ? ";

CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like ? OR description like ? OR ((SELECT count(1) FROM posts_tags pt, posts_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like ?) > 0)) ");
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like ? ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like ? ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND ((SELECT count(1) FROM posts_tags pt, posts_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like ?) > 0) ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND state = ? ");
ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
END CASE;

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

CASE
WHEN _field = 0 THEN
EXECUTE stmt USING @_id_dossier,@_title,@_description,@_tags_stripped;
WHEN _field = 1 THEN
EXECUTE stmt USING @_id_dossier,@_title;
WHEN _field = 2 THEN
EXECUTE stmt USING @_id_dossier,@_description;
WHEN _field = 3 THEN
EXECUTE stmt USING @_id_dossier,@_tags_stripped;
WHEN _field = 4 THEN
EXECUTE stmt USING @_id_dossier,@_state;
ELSE 
EXECUTE stmt USING @_id_dossier;    
END CASE;

COMMIT;

END;

