create
    definer = skoiypp@`%` procedure SP_GET_POSTS_STICKERS_RELATED(IN _field int(10), IN _field_snd int(10),
                                                                  IN _field_trd int(10), IN _query varchar(192),
                                                                  IN _filter varchar(192), IN _filter_snd varchar(192),
                                                                  IN _filter_trd varchar(192), IN _order int(10),
                                                                  IN _order_by int(10), IN _limit_a int(10),
                                                                  IN _limit_b int(10))
BEGIN





DECLARE sqlcommand text;
DECLARE sqlcommand_union text;
DECLARE sqlcommand_feed text;

DECLARE _autoFeedEnabled INT(10);
DECLARE _sourceType INT(10);

START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM posts_stickers_related;
END IF;

SET @_title = CONCAT("%",_query,"%");
SET @_id_sticker = _filter;
SET @_id_post = _filter;

SET @id_post = _filter_snd;
SET @state = _filter_snd;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET _autoFeedEnabled = 0; SET _sourceType = 0;
SET sqlcommand_feed = ""; SET sqlcommand = "";

IF EXISTS (SELECT id_sticker FROM posts_stickers WHERE id_sticker = @_id_sticker)
THEN
      SELECT  auto_feed_enabled into _autoFeedEnabled FROM posts_stickers WHERE id_sticker = @_id_sticker;
END IF;

IF EXISTS (SELECT source_type FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker LIMIT 0,1)
THEN
      SELECT source_type into _sourceType FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker LIMIT 0,1;
      SET @_source_type = _sourceType;
END IF;
        
     
     
    

IF(_field = 1000)
THEN
	SET sqlcommand = "SELECT distinct 1 as fixed,0 as value,psr.id_sticker,ps.name,ps.name_stripped,FN_GET_POSTS_STICKERS_TOTAL_ITEMS(ps.id_sticker) as total,psr.id_post,'' as title,'' as description,'' as image,'' as image_align,psr.begin_date,psr.end_date,psr.state,psr.position,psr.register_date
	FROM posts_stickers_related psr, posts_l10n pl10n, posts_stickers ps WHERE psr.id_post = pl10n.id_post AND ps.id_sticker = psr.id_sticker AND psr.id_post = @_id_post ";
END IF;

IF(_field = 2000 OR _field = 2010)
THEN

    SET sqlcommand = "(SELECT 1 as fixed,0 as value,psr.id_sticker,ps.name,ps.name_stripped,FN_GET_POSTS_STICKERS_TOTAL_ITEMS(ps.id_sticker) as total,psr.id_post,pl10n.title,pl10n.description,pl10n.image,pl10n.image_align,psr.begin_date,psr.end_date,psr.state,psr.position,psr.register_date
	FROM posts_stickers_related psr, posts_l10n pl10n, posts_stickers ps WHERE psr.id_post = pl10n.id_post AND ps.id_sticker = psr.id_sticker AND ps.id_sticker = @_id_sticker GROUP BY pl10n.id_post ORDER BY psr.position)";

	IF (_sourceType in (2,3,5,10,20,30))
	THEN
		SET sqlcommand_feed = "(SELECT 0 as fixed,0 as value,@_id_sticker as id_sticker,'' as name, '' as name_stripped, 0 as total, id_post,pl10n.title,pl10n.description,pl10n.image,pl10n.image_align, '0000-00-00 00:00:00' as begin_date,'0000-00-00 00:00:00' as end_date,'' as state,0 as position,register_date
			FROM posts_l10n pl10n WHERE id_post in ";
    
		CASE
			WHEN _sourceType = 4 THEN SET sqlcommand_feed =  CONCAT(sqlcommand_feed, " (SELECT id_post FROM  posts_l10n) ");
            WHEN _sourceType = 2 THEN SET sqlcommand_feed =  CONCAT(sqlcommand_feed, " (SELECT id_post FROM posts_dossiers_related WHERE id_dossier in (SELECT id_dossier FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker AND source_type = @_source_type)) ");
			WHEN _sourceType = 20 THEN SET sqlcommand_feed =  CONCAT(sqlcommand_feed, " (SELECT id_post FROM posts_dossiers_related WHERE id_dossier in (SELECT id_dossier FROM dossiers_l10n WHERE id_l10n in (SELECT id_l10n FROM  dossiers_l10n_tags_related WHERE id_tag in (SELECT id_dossier_tag FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker AND source_type = @_source_type)))) ");
			WHEN _sourceType = 3 THEN SET sqlcommand_feed =  CONCAT(sqlcommand_feed, " (SELECT id_post FROM posts_dossiers_related WHERE id_dossier in (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection in (SELECT id_collection FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker AND source_type = @_source_type))) ");
			WHEN _sourceType = 30 THEN SET sqlcommand_feed =  CONCAT(sqlcommand_feed, " (SELECT id_post FROM posts_dossiers_related WHERE id_dossier in (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection in 
    (SELECT id_collection FROM collections_l10n WHERE id_l10n in (SELECT id_l10n FROM collections_l10n_tags_related WHERE id_tag in (SELECT id_collection_tag FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker AND source_type = @_source_type))))) ");
			WHEN _sourceType = 5 THEN SET sqlcommand_feed =  CONCAT(sqlcommand_feed, " (SELECT id_post FROM posts_l10n WHERE id_l10n in (SELECT id_l10n FROM posts_l10n_authors WHERE id_author in (SELECT id_author FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker AND source_type = @_source_type))) ");
			WHEN _sourceType = 10 THEN SET sqlcommand_feed =  CONCAT(sqlcommand_feed, " (SELECT id_post FROM posts_l10n WHERE id_l10n in (SELECT id_l10n FROM posts_l10n_tags_related WHERE id_tag in (SELECT id_post_tag FROM posts_stickers_feeds_sources WHERE id_sticker = @_id_sticker AND source_type = @_source_type))) ");
		ELSE SET sqlcommand_feed = CONCAT(sqlcommand_feed,"");
		END CASE;
        
			SET sqlcommand_feed = CONCAT(sqlcommand_feed," AND state in (3,4,5) ORDER by pl10n.publish_date desc LIMIT 0,15) ");
	
	END IF;
    
    
    IF(sqlcommand_feed <> '' AND _autoFeedEnabled = 1)
    THEN
    
			IF(_field = 2000)
            THEN
				SET sqlcommand_union = CONCAT(sqlcommand," UNION ", sqlcommand_feed);
            ELSE
				SET sqlcommand_union = sqlcommand_feed;
            END IF;
            
	ELSE
        
			IF(_field = 2000)
            THEN
				SET sqlcommand_union = sqlcommand;
            ELSE
				SET sqlcommand_union = "SELECT 0 as fixed,0 as value,@_id_sticker as id_sticker,'' as name, '' as name_stripped, 0 as total, id_post,pl10n.title,pl10n.description,pl10n.image,pl10n.image_align, '0000-00-00 00:00:00' as begin_date,'0000-00-00 00:00:00' as end_date,'' as state,0 as position,register_date
				FROM posts_l10n pl10n WHERE 0=1";
            END IF;
            
	END IF;
   

END IF;

IF(_field not in (1000,2000,2010))
THEN
    SET sqlcommand = "SELECT 1 as fixed,0 as value,psr.id_sticker,ps.name,ps.name_stripped,FN_GET_POSTS_STICKERS_TOTAL_ITEMS(ps.id_sticker) as total,psr.id_post,pl10n.title,pl10n.description,pl10n.image,pl10n.image_align,psr.begin_date,psr.end_date,psr.state,psr.position,psr.register_date
	FROM posts_stickers_related psr, posts_l10n pl10n, posts_stickers ps WHERE psr.id_post = pl10n.id_post AND ps.id_sticker = psr.id_sticker AND ps.id_sticker = @_id_sticker ";
END IF;


	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (psr.id_post = @id_post ) ");
			WHEN _field_snd = 116 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (psr.state = @state ) ");

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;


CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND pl10n.title like @_title ");

ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

CASE 
	WHEN _field = 1000 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY psr.position ASC LIMIT ?,?");
	WHEN _field = 2000 THEN SET sqlcommand =  sqlcommand_union;
    WHEN _field = 2010 THEN SET sqlcommand =  sqlcommand_union;
ELSE SET sqlcommand = CONCAT(sqlcommand, " GROUP BY pl10n.id_post ORDER BY psr.position ASC LIMIT ?,?");
END CASE;

SET @sqlcommand = sqlcommand;   
PREPARE stmt FROM @sqlcommand;

IF(_field = 2000 OR _field = 2010)
THEN
	EXECUTE stmt;  
ELSE
	EXECUTE stmt USING @_limit_a,@_limit_b;  
END IF;  
        
COMMIT;

END;

