create
    definer = skoiypp@`%` procedure SP_GET_POSTS_TAGS_COUNT(IN _field int(10), IN _id_group int(10),
                                                            IN _query varchar(192), IN _filter varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_name = CONCAT("%",_query,"%");
SET @_id_group = _id_group;
SET @_id_tag = _filter;
SET @_id_key = _filter;
SET @_id_post = _filter;
SET @_num_x = _filter;

IF(_field = 12)
THEN
	SET sqlcommand = "SELECT count(1) as total FROM posts_tags at, posts_tags_variants_related atvr 
	WHERE at.id_tag = atvr.id_tag AND id_key = @_id_key ";
ELSE
	SET sqlcommand = "SELECT count(1) as total FROM posts_tags at WHERE 1=1 ";
END IF;

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND public = 1 AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND public = 0 AND name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_tag in (SELECT distinct id_tag FROM posts_l10n_tags_related) AND name like @_name ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_tag not in (SELECT distinct id_tag FROM posts_l10n_tags_related) AND name like @_name ");

WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_tag in (SELECT distinct id_tag FROM posts_l10n_tags_related WHERE id_l10n in (SELECT id_l10n FROM posts_l10n WHERE id_post = @_id_post)) AND name like @_name ");
WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name_stripped in (SELECT name_stripped FROM (SELECT count(1) as total,name_stripped FROM assets_tags GROUP BY name_stripped) as tt WHERE total > 1) AND name like @_name ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_POSTS_TAGS_TOTAL_POSTS(id_tag) = @_num_x AND name like @_name ");
WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_tag = @_id_tag AND name like @_name ");

WHEN _field = 13 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_tag in (SELECT distinct id_tag FROM posts_tags_variants_related) AND name like @_name ");
WHEN _field = 14 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_tag not in (SELECT distinct id_tag FROM posts_tags_variants_related) AND name like @_name ");

ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

	IF (_id_group > 0)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND id_group = @_id_group ");
	END IF;

	IF (_field = 4)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," GROUP BY id_tag ");
	END IF;
    
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt; 
  
  
        
COMMIT;

END;

