create
    definer = skoiypp@`%` procedure SP_GET_PUSH_ARCHIVE_VIDEO_PROCESS(IN _field int, IN _machine varchar(255))
BEGIN

DECLARE _id_queue INT;
DECLARE _id_account INT;
DECLARE _account_token varchar(255);
DECLARE _push_type TINYINT(3);
DECLARE _id_directory INT;
DECLARE _input_path VARCHAR(255);
DECLARE _video_name VARCHAR(255);
DECLARE _video VARCHAR(255);
DECLARE _extension VARCHAR(255);
DECLARE _mime_type VARCHAR(255);
DECLARE _size VARCHAR(255);
DECLARE _requester varchar(255);


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

 SELECT id_queue, id_account,requester,account_token,push_type,id_directory,input_path,video_name,video,extension,mime_type,size into _id_queue, _id_account,_requester,_account_token,_push_type,_id_directory,_input_path,_video_name,_video,_extension,_mime_type,_size FROM 
 loader_archive_video_queue WHERE is_running = 0 LIMIT 0,1;
 UPDATE loader_archive_video_queue SET is_running = 1, start = now(), attempts = attempts+1 WHERE id_queue = _id_queue;
 UPDATE loader_archive_video_queue SET first_try = now() WHERE id_queue = _id_queue AND attempts = 1;
 UPDATE loader_archive_video_queue SET machine = _machine WHERE id_queue = _id_queue;

	IF(_id_queue > 0)
	THEN
		SELECT _id_queue as id_queue, _id_account as id_account,_requester as requester, _account_token as account_token, _push_type as push_type,_id_directory as id_directory,_input_path as input_path,_video_name as video_name,_video as video,_extension as extension,_mime_type as mime_type,_size as size;
	ELSE
		SELECT -2 as return_code;
	END IF;
    	        
COMMIT;

END;

