create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_SSO_USER(IN _id_user bigint)
BEGIN

DECLARE _has INT(10);
DECLARE _total_profiles INT(10);

DECLARE _id_avatar INT(10);
DECLARE _id_user_profile INT(10);
DECLARE _avatar VARCHAR(255);
DECLARE _profile_name VARCHAR(255);
DECLARE _lang VARCHAR(10);

DECLARE _autoplay_next_video tinyint(1);
DECLARE _autoplay_previews tinyint(1);
DECLARE _lock_active tinyint(1);
DECLARE _lock_pin INT(10);



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS(SELECT id_user FROM users WHERE id_user = _id_user)
THEN

SELECT count(1) into _total_profiles FROM users_profiles WHERE id_user = _id_user;

	SELECT id_user_profile,up.id_avatar,FN_GET_OTT_AVATAR(id_avatar) as avatar,profile_name,lang,autoplay_next_video,autoplay_previews,lock_active,lock_pin 
    into _id_user_profile,_id_avatar,_avatar,_profile_name,_lang,_autoplay_next_video,_autoplay_previews,_lock_active,_lock_pin
	FROM users_profiles up WHERE up.id_user = _id_user LIMIT 0,1;

IF EXISTS(SELECT id_user FROM users WHERE id_user = _id_user AND password = '')
THEN
	SET _has = 0;
ELSE
	SET _has = 1;
END IF;

    SELECT id_user,_has as has_password,_total_profiles as total_profiles,FN_GET_OTT_PLAN(id_plan,1) as plan,FN_GET_OTT_PLAN(id_plan,2) as plan_stripped,name,email,gender,birthdate,identification,tax_number,nationality,country_iso,city,zipcode,active,verified,
    _id_user_profile as id_user_profile,_id_avatar as id_avatar,_avatar as avatar,_profile_name as profile_name,_lang as lang,_autoplay_next_video as autoplay_next_video,_autoplay_previews as autoplay_previews,_lock_active as lock_active,_lock_pin as lock_pin,
    update_date, register_date FROM users WHERE id_user = _id_user; 

ELSE
	SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

