create
    definer = skoiypp@`%` procedure SP_GET_TASK_ARCHIVE_CREATE_CLIP_TO_PROCESS(IN _field int, IN _machine varchar(255))
BEGIN

DECLARE _id_queue INT;
DECLARE _id_account INT;
DECLARE _account_token varchar(255);
DECLARE _id_video INT(10);
DECLARE _id_clip INT(10);
DECLARE _muted TINYINT(1);
DECLARE _output_path varchar(255);
DECLARE _command text;
DECLARE _video VARCHAR(255);
DECLARE _in_seconds INT;
DECLARE _duration_seconds INT;
DECLARE _created_clip_date date;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

 SELECT id_queue, id_account, account_token, output_path, id_video,id_clip,muted, video,command,in_seconds,duration_seconds, created_clip_date into _id_queue, _id_account, _account_token, _output_path, _id_video,_id_clip,_muted, _video,_command,_in_seconds,_duration_seconds,_created_clip_date FROM 
 archive_create_clip_queue WHERE is_running = 0 LIMIT 0,1;
 UPDATE archive_create_clip_queue SET is_running = 1, start = now(), attempts = attempts+1 WHERE id_queue = _id_queue;
 UPDATE archive_create_clip_queue SET first_try = now() WHERE id_queue = _id_queue AND attempts = 1;
 UPDATE archive_create_clip_queue SET machine = _machine WHERE id_queue = _id_queue;

	IF(_id_queue > 0)
	THEN
		SELECT _id_queue as id_queue, _id_account as id_account, _account_token as account_token, _output_path as output_path, _id_video as id_video,_id_clip as id_clip, _muted as muted, _video as video,_command as command, _in_seconds as in_seconds, _duration_seconds as _duration_seconds, _created_clip_date as created_clip_date;
	ELSE
		SELECT -2 as return_code;
	END IF;
    	        
COMMIT;

END;

