create
    definer = skoiypp@`%` procedure SP_GET_TASK_ARCHIVE_END_UPDATE_CLIP_PREVIEW_TO_PROCESS(IN _field int)
BEGIN

DECLARE _id_queue INT;
DECLARE _id_account INT;
DECLARE _account_token varchar(255);
DECLARE _id_clip INT;
DECLARE _output_path varchar(255);
DECLARE _clip VARCHAR(255);


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

 SELECT id_queue, id_account, account_token, output_path, id_clip, clip into _id_queue, _id_account, _account_token, _output_path, _id_clip, _clip FROM 
 archive_end_update_preview_clip_queue apcq WHERE is_running = 0 AND id_clip not in (SELECT id_clip FROM archive_create_clip_queue WHERE id_account = apcq.id_account) LIMIT 0,1;
 UPDATE archive_end_update_preview_clip_queue SET is_running = 1, start = now(), attempts = attempts+1 WHERE id_queue = _id_queue;
 UPDATE archive_end_update_preview_clip_queue SET first_try = now() WHERE id_queue = _id_queue AND attempts = 1;

	IF(_id_queue > 0)
	THEN
		SELECT _id_queue as id_queue, _id_account as id_account, _account_token as account_token, _output_path as output_path, _id_clip as id_clip, _clip as clip;
	ELSE
		SELECT -2 as return_code;
	END IF;
    	        
COMMIT;

END;

