create
    definer = skoiypp@`%` procedure SP_GET_TASK_OIR_TO_PROCESS(IN _field int, IN _machine varchar(255),
                                                               IN _requester varchar(255), IN _total int(10))
BEGIN

DECLARE _id_queue INT;
DECLARE _id_account INT;
DECLARE _account_token varchar(255);
DECLARE _command text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

 SELECT id_queue, id_account,account_token, command
 into _id_queue, _id_account,_account_token, _command FROM 
 oir_queue WHERE requester = _requester AND is_running = 0 LIMIT 0,1;
 
 UPDATE oir_queue SET is_running = 1, start = now(), attempts = attempts+1 WHERE id_queue = _id_queue;
 UPDATE oir_queue SET first_try = now() WHERE id_queue = _id_queue AND attempts = 1;
 UPDATE oir_queue SET machine = _machine WHERE id_queue = _id_queue;

	IF(_id_queue > 0)
	THEN
		SELECT _id_queue as id_queue, _id_account as id_account, _account_token as account_token, _command;
	ELSE
		SELECT -2 as return_code;
	END IF;
    	        
COMMIT;

END;

