create
    definer = skoiypp@`%` procedure SP_GET_TRANSCODER_ADS_VIDEOS(IN _field int(10), IN _field_snd int(10),
                                                                 IN _field_trd int(10), IN _query varchar(192),
                                                                 IN _filter varchar(192), IN _filter_snd varchar(192),
                                                                 IN _filter_trd varchar(192), IN _limit_a int,
                                                                 IN _limit_b int, IN _order_by int(10),
                                                                 IN _order int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM ads_transcoding_h264_queue;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;

SET @id_video = _filter_snd;
SET @id_account = _filter_snd;
SET @machine = _filter_snd;
SET @state = _filter_snd;

SET @id_video_trd = _filter_trd;
SET @id_account_trd = _filter_trd;
SET @machine_trd = _filter_trd;
SET @state_trd = _filter_trd;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

	SET sqlcommand = "SELECT id_queue,machine,is_running, id_storage, id_cdn, id_account, account_token, output_path, id_video, video,command,versions FROM ads_transcoding_h264_queue v WHERE deleted = 0 ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_video = @id_video ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_account = @id_account ) ");   
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (machine = @machine ) ");               
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (is_running = @state ) ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;
    
	IF (_field_trd > 0)
	THEN
		CASE
			WHEN _field_trd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_video = @id_video_trd ) ");
			WHEN _field_trd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_account = @id_account_trd ) ");   
			WHEN _field_trd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (machine = @machine_trd ) ");               
			WHEN _field_trd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (is_running = @state_trd ) ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;
    
    CASE
		WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND video like @_name ");
		WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (is_running = @_cfilter) AND (video like @_name) ");        
		ELSE SET sqlcommand = CONCAT(sqlcommand, "");
	END CASE;
    
	CASE
			WHEN _order_by = 10000 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY video DESC ");
			WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY video ASC ");
			WHEN _order_by = 10001 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date DESC ");
			WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date ASC ");
			WHEN _order_by = 10002 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY position DESC ");
			WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY position ASC ");
			WHEN _order_by = 10003 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY id_account DESC ");
			WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY id_account ASC ");
			WHEN _order_by = 10004 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY seconds DESC ");
			WHEN _order_by = 11004 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY seconds ASC ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY position ASC  ");
	END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b; 
 	        
COMMIT;

END;

