create
    definer = skoiypp@`%` procedure SP_PUBLISH_VIDEO_CHANGE_PROFILE_AND_VIDEO_STATE_BY_PLAYLIST(IN _id_playlist INT, OUT _result INT)
BEGIN

DECLARE profile_state INT;
DECLARE video_state INT;

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id_composed INT;
DECLARE c_id_profile INT;
DECLARE c_id_video INT;

DECLARE cursor_id_composed CURSOR FOR SELECT id_composed,id_video,id_profile FROM video_composed WHERE id_composed in (select id_composed FROM video_composed_playlists_related WHERE id_playlist = _id_playlist) AND 
		(SELECT FN_GET_VIDEO_COMPOSES_ON_PLAYLISTS(id_composed)) = 1 AND FN_GET_VIDEO_IS_LIVE_COMPOSED(id_composed) = 0;

DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;


DECLARE exit handler for sqlexception
  BEGIN
    
	SET _result = -1; 
    rollback;
  END;


 
   
    OPEN cursor_id_composed;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_id_composed INTO c_id_composed,c_id_video,c_id_profile;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	

		SELECT max(vc.state) into video_state FROM videos v, video_composed vc WHERE v.id_video = vc.id_video AND vc.id_video = c_id_video;
		SELECT max(vc.state) into profile_state FROM video_profiles vp, video_composed vc WHERE vp.id_profile = vc.id_profile AND vc.id_profile = c_id_profile;

    UPDATE videos set state = video_state WHERE id_video = c_id_video;
    UPDATE video_profiles_l10n set state = profile_state WHERE id_profile = c_id_profile;

	
    
      END LOOP read_loop;

    CLOSE cursor_id_composed;
 

	SELECT 0 as return_code;

   


END;

