create
    definer = skoiypp@`%` procedure SP_SET_ACCOUNT_API(IN _id_api int, IN _id_account int, IN _api_key varchar(255),
                                                       IN _description varchar(255), IN _domains text,
                                                       IN _active tinyint(2), IN _public tinyint(2))
BEGIN

DECLARE _token VARCHAR(255);
DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS(SELECT id_account FROM accounts WHERE id_account = _id_account)
THEN

	IF EXISTS (SELECT id_account FROM accounts_apis WHERE id_account = _id_account AND id_api = _id_api)
	THEN
		SELECT account_token into _token FROM accounts WHERE id_account = _id_account;
		UPDATE accounts_apis SET domains = _domains, active = _active,description = _description, update_date = now() WHERE id_account = _id_account AND id_api = _id_api;
		SELECT id_account,id_api,api_key,description,domains,active, public, _token as token FROM accounts_apis WHERE id_api = _id_api;
	ELSE

		SELECT account_token into _token FROM accounts WHERE id_account = _id_account;
		INSERT into accounts_apis(id_account,domains,api_key,description,active,public,register_date) VALUES(_id_account,_domains,_api_key,_description,_active,_public,now());
		SET p_last_id = last_insert_id();
		SELECT id_account,id_api,api_key,description,domains,active,public, _token as token FROM accounts_apis WHERE id_api = p_last_id;
	END IF;

ELSE
	SELECT -2 as return_code;
END IF;

COMMIT;

END;

