create
    definer = skoiypp@`%` procedure SP_SET_ARCHIVE_TRANSFER(IN _id_transfer int, IN _name varchar(192),
                                                            IN _code varchar(255), IN _password varchar(255),
                                                            IN _end_date datetime, IN _active tinyint(1),
                                                            IN _create_xml tinyint(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_id_transfer = 0 OR _id_transfer = -1)
THEN
	IF NOT EXISTS(SELECT id_transfer FROM archive_transfers WHERE code = _code)
	THEN
	   INSERT INTO archive_transfers(name,code,password,end_date,active,create_xml,register_date) VALUES(_name,_code,_password,_end_date,_active,_create_xml,now());
	   SET p_last_id = last_insert_id();
    SELECT id_transfer, name, code, password, end_date,active,FN_GET_ARCHIVE_NUM_ON_TRANSFERS(id_transfer) as total_content, create_xml,register_date,
	FN_GET_ARCHIVE_LAST_FILENAME_ON_TRANSFER(id_transfer) as filename, 
	FN_GET_ARCHIVE_LAST_SECONDS_ON_TRANSFER(id_transfer) as seconds, FN_GET_ARCHIVE_LAST_TYPE_ON_TRANSFER(id_transfer) as is_clip 
	FROM archive_transfers WHERE id_transfer = p_last_id;
	ELSE
		SELECT -2 as return_code;
	END IF;
ELSE
	IF EXISTS (SELECT id_transfer FROM archive_transfers WHERE id_transfer = _id_transfer)
	THEN	   
		UPDATE archive_transfers SET name = _name, password = _password, end_date = _end_date, active = _active,create_xml = _create_xml, update_date = now() WHERE id_transfer = _id_transfer;
    SELECT id_transfer, name, code, password, end_date,active,FN_GET_ARCHIVE_NUM_ON_TRANSFERS(id_transfer) as total_content, create_xml,register_date,
	FN_GET_ARCHIVE_LAST_FILENAME_ON_TRANSFER(id_transfer) as filename, 
	FN_GET_ARCHIVE_LAST_SECONDS_ON_TRANSFER(id_transfer) as seconds, FN_GET_ARCHIVE_LAST_TYPE_ON_TRANSFER(id_transfer) as is_clip 
	FROM archive_transfers WHERE id_transfer = _id_transfer;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;  
  
COMMIT;

END;

