create
    definer = skoiypp@`%` procedure SP_SET_ARCHIVE_VIDEO_PREVIEW(IN _id_video int(10), IN _file_name varchar(192),
                                                                 IN _size bigint, IN _extension varchar(8),
                                                                 IN _bitrate bigint, IN _width int(10),
                                                                 IN _height int(10), IN _id_storage int(10),
                                                                 IN _id_cdn int(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS(SELECT id_video FROM archive_videos WHERE id_video = _id_video)
THEN
	IF EXISTS(SELECT id_video FROM archive_videos_previews WHERE id_video = _id_video)
	THEN
		UPDATE archive_videos_previews SET filename = _file_name, size = _size,extension = _extension,bitrate = _bitrate,width = _width,height = height,id_storage = _id_storage,id_cdn = _id_cdn WHERE id_video = _id_video;
		SELECT id_video,id_storage,id_cdn,filename,size,extension,bitrate,width,height, register_date FROM archive_videos_previews WHERE id_video = _id_video;
	ELSE
		INSERT into archive_videos_previews(id_video,id_storage,id_cdn,filename,size,extension,bitrate,width,height,register_date) 
		VALUES(_id_video,_id_storage,_id_cdn,_file_name,_size,_extension,_bitrate,_width,_height,now());
		SET p_last_id = last_insert_id();
		SELECT id_video,id_storage,id_cdn,filename,size,extension,bitrate,width,height, register_date FROM archive_videos_previews WHERE id_video = p_last_id;
	END IF;
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

