create
    definer = skoiypp@`%` procedure SP_SET_ARCHIVE_VIDEO_THUMBNAIL(IN _id_thumbnail int, IN _id_video int,
                                                                   IN _thumbnail varchar(192),
                                                                   IN _is_default tinyint(1), IN _seconds float(10, 2))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE totalThumb INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS(SELECT id_video FROM archive_videos WHERE id_video = _id_video)
THEN
	IF EXISTS(SELECT id_thumbnail FROM archive_videos_thumbnails WHERE id_thumbnail = _id_thumbnail)
	THEN
		UPDATE archive_videos_thumbnails SET is_default = _is_default WHERE id_thumbnail = _id_thumbnail AND id_video = _id_video;
		IF(_is_default = 1)
		THEN
			UPDATE archive_videos_thumbnails SET is_default = 0 WHERE id_video = _id_video AND id_thumbnail not in (_id_thumbnail);
		END IF;
		SELECT id_thumbnail,id_video,thumbnail,is_default,seconds,register_date FROM archive_videos_thumbnails WHERE id_thumbnail = _id_thumbnail;
	ELSE
		SELECT count(1) into totalThumb FROM archive_videos_thumbnails WHERE id_video = _id_video;
		IF(totalThumb = 0)
		THEN
			SET _is_default = 1;
		END IF;
		INSERT into archive_videos_thumbnails(id_video,thumbnail,is_default,duration,seconds,register_date) VALUES(_id_video,_thumbnail,_is_default,sec_to_time(_seconds),_seconds,now());
		SET p_last_id = last_insert_id();
		SELECT id_thumbnail,id_video,thumbnail,is_default,seconds,register_date FROM archive_videos_thumbnails WHERE id_thumbnail = p_last_id;
	END IF;
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

