create
    definer = skoiypp@`%` procedure SP_SET_ASSETS(IN _id_asset int, IN _id_directory int, IN _name varchar(192),
                                                  IN _description text, IN _image_title varchar(255),
                                                  IN _image_alter_text varchar(255), IN _link varchar(255),
                                                  IN _file_name varchar(192), IN _extension varchar(8),
                                                  IN _mime_type varchar(192), IN _size bigint, IN _width int(10),
                                                  IN _height int(10), IN _id_storage int(10), IN _id_cdn int(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF (_id_directory = 0 OR _id_directory = 1 OR _id_directory = -1)
THEN
	SET _id_directory = 1;
END IF;

IF NOT EXISTS (SELECT id_directory FROM assets_directories WHERE id_directory = 1)
THEN
	INSERT INTO assets_directories(id_directory,name,register_date) VALUES(1,'root',now());
END IF;

IF(_id_asset = 0 OR _id_asset = -1)
THEN
        INSERT into assets(id_directory,id_storage,id_cdn,name,description,image_title,image_alter_text,link,filename,extension,mime_type,size,width,height,register_date) 
        VALUES(_id_directory,_id_storage,_id_cdn,_name,_description,_image_title,_image_alter_text,_link,_file_name,_extension,_mime_type,_size,_width,_height,now());        
        SET p_last_id = last_insert_id();
        SELECT id_asset,id_directory,id_storage,id_cdn,name,description,image_title,image_alter_text,link,filename,extension,mime_type,size,width,height,state,created_date, register_date FROM assets WHERE id_asset = p_last_id; 
ELSE       
     IF EXISTS (SELECT id_asset FROM assets WHERE id_asset = _id_asset)
     THEN
         SELECT FN_SP_SET_PUBLISH_ASSETS_SYNC_UPDATE(10,_id_asset) into _empty;
         UPDATE assets SET name = _name, description = _description, id_directory = _id_directory, image_title = _image_title,image_alter_text = _image_alter_text,link = _link, update_date = now() WHERE id_asset = _id_asset; 
		 SELECT id_asset,id_directory,id_storage,id_cdn,name,description,image_title,image_alter_text,link,filename,extension,mime_type,size,width,height,state,created_date, register_date FROM assets WHERE id_asset = _id_asset; 
     ELSE
        SELECT -2 as return_code;
     END IF;
END IF;
COMMIT;

END;

