create
    definer = skoiypp@`%` procedure SP_SET_ASSETS_SHARE_AND_DOWNLOAD(IN _id_shr_dld int, IN _type tinyint(1),
                                                                     IN _name varchar(192), IN _code varchar(255),
                                                                     IN _password varchar(255), IN _end_date datetime,
                                                                     IN _active tinyint(1), IN _term varchar(255),
                                                                     IN _id_directory varchar(255),
                                                                     IN _tag varchar(255), IN _system_tag varchar(255),
                                                                     IN _system_tag_value varchar(255),
                                                                     IN _room varchar(255), IN _id_user varchar(255),
                                                                     IN _order_by varchar(255), IN _resize tinyint(10),
                                                                     IN _quality tinyint(10),
                                                                     IN _compress_enabled tinyint(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_id_shr_dld = 0 OR _id_shr_dld = -1)
THEN
	IF NOT EXISTS(SELECT id_shr_dld FROM assets_share_and_download WHERE code = _code)
	THEN
	   INSERT INTO assets_share_and_download(name,type,code,password,end_date,active,term,id_directory,tag,system_tag,system_tag_value,room,id_user,order_by,resize,quality,compress_enabled,register_date) 
	   VALUES(_name,_type,_code,_password,_end_date,_active,_term,_id_directory,_tag,_system_tag,_system_tag_value,_room,_id_user,_order_by,_resize,_quality,_compress_enabled,now());
	   SET p_last_id = last_insert_id();
    SELECT id_shr_dld, name,type,code,password,end_date,active,term,id_directory,tag,system_tag,system_tag_value,room,id_user,order_by,resize,quality,compress_enabled,compress_running,compress_completed,register_date 
	FROM assets_share_and_download WHERE id_shr_dld = p_last_id;
	ELSE
		SELECT -2 as return_code;
	END IF;
ELSE
	IF EXISTS (SELECT id_shr_dld FROM assets_share_and_download WHERE id_shr_dld = _id_shr_dld)
	THEN	   
		UPDATE assets_share_and_download SET name = _name, password = _password, end_date = _end_date, active = _active,term = _term,id_directory = _id_directory,tag = _tag,system_tag = _system_tag,system_tag_value = _system_tag_value,room = _room,id_user = _id_user,order_by = _order_by, rezise = _resize,quality = _quality,compress_enabled = _compress_enabled,update_date = now() WHERE id_shr_dld = _id_shr_dld;
    SELECT id_shr_dld, name,type,code,password,end_date,active,term,id_directory,tag,system_tag,system_tag_value,room,id_user,order_by,resize,quality,compress_enabled,compress_running,compress_completed,register_date 
	FROM assets_share_and_download WHERE id_shr_dld = _id_shr_dld;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;  
  
COMMIT;

END;

