create
    definer = skoiypp@`%` procedure SP_SET_ASSETS_TAGS(IN _id_tag int, IN _id_group int, IN _name varchar(192),
                                                       IN _name_stripped varchar(192), IN _public tinyint(1),
                                                       IN _if_exists tinyint(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF (_id_group = 0 OR _id_group = -1)
THEN
    SET _id_group = 1;
END IF;

IF NOT EXISTS (SELECT id_group FROM assets_tags_groups WHERE id_group = 1)
THEN
    INSERT INTO assets_tags_groups(id_group,name,register_date) VALUES(1,'root',now());
END IF;


IF(_id_tag = 0 OR _id_tag = -1)
THEN
    IF (((SELECT count(1) FROM assets_tags WHERE name_stripped = _name_stripped)>0) AND _if_exists = 1)
    THEN
            SELECT id_tag,id_group,name,name_stripped,public,FN_GET_ASSETS_TAGS_KEYS_GROUPED(id_tag) as tag_keys FROM assets_tags WHERE name_stripped = _name_stripped LIMIT 0,1; 
    ELSE
            INSERT into assets_tags(id_group,name,name_stripped,public,register_date) VALUES(_id_group,_name,_name_stripped,_public,now());        
            SET p_last_id = last_insert_id();
            SELECT id_tag,id_group,name,name_stripped,public,FN_GET_ASSETS_TAGS_KEYS_GROUPED(id_tag) as tag_keys FROM assets_tags WHERE id_tag = p_last_id; 
    END IF;        
ELSE       
     IF EXISTS (SELECT id_tag FROM assets_tags WHERE id_tag = _id_tag)
     THEN
        UPDATE assets_tags SET id_group = _id_group,name = _name,name_stripped = _name_stripped,public = _public, update_date = now() WHERE id_tag = _id_tag;
        SELECT id_tag,id_group,name,name_stripped,public,FN_GET_ASSETS_TAGS_KEYS_GROUPED(id_tag) as tag_keys FROM assets_tags WHERE id_tag = _id_tag; 
     ELSE
        SELECT -2 as return_code;
     END IF;
END IF;
COMMIT;

END;

