create
    definer = skoiypp@`%` procedure SP_SET_LIVE_COMPOSED(IN _id_composed int, IN _id_live int, IN _id_profile int,
                                                         IN _publish_date datetime, IN _unpublish_date datetime,
                                                         IN _begin_date datetime, IN _end_date datetime,
                                                         IN _set_thumbnail tinyint, IN _set_inside_social tinyint,
                                                         IN _set_autoplay tinyint, IN _set_play_inline tinyint,
                                                         IN _set_play_mark tinyint, IN _set_webvtt tinyint,
                                                         IN _color varchar(255), IN _os_graphics_image varchar(255),
                                                         IN _os_graphics_position varchar(255),
                                                         IN _os_graphics_size varchar(255),
                                                         IN _os_graphics_padding varchar(255))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE last_id_profile INT;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;
IF(SELECT FN_GET_VIDEO_IS_LIVE_PROFILE(_id_profile) = 1)
THEN

IF EXISTS (SELECT id_composed FROM video_composed WHERE id_composed = _id_composed AND FN_GET_VIDEO_IS_LIVE_COMPOSED(id_composed) = 1)
THEN

		SELECT id_profile into last_id_profile FROM video_composed WHERE id_composed = _id_composed;

		UPDATE video_composed SET id_live = _id_live, id_profile = _id_profile, publish_date = _publish_date,unpublish_date = _unpublish_date,begin_date = _begin_date, end_date = _end_date, 
		color = _color,os_graphics_image = _os_graphics_image,os_graphics_position = _os_graphics_position,os_graphics_size = _os_graphics_size,os_graphics_padding = _os_graphics_padding,
		set_thumbnail = _set_thumbnail, set_inside_social = _set_inside_social,set_autoplay = _set_autoplay,set_play_inline = _set_play_inline,set_play_mark = _set_play_mark, set_webvtt = _set_webvtt WHERE id_composed = _id_composed;
		
		UPDATE video_profiles_l10n SET state = '3' WHERE id_profile = _id_profile AND state < 4;

		SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(12,_id_composed) into _empty;

		CALL SP_VIDEO_CHANGE_LIVE_PROFILE_STATE(last_id_profile,@result_profile);

		IF(@result_profile <> 0)
		THEN
			SELECT -1 as return_code;
		ELSE
			SELECT id_composed,id_live,id_profile,publish_date,unpublish_date,begin_date,end_date,color,os_graphics_image,os_graphics_position,os_graphics_size,os_graphics_padding,set_thumbnail,set_inside_social,set_autoplay,set_play_inline,set_play_mark,set_webvtt,register_date,FN_GET_LIVE_IS_COMPOSED_ON_STICKERS(id_composed) as on_sticker FROM video_composed WHERE id_composed = _id_composed;
		END IF;

	ELSE
		INSERT INTO video_composed(id_live,id_profile,publish_date,unpublish_date,begin_date,end_date,color,os_graphics_image,os_graphics_position,os_graphics_size,os_graphics_padding,set_thumbnail,set_inside_social,set_autoplay,set_play_inline,set_play_mark,set_webvtt,register_date) VALUES(_id_live,_id_profile,_publish_date,_unpublish_date,_begin_date,_end_date,_color,_os_graphics_image,_os_graphics_position,_os_graphics_size,_os_graphics_padding,_set_thumbnail,_set_inside_social,_set_autoplay,_set_play_inline,_set_play_mark,_set_webvtt,now());
		SET p_last_id = last_insert_id();

		UPDATE video_profiles_l10n SET state = '3' WHERE id_profile = _id_profile AND state < 4;
		SELECT id_composed,id_live,id_profile,publish_date,unpublish_date,begin_date,end_date,color,os_graphics_image,os_graphics_position,os_graphics_size,os_graphics_padding,set_thumbnail,set_inside_social,set_autoplay,set_play_inline,set_play_mark,set_webvtt,register_date,FN_GET_LIVE_IS_COMPOSED_ON_STICKERS(id_composed) as on_sticker FROM video_composed WHERE id_composed = p_last_id;
	END IF;

ELSE
	SELECT -3 as return_code;
END IF;
    
COMMIT;

END;

