create
    definer = skoiypp@`%` procedure SP_SET_POSTS_AUTHORS_CLONE_L10N(IN _id_author int, IN _id_author_clone int)
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id_l10n INT;
DECLARE c_iso_language VARCHAR(10);
DECLARE exist_table varchar(10);

DECLARE cursor_l10n CURSOR FOR SELECT id_author_l10n,iso_language FROM posts_authors_l10n WHERE id_author = _id_author;
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;

START TRANSACTION;

    
   
    OPEN cursor_l10n;
    IF(@result = -1)
        THEN
            SELECT -1 as return_code;
            ROLLBACK;
    END IF;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_l10n INTO c_id_l10n,c_iso_language;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	
               
	 INSERT into posts_authors_variants_related(id_variant,id_key,variant_value,position,id_author_l10n,register_date) 
		 SELECT null,id_key,variant_value,position,c_id_l10n,now() FROM posts_authors_variants_related WHERE id_author_l10n in (SELECT id_author_l10n FROM posts_authors_l10n WHERE id_author = _id_author_clone AND iso_language = c_iso_language);

	 INSERT into posts_authors_l10n_photos(id_asset,id_author_l10n,register_date) 
		 SELECT id_asset,c_id_l10n,now() FROM posts_authors_l10n_photos WHERE id_author_l10n in (SELECT id_author_l10n FROM posts_authors_l10n WHERE id_author = _id_author_clone AND iso_language = c_iso_language);

	
    
      END LOOP read_loop;

    CLOSE cursor_l10n;
    

COMMIT;

END;

