create
    definer = skoiypp@`%` procedure SP_SET_POSTS_COLLECTIONS(IN _id_collection int(10),
                                                             IN _management_name varchar(192),
                                                             IN _publish_date datetime, IN _begin_date datetime,
                                                             IN _end_date datetime, IN _domain varchar(192),
                                                             IN _default_id_dossier int(10), IN _position int(10))
BEGIN

DECLARE lastposition INT;
DECLARE currentposition INT;
DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET p_last_id = 0;

  SELECT count(1) into lastposition FROM collections;
  IF(_position = lastposition)
  THEN
    SET _position = _position+1;
  END IF;


IF(_id_collection = 0 OR _id_collection = -1)
THEN
   INSERT into collections(management_name,publish_date,begin_date,end_date,domain,default_id_dossier,update_date,register_date) VALUES(_management_name,_publish_date,_begin_date,_end_date,_domain,_default_id_dossier,now(),now());
   SET p_last_id = last_insert_id();
    
    SET @rownum=0;
    UPDATE collections c, (SELECT @rownum:=@rownum+1 rownum, collections.* FROM collections ORDER BY position,update_date desc) r 
    SET c.position = r.rownum
    WHERE (c.id_collection = r.id_collection);

   SELECT id_collection,management_name,publish_date,begin_date,end_date,domain,default_id_dossier, position,state, register_date,FN_GET_POSTS_L10N_ISO_GROUPED(3,id_collection) as iso_grouped FROM collections WHERE id_collection = p_last_id;
ELSE
  IF EXISTS (SELECT id_collection FROM collections WHERE id_collection = _id_collection)
  THEN     
  
  SELECT position into currentposition FROM collections WHERE id_collection = _id_collection;
	SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(12,_id_collection) into _empty;

	UPDATE collections SET management_name = _management_name, publish_date = _publish_date,begin_date = _begin_date, end_date = _end_date,domain = _domain,default_id_dossier = _default_id_dossier, position = _position, update_date = now() WHERE id_collection = _id_collection;
	  
 IF(currentposition <> _position)
 THEN   
    SET @rownum=0;
    UPDATE collections c, (SELECT @rownum:=@rownum+1 rownum, collections.* FROM collections ORDER BY position,update_date desc) r 
    SET c.position = r.rownum
    WHERE (c.id_collection = r.id_collection);
    SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(60,-1) into _empty; 
 END IF;   

  SELECT id_collection,management_name,publish_date,begin_date,end_date,domain,default_id_dossier, position,state, register_date,FN_GET_POSTS_L10N_ISO_GROUPED(3,id_collection) as iso_grouped FROM collections WHERE id_collection = _id_collection;
  ELSE
    SELECT -2 as return_code;
  END IF;
END IF;  
  
COMMIT;

END;

