create
    definer = skoiypp@`%` procedure SP_SET_POSTS_COLLECTIONS_POSITION_TAGS_RELATED(IN _id_collection INT(10),
                                                                                   IN _id_tag INT(10),
                                                                                   IN _position INT(10))
BEGIN

DECLARE lastposition INT;
DECLARE _old_position INT;
DECLARE _position INT;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_tag FROM collections_tags WHERE id_tag = _id_tag) AND EXISTS (SELECT id_collection FROM collections WHERE id_collection = _id_collection)
THEN

  SELECT count(1) into lastposition FROM collections_position_tags_related WHERE id_collection = _id_collection;
  SELECT position into _old_position FROM collections_position_tags_related WHERE id_tag = _id_tag AND id_collection = _id_collection;
 
  IF(_position = lastposition)
  THEN
    SET _position = _position+1;
  END IF;

		IF NOT EXISTS (SELECT id_collection FROM collections_position_tags_related WHERE id_collection = _id_collection AND id_tag = _id_tag)
		THEN
			INSERT INTO dossiers_collections_related(id_collection,id_tag,position,update_date,register_date) VALUES(_id_collection,_id_tag,_position,now(),now());
			SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(15,_id_collection) into _empty;
		ELSE
			UPDATE collections_position_tags_related SET position = _position, update_date = now() WHERE id_collection = _id_collection AND id_tag = _id_tag;
		END IF;
    
	IF(_position < _old_position)
	THEN
			SET @rownum=0;
			UPDATE collections_position_tags_related p, (SELECT @rownum:=@rownum+1 rownum, collections_position_tags_related.* FROM collections_position_tags_related WHERE id_collection = _id_collection ORDER BY position,update_date DESC) r 
			SET p.position = r.rownum
			WHERE (p.id_tag = r.id_tag);
	ELSE
			SET @rownum=0;
			UPDATE collections_position_tags_related p, (SELECT @rownum:=@rownum+1 rownum, collections_position_tags_related.* FROM collections_position_tags_related WHERE id_collection = _id_collection ORDER BY position,update_date ASC) r 
			SET p.position = r.rownum
			WHERE (p.id_tag = r.id_tag);
	END IF;    
    
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

