create
    definer = skoiypp@`%` procedure SP_SET_POSTS_COLLECTION_CLONE_L10N(IN _id_collection INT, IN _id_collection_clone INT)
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id_l10n INT;
DECLARE c_iso_language VARCHAR(10);

DECLARE cursor_l10n CURSOR FOR SELECT id_l10n,iso_language FROM collections_l10n WHERE id_collection = _id_collection;
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;

START TRANSACTION;

    
   
    OPEN cursor_l10n;
    IF(@result = -1)
        THEN
            SELECT -1 as return_code;
            ROLLBACK;
    END IF;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_l10n INTO c_id_l10n,c_iso_language;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	
                
	INSERT into collections_l10n_tags_related(id_tag,id_l10n,position,register_date) 
		 SELECT id_tag,c_id_l10n,position,now() FROM collections_l10n_tags_related WHERE id_l10n = (SELECT id_l10n FROM collections_l10n WHERE id_collection = _id_collection_clone AND iso_language = c_iso_language);

	
    
      END LOOP read_loop;

    CLOSE cursor_l10n;
    

COMMIT;

END;

