create
    definer = skoiypp@`%` procedure SP_SET_POSTS_L10N(IN _id_l10n INT, IN _id_post INT, IN _iso_language VARCHAR(10),
                                                      IN _title VARCHAR(255), IN _description TEXT,
                                                      IN _image VARCHAR(255), IN _meta_title VARCHAR(255),
                                                      IN _meta_description TEXT, IN _meta_image VARCHAR(255),
                                                      IN _meta_url VARCHAR(255), IN _image_title VARCHAR(255),
                                                      IN _image_alter_text VARCHAR(255), IN _meta_keywords VARCHAR(255),
                                                      IN _meta_play_mark tinyint(1), IN _publish_date DATETIME,
                                                      IN _begin_date DATETIME, IN _end_date DATETIME)
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;
SET _meta_play_mark = 0;

START TRANSACTION;

IF(_publish_date = '0000-00-00')
THEN
    SELECT now() into _publish_date;
END IF;
IF(_begin_date = '0000-00-00')
THEN
    SELECT now() into _begin_date;
END IF;

IF(_id_l10n = 0 OR _id_l10n = -1)
THEN
        INSERT into posts_l10n(id_post,iso_language,title,description,image,meta_title,meta_description,meta_image,meta_url,image_title,image_alter_text,meta_keywords,meta_play_mark,publish_date,begin_date,end_date,register_date) VALUES(_id_post,_iso_language,_title,_description,_image,_meta_title,_meta_description,_meta_image,_meta_url,_image_title,_image_alter_text,_meta_keywords,_meta_play_mark,_publish_date,_begin_date,_end_date,now());        
        SET p_last_id = last_insert_id();
        SELECT id_l10n,id_post,iso_language,title,description,image,meta_title,meta_description,meta_image,meta_url,image_title,image_alter_text,meta_keywords,meta_play_mark,publish_date,begin_date,end_date,register_date FROM posts_l10n WHERE id_l10n = p_last_id; 
ELSE       
     IF EXISTS (SELECT id_post FROM posts_l10n WHERE id_l10n = _id_l10n)
     THEN
        UPDATE posts_l10n SET iso_language = _iso_language,title = _title, description = _description, image = _image,meta_title = _meta_title,meta_description = _meta_description,meta_image = _meta_image,meta_url = _meta_url,image_title = _image_title,image_alter_text = _image_alter_text,meta_keywords = _meta_keywords, meta_play_mark = _meta_play_mark,publish_date = _publish_date,begin_date = _begin_date,end_date = _end_date, update_date = now() WHERE id_post = _id_post AND id_l10n = _id_l10n;
        UPDATE posts SET update_date = now() WHERE id_post = _id_post;
		SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(10,_id_post) into _empty;
		SELECT id_l10n,id_post,iso_language,title,description,image,meta_title,meta_description,meta_image,meta_url,image_title,image_alter_text,meta_keywords,meta_play_mark,publish_date,begin_date,end_date,register_date FROM posts_l10n WHERE id_l10n = _id_l10n; 
     ELSE
        SELECT -2 as return_code;
     END IF;
END IF;
COMMIT;

END;

