create
    definer = skoiypp@`%` procedure SP_SET_POSTS_L10N_BODY(IN _id_body INT(10), IN _id_l10n INT(10), IN _body TEXT,
                                                           IN _position INT(10), IN _settings TEXT,
                                                           IN _restricted TINYINT(1), IN _draft TINYINT(1),
                                                           IN _block_type VARCHAR(255))
BEGIN

-- call SP_SET_POSTS_L10N_BODY_new(0,4051,'xx','1','settings',1,1,1)

DECLARE p_last_id INT UNSIGNED;

DECLARE lastposition INT;
DECLARE _old_position INT;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
    SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS (SELECT id_l10n FROM posts_l10n WHERE id_l10n = _id_l10n)
THEN

  SELECT count(1) into lastposition FROM posts_l10n_body WHERE id_l10n = _id_l10n;
  SELECT position into _old_position FROM posts_l10n_body WHERE id_body = _id_body AND id_l10n = _id_l10n;
  
  IF(_position = lastposition)
  THEN
    SET _position = _position+1;
  END IF;

	IF(_id_body = 0 OR _id_body = -1)
    THEN
        
		IF(_position = 0)
        THEN
          SET _position = lastposition+1;
        END IF;
        
        INSERT INTO posts_l10n_body(id_l10n,body,position,settings,restricted,draft,block_type,register_date) VALUES(_id_l10n,_body,_position,_settings,_restricted,_draft,_block_type,now());
		SET p_last_id = last_insert_id();    
        
					SET @rownum=0;
					UPDATE posts_l10n_body p, (SELECT @rownum:=@rownum+1 rownum, posts_l10n_body.* FROM posts_l10n_body WHERE id_l10n = _id_l10n ORDER BY position,update_date ASC) r 
					SET p.position = r.rownum
					WHERE (p.id_body = r.id_body AND p.id_l10n = _id_l10n);
        
		SELECT id_body,id_l10n,body, position, settings, restricted,draft,block_type,update_date,register_date FROM posts_l10n_body WHERE id_body = p_last_id;
                
    ELSE
		
        IF EXISTS (SELECT id_body FROM posts_l10n_body WHERE id_body = _id_body)
		THEN
			
            UPDATE posts_l10n_body SET body = _body,  position = _position, settings = _settings, restricted = _restricted,draft = _draft,block_type = _block_type, update_date = now() WHERE id_body = _id_body;
            SELECT id_body,id_l10n,body, position, settings, restricted,draft,block_type,update_date,register_date FROM posts_l10n_body WHERE id_body = _id_body;
            
			IF(_position < _old_position)
			THEN
					SET @rownum=0;
					UPDATE posts_l10n_body p, (SELECT @rownum:=@rownum+1 rownum, posts_l10n_body.* FROM posts_l10n_body WHERE id_l10n = _id_l10n ORDER BY position,update_date DESC) r 
					SET p.position = r.rownum
					WHERE (p.id_body = r.id_body AND p.id_l10n = _id_l10n);
			ELSE
					SET @rownum=0;
					UPDATE posts_l10n_body p, (SELECT @rownum:=@rownum+1 rownum, posts_l10n_body.* FROM posts_l10n_body WHERE id_l10n = _id_l10n ORDER BY position,update_date ASC) r 
					SET p.position = r.rownum
					WHERE (p.id_body = r.id_body AND p.id_l10n = _id_l10n);
			END IF;
            
        ELSE
			SELECT -2 as return_code;
        END IF;
    
    END IF;

ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

