create
    definer = skoiypp@`%` procedure SP_SET_POSTS_L10N_KEYS(IN _id_l10n INT(10), IN _id_key INT(10),
                                                           IN _name VARCHAR(192), IN _name_stripped VARCHAR(192),
                                                           IN _public TINYINT(1), IN _if_exists TINYINT(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

SET p_last_id = 0;

START TRANSACTION;

IF EXISTS (SELECT id_post FROM posts_l10n WHERE id_l10n = _id_l10n)
THEN

    IF(_id_key = 0 OR _id_key = -1)
    THEN
        IF (((SELECT count(1) FROM posts_l10n_variants_keys WHERE name_stripped = _name_stripped)>0) AND _if_exists = 1)
        THEN
                SELECT id_l10n,id_key,name,name_stripped,public FROM posts_l10n_variants_keys WHERE name_stripped = _name_stripped LIMIT 0,1; 
        ELSE
                INSERT into posts_l10n_variants_keys(id_l10n,name,name_stripped,public,register_date) VALUES(_id_l10n,_name,_name_stripped,_public,now());        
                SET p_last_id = last_insert_id();
                SELECT id_l10n,id_key,name,name_stripped,public FROM posts_l10n_variants_keys WHERE id_key = p_last_id; 
        END IF;        
    ELSE       
         IF EXISTS (SELECT id_key FROM posts_l10n_variants_keys WHERE id_key = _id_key)
         THEN
            UPDATE posts_l10n_variants_keys SET name = _name,name_stripped = _name_stripped,public = _public, update_date = now() WHERE id_key = _id_key;
            SELECT id_l10n,id_key,name,name_stripped,public FROM posts_l10n_variants_keys WHERE id_key = _id_key; 
         ELSE
            SELECT -2 as return_code;
         END IF;
    END IF;

ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

