create
    definer = skoiypp@`%` procedure SP_SET_POSTS_STICKER(IN _id_sticker int(10), IN _id_group int(10),
                                                         IN _name varchar(192), IN _name_stripped varchar(192),
                                                         IN _token varchar(192), IN _maximum_items int(10),
                                                         IN _number_of_rows int(10), IN _display_in varchar(255),
                                                         IN _id_format int(10), IN _link varchar(255),
                                                         IN _auto_feed tinyint(1), IN _auto_feed_order varchar(255),
                                                         IN _auto_feed_type int(10), IN _color varchar(255),
                                                         IN _active tinyint(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF(_id_sticker = 0 OR _id_sticker = -1)
THEN
        INSERT into posts_stickers(id_group,name,name_stripped,token,maximum_items,number_of_rows,display_in,id_format,link,auto_feed,auto_feed_order,auto_feed_type,color,active,register_date) VALUES(_id_group,_name,_name_stripped,_token,_maximum_items,_number_of_rows,_display_in,_id_format,_link,_auto_feed,_auto_feed_order,_auto_feed_type,_color,_active,now());        
        SET p_last_id = last_insert_id();
		SELECT id_sticker,id_group, name,name_stripped,token,maximum_items,number_of_rows,display_in,id_format,link,auto_feed,auto_feed_order,auto_feed_type,color,active, FN_GET_POSTS_STICKERS_TOTAL_ITEMS(id_sticker) as total, 0 as position,register_date FROM posts_stickers WHERE id_sticker = p_last_id; 
ELSE       
     IF EXISTS (SELECT id_sticker FROM posts_stickers WHERE id_sticker = _id_sticker)
     THEN
		UPDATE posts_stickers SET id_group = _id_group,name = _name,name_stripped = _name_stripped,maximum_items = _maximum_items,number_of_rows = _number_of_rows,display_in = _display_in,id_format = _id_format,link = _link,auto_feed = _auto_feed,auto_feed_order = _auto_feed_order,auto_feed_type = _auto_feed_type,color = _color,active = _active, update_date = now() WHERE id_sticker = _id_sticker;
		SELECT id_sticker,id_group, name,name_stripped,token,maximum_items,number_of_rows,display_in,id_format,link,auto_feed,auto_feed_order,auto_feed_type,color,active, FN_GET_POSTS_STICKERS_TOTAL_ITEMS(id_sticker) as total, 0 as position,register_date FROM posts_stickers WHERE id_sticker = _id_sticker; 
     ELSE
        SELECT -2 as return_code;
     END IF;
END IF;
COMMIT;

END;

