create
    definer = skoiypp@`%` procedure SP_SET_POSTS_STICKER_FEED_SOURCE(IN _id_sticker INT(10), IN _type INT(10), IN _id VARCHAR(255))
BEGIN

DECLARE _empty INT(10);
DECLARE _total INT(10);

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
    SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS (SELECT id_sticker FROM posts_stickers WHERE id_sticker = _id_sticker)
THEN

SELECT count(1) into _total FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker;

	IF(_total > 0) AND NOT EXISTS(SELECT id_sticker FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker AND source_type = _type)
	THEN
		SELECT -3 as return_code;
	ELSE
			-- POSTS
			IF(_type = 1) AND NOT EXISTS (SELECT id_sticker FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker AND source_type = _type AND id_post = _id)
			THEN
				INSERT into posts_stickers_feeds_sources(id_sticker,source_type,id_post,register_date) VALUES (_id_sticker,_type,_id,now());
			END IF;
			IF(_type = 10) AND NOT EXISTS (SELECT id_sticker FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker AND source_type = _type AND id_post_tag = _id)
			THEN
				INSERT into posts_stickers_feeds_sources(id_sticker,source_type,id_post_tag,register_date) VALUES (_id_sticker,_type,_id,now());
			END IF;
			IF(_type = 2) AND NOT EXISTS (SELECT id_sticker FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker AND source_type = _type AND id_dossier = _id)
			THEN
				INSERT into posts_stickers_feeds_sources(id_sticker,source_type,id_dossier,register_date) VALUES (_id_sticker,_type,_id,now());
			END IF;        
			IF(_type = 20) AND NOT EXISTS (SELECT id_sticker FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker AND source_type = _type AND id_dossier_tag = _id)
			THEN
				INSERT into posts_stickers_feeds_sources(id_sticker,source_type,id_dossier_tag,register_date) VALUES (_id_sticker,_type,_id,now());
			END IF;        
			IF(_type = 3) AND NOT EXISTS (SELECT id_sticker FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker AND source_type = _type AND id_collection = _id)
			THEN
				INSERT into posts_stickers_feeds_sources(id_sticker,source_type,id_collection,register_date) VALUES (_id_sticker,_type,_id,now());
			END IF;        
			IF(_type = 30) AND NOT EXISTS (SELECT id_sticker FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker AND source_type = _type AND id_collection_tag = _id)
			THEN
				INSERT into posts_stickers_feeds_sources(id_sticker,source_type,id_collection_tag,register_date) VALUES (_id_sticker,_type,_id,now());
			END IF;  
			IF(_type = 5) AND NOT EXISTS (SELECT id_sticker FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker AND source_type = _type AND id_author = _id)
			THEN
				INSERT into posts_stickers_feeds_sources(id_sticker,source_type,id_author,register_date) VALUES (_id_sticker,_type,_id,now());
			END IF;
            
            -- RSS FEED 
			IF(_type = 100) AND NOT EXISTS (SELECT id_sticker FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker AND source_type = _type AND feed_url = _id)
			THEN
				INSERT into posts_stickers_feeds_sources(id_sticker,source_type,feed_url,register_date) VALUES (_id_sticker,_type,_id,now());
			END IF; 
            
            -- MOST VIEWED
			IF(_type = 200) AND NOT EXISTS (SELECT id_sticker FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker AND source_type = _type AND id_dossier = _id)
			THEN
				INSERT into posts_stickers_feeds_sources(id_sticker,source_type,id_dossier,register_date) VALUES (_id_sticker,_type,_id,now());
			END IF; 
 			IF(_type = 201) AND NOT EXISTS (SELECT id_sticker FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker AND source_type = _type AND id_collection = _id)
			THEN
				INSERT into posts_stickers_feeds_sources(id_sticker,source_type,id_collection,register_date) VALUES (_id_sticker,_type,_id,now());
			END IF;      
            
            -- LATEST
			IF(_type = 300) AND NOT EXISTS (SELECT id_sticker FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker AND source_type = _type AND id_dossier = _id)
			THEN
				INSERT into posts_stickers_feeds_sources(id_sticker,source_type,id_dossier,register_date) VALUES (_id_sticker,_type,_id,now());
			END IF; 
 			IF(_type = 301) AND NOT EXISTS (SELECT id_sticker FROM posts_stickers_feeds_sources WHERE id_sticker = _id_sticker AND source_type = _type AND id_collection = _id)
			THEN
				INSERT into posts_stickers_feeds_sources(id_sticker,source_type,id_collection,register_date) VALUES (_id_sticker,_type,_id,now());
			END IF;      
            
			SELECT 0 as return_code;
	END IF;

ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

