create
    definer = skoiypp@`%` procedure SP_SET_PUBLISH_ADS_CAMPAIGNS_TO_OFFLINE()
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id INT;
DECLARE num_ads INT DEFAULT 0;
DECLARE _empty INT;

DECLARE cursor_id CURSOR FOR SELECT id_campaign FROM ads_campaigns WHERE end_date < now() AND date(end_date) NOT IN ('0000-00-00');
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

 
   
    OPEN cursor_id;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_id INTO c_id;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	

		SELECT FN_SP_SET_PUBLISH_ADS_SYNC_UPDATE(41,c_id) into _empty;

		UPDATE ads_campaigns SET state = 2 WHERE id_campaign = c_id; 
		DELETE FROM ads_campaigns_video_composed_related WHERE id_campaign = c_id;
     
	
    
      END LOOP read_loop;

    CLOSE cursor_id;
 

	SELECT 0 as return_code;

COMMIT;

END;

