create
    definer = skoiypp@`%` procedure SP_SET_PUBLISH_COMPOSES_TO_SCHEDULE_ON_IDLE_PLAYLISTS()
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id_playlist INT;

DECLARE profile_state INT;
DECLARE video_state INT;

DECLARE cursor_id_playlist_idle CURSOR FOR SELECT id_playlist FROM playlists WHERE id_playlist not in (SELECT id_playlist FROM playlists_channels_related);
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

 
   
    OPEN cursor_id_playlist_idle;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_id_playlist_idle INTO c_id_playlist;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	
		
       UPDATE video_composed SET state = 4 WHERE id_composed in (select id_composed FROM video_composed_playlists_related WHERE id_playlist = c_id_playlist) AND 
		(SELECT FN_GET_VIDEO_COMPOSES_ON_PLAYLISTS(id_composed)) = 1;
		
      CALL SP_PUBLISH_VIDEO_CHANGE_PROFILE_AND_VIDEO_STATE_BY_PLAYLIST(c_id_playlist,@result);
      IF(@result <> 0)
      THEN
        SELECT -1 as return_code;
      END IF;              
	
    
      END LOOP read_loop;

    CLOSE cursor_id_playlist_idle;
 

	SELECT 0 as return_code;

COMMIT;

END;

