create
    definer = skoiypp@`%` procedure SP_SET_PUBLISH_POSTS_COLLECTIONS_TO_OFFLINE()
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id_collection INT;
DECLARE _empty INT;

DECLARE cursor_id_collection CURSOR FOR SELECT id_collection FROM collections WHERE end_date < now() AND date(end_date) NOT IN ('0000-00-00') AND state = 5;
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

 
   
    OPEN cursor_id_collection;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_id_collection INTO c_id_collection;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	
		
	SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(32,c_id_collection) into _empty;
        
	UPDATE collections SET state = 4 WHERE id_collection = c_id_collection; 
	UPDATE dossiers SET state = 4 WHERE id_dossier in (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection = c_id_collection); 
	
    UPDATE posts_l10n SET state = 4 WHERE id_post in (select id_post FROM posts_dossiers_related WHERE id_dossier in (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection = c_id_collection)) AND 
		(SELECT FN_GET_POSTS_IS_POSTS_ON_DOSSIER(id_post)) = 1;
		         
	
    
      END LOOP read_loop;

    CLOSE cursor_id_collection;
 

	SELECT 0 as return_code;

COMMIT;

END;

