create
    definer = skoiypp@`%` procedure SP_SET_PUBLISH_POSTS_DOSSIERS_COLLECTIONS_REORDER()
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;

DECLARE c_id_collection INT;

DECLARE cursor_collection CURSOR FOR SELECT distinct id_collection FROM dossiers_collections_related;
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

    
    OPEN cursor_collection;

    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_collection INTO c_id_collection;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	

    SET @rownum=0;
    UPDATE dossiers_collections_related p, (SELECT @rownum:=@rownum+1 rownum, dossiers_collections_related.* FROM dossiers_collections_related WHERE id_collection = c_id_collection ORDER BY position,update_date desc) r 
    SET p.position = r.rownum
    WHERE (p.id_dossier = r.id_dossier);

	
    
      END LOOP read_loop;

    CLOSE cursor_collection;
    

	SELECT 0 as return_code;

COMMIT;

END;

