create
    definer = skoiypp@`%` procedure SP_SET_PUBLISH_VIDEO_COMPOSED_TO_OFFLINE()
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE _empty INT;

DECLARE num_composes INT DEFAULT 0;

DECLARE profile_state INT;
DECLARE video_state INT;

DECLARE c_id_composed INT;
DECLARE c_id_playlist INT;

DECLARE cursor_video_composed CURSOR FOR SELECT id_playlist,vc.id_composed FROM video_composed vc, video_composed_playlists_related vcpr WHERE vc.id_composed = vcpr.id_composed AND ((date(end_date) < date(now())) OR (date(end_date) <= date(now()) AND time(end_date) < time(now()))) AND date(end_date) NOT IN ('0000-00-00');
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

 
   
    OPEN cursor_video_composed;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_video_composed INTO c_id_playlist,c_id_composed;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
		
			SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(30,c_id_composed) into _empty;

			DELETE FROM video_composed_playlists_related WHERE id_playlist = c_id_playlist AND id_composed = c_id_composed;
			SELECT count(1) into num_composes FROM video_composed_playlists_related WHERE id_composed = c_id_composed;
			IF(num_composes = 0)
			THEN
				UPDATE video_composed SET state = 3 WHERE id_composed = c_id_composed;
				
				SELECT max(vc.state) into video_state FROM videos v, video_composed vc WHERE v.id_video = vc.id_video
				AND v.id_video in (SELECT id_video FROM video_composed WHERE id_composed = c_id_composed);
				SELECT max(vc.state) into profile_state FROM video_profiles vp, video_composed vc WHERE vp.id_profile = vc.id_profile
				AND vp.id_profile in (SELECT id_profile FROM video_composed WHERE id_composed = c_id_composed);
			
				UPDATE videos set state = video_state
				WHERE id_video in (SELECT id_video FROM video_composed WHERE id_composed = c_id_composed);

				UPDATE video_profiles_l10n set state = profile_state
				WHERE id_profile in (SELECT id_profile FROM video_composed WHERE id_composed = c_id_composed);
			END IF;
	
    
      END LOOP read_loop;

    CLOSE cursor_video_composed;
 

	SELECT 0 as return_code;

COMMIT;

END;

