create
    definer = skoiypp@`%` procedure SP_SET_PUBLISH_VIDEO_PLAYLISTS_TO_OFFLINE()
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id_playlist INT;
DECLARE _empty INT;

DECLARE profile_state INT;
DECLARE video_state INT;

DECLARE cursor_id_playlist CURSOR FOR SELECT id_playlist FROM playlists WHERE end_date < now() AND date(end_date) NOT IN ('0000-00-00') AND id_playlist in (SELECT id_playlist FROM playlists_channels_related);
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

 
   
    OPEN cursor_id_playlist;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_id_playlist INTO c_id_playlist;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	
		
		SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(31,c_id_playlist) into _empty;

    UPDATE video_composed SET state = 4 WHERE id_composed in (select id_composed FROM video_composed_playlists_related WHERE id_playlist = c_id_playlist) AND 
		(SELECT FN_GET_VIDEO_COMPOSES_ON_PLAYLISTS(id_composed)) = 1;
		
      DELETE FROM playlists_channels_related WHERE id_playlist = c_id_playlist;

      UPDATE playlists SET state = 2 WHERE id_playlist = c_id_playlist AND FN_GET_VIDEO_IS_PLAYLISTS_ON_CHANNEL(c_id_playlist) = 0;
      CALL SP_PUBLISH_VIDEO_CHANGE_PROFILE_AND_VIDEO_STATE_BY_PLAYLIST(c_id_playlist,@result);
      IF(@result <> 0)
      THEN
        SELECT -1 as return_code;
      END IF;
              
	
    
      END LOOP read_loop;

    CLOSE cursor_id_playlist;
 

	SELECT 0 as return_code;

COMMIT;

END;

