create
    definer = skoiypp@`%` procedure SP_SET_PUSH_VIDEO(IN _id_account int(10), IN _account_token varchar(255),
                                                      IN _push_type tinyint(3), IN _id_directory int(10),
                                                      IN _input_path varchar(255), IN _video_name varchar(255),
                                                      IN _video varchar(255), IN _extension varchar(255),
                                                      IN _mime_type varchar(255), IN _size varchar(255),
                                                      IN _requester varchar(255))
BEGIN

DECLARE _request text;
DECLARE _position INT(10) DEFAULT 1; 
DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET _request = CONCAT_WS("','","CALL SP_SET_PUSH_VIDEO( ",_id_account,_account_token,_push_type,_id_directory,_input_path,_video_name,_video,_extension,_mime_type,_size,_requester,")");
INSERT INTO loader_video_requests(id_account,account_token,input_path,video_name,video,id_directory,request,register_date) 
VALUES(_id_account,_account_token,_input_path,_video_name,_video,_id_directory,_request,now());

		SELECT max(position)+1 INTO _position FROM loader_video_queue WHERE id_account = _id_account;
                IF(_position is null) THEN SET _position = 1; END IF;
		INSERT into loader_video_queue(id_account,position,account_token,push_type,id_directory,input_path,video_name,video,extension,mime_type,size,requester,register_date) VALUES(_id_account,_position,_account_token,_push_type,_id_directory,_input_path,_video_name,_video,_extension,_mime_type,_size,_requester,now());
		SET p_last_id = last_insert_id();
		INSERT into loader_video_history(id_account,position,account_token,push_type,id_directory,input_path,video_name,video,extension,mime_type,size,requester,register_date) VALUES(_id_account,_position,_account_token,_push_type,_id_directory,_input_path,_video_name,_video,_extension,_mime_type,_size,_requester,now());

		SELECT FN_PUSH_VIDEO_HAS_DETAILS(id_queue) as has_details,FN_PUSH_VIDEO_HAS_VERSIONS(id_queue) as has_versions,id_queue,id_account, account_token, push_type, id_directory, input_path,video_name, video,extension,mime_type,size,requester
        FROM loader_video_queue WHERE id_queue = p_last_id;

SELECT 0 as return_code;

COMMIT;


END;

