create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_SSO_UPDATE_USER(IN _id_user bigint, IN _id_plan int(10),
                                                                    IN _name varchar(255), IN _gender tinyint(2),
                                                                    IN _birthdate date, IN _identification varchar(255),
                                                                    IN _tax_number varchar(255),
                                                                    IN _nationality varchar(255),
                                                                    IN _country_iso varchar(255), IN _city varchar(255),
                                                                    IN _zipcode varchar(255), IN _phone varchar(255))
BEGIN


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;



START TRANSACTION;

IF EXISTS (SELECT id_user FROM users WHERE id_user = _id_user)
THEN
    
	UPDATE users SET id_plan = _id_plan, name = _name, gender = _gender,birthdate = _birthdate,identification = _identification,tax_number = _tax_number,nationality = _nationality,country_iso = _country_iso,city = _city,zipcode = _zipcode WHERE id_user = _id_user;
    SELECT id_user,FN_GET_OTT_PLAN(id_plan,1) as plan,FN_GET_OTT_PLAN(id_plan,2) as plan_stripped,name,email,gender,birthdate,identification,tax_number,nationality,country_iso,city,zipcode,active,verified,update_date, register_date FROM users WHERE id_user = _id_user; 
    
ELSE
	SELECT -2 as return_code;
END IF;

COMMIT;

END;

