create
    definer = skoiypp@`%` procedure SP_SET_TASK_ARCHIVE_CREATE_CLIP(IN _id_account int(10),
                                                                    IN _account_token varchar(255),
                                                                    IN _id_video int(10), IN _id_clip int(10),
                                                                    IN _input_path varchar(255),
                                                                    IN _output_path varchar(255),
                                                                    IN _file_name varchar(255), IN _source varchar(255),
                                                                    IN _clip varchar(255), IN _muted int(10),
                                                                    IN _in_seconds int(10),
                                                                    IN _duration_seconds int(10),
                                                                    IN _created_video_date date,
                                                                    IN _created_clip_date date)
BEGIN

DECLARE _command text;
DECLARE _output_path_clean varchar(255);

DECLARE _year varchar(25);
DECLARE _month varchar(25);
DECLARE _day varchar(25);


DECLARE _cyear varchar(25);
DECLARE _cmonth varchar(25);
DECLARE _cday varchar(25);



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET _year = year(_created_video_date);
SET _month = month(_created_video_date);
SET _day = day(_created_video_date);

IF(_month < 10) THEN SET _month = CONCAT(0,_month); END IF;
IF(_day < 10) THEN SET _day = CONCAT(0,_day); END IF;

SET _cyear = year(_created_clip_date);
SET _cmonth = month(_created_clip_date);
SET _cday = day(_created_clip_date);

IF(_cmonth < 10) THEN SET _cmonth = CONCAT(0,_cmonth); END IF;
IF(_cday < 10) THEN SET _cday = CONCAT(0,_cday); END IF;

SET _output_path_clean = _output_path;
SET _input_path = CONCAT(_input_path,'/',_account_token,'/',_year,'/',_month,'/',_day,'/');
SET _output_path = CONCAT(_output_path,'/',_account_token,'/',_cyear,'/',_cmonth,'/',_cday,'/');


IF(_muted = 0)
THEN
	SET _command = CONCAT_WS(' ','ffmpeg -ss ',_in_seconds,' -i ',(CONCAT(_input_path,_source)),' -t ',_duration_seconds,' -c copy ',(CONCAT(_output_path,_file_name)));
ELSE
	SET _command = CONCAT_WS(' ','ffmpeg -ss ',_in_seconds,' -i ',(CONCAT(_input_path,_source)),' -t ',_duration_seconds,' -an -c copy ',(CONCAT(_output_path,_file_name)));
END IF;




	INSERT into archive_create_clip_queue(id_account,account_token,output_path,id_video,id_clip,video,muted,in_seconds,duration_seconds,command,created_clip_date,created_video_date,register_date) 
	VALUES(_id_account,_account_token,_output_path_clean,_id_video,_id_clip,_file_name,muted,_in_seconds,_duration_seconds,_command,_created_clip_date,_created_video_date,now());

SELECT 0 as return_code;

COMMIT;


END;

