create
    definer = skoiypp@`%` procedure SP_SET_VIDEO_TRANSCODING(IN _id_account int(10), IN _account_token varchar(255),
                                                             IN _id_video int(10), IN _input_path varchar(255),
                                                             IN _output_path varchar(255), IN _file_name varchar(255),
                                                             IN _source varchar(255), IN _width int(10),
                                                             IN _height int(10), IN _seconds float(10, 2),
                                                             IN _aspect_ratio varchar(255),
                                                             IN _audio_codec varchar(255), IN _audio_rate varchar(255),
                                                             IN _video_rate varchar(255), IN _version tinyint(1),
                                                             IN _h264 tinyint(1), IN _ogg tinyint(1),
                                                             IN _webm tinyint(1), IN _web_version tinyint(1),
                                                             IN _mobile_version tinyint(1), IN _id_storage int(10),
                                                             IN _id_cdn int(10))
BEGIN

DECLARE _request text;

DECLARE _file_extention varchar(255);

DECLARE _command text;
DECLARE _command_webm text;
DECLARE _command_ogg text;
DECLARE _versions text;
DECLARE _ratio varchar(255);


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET _request = CONCAT_WS("','","CALL SP_SET_VIDEO_TRANSCODING( ",_id_account,_account_token,_id_video,_input_path,_output_path,_file_name,_source,_width,_height,_seconds,_aspect_ratio,_audio_codec,_audio_rate,_video_rate,_version,_h264, _ogg, _webm, _web_version, _mobile_version,")");
INSERT INTO video_transcoding_requests(id_account,account_token,aspect_ratio,id_video,video,request,id_storage,id_cdn,register_date) VALUES(_id_account,_account_token,_aspect_ratio,_id_video,_file_name,_request,_id_storage,_id_cdn,now());

SELECT _width/_height into _ratio;


IF(SELECT _ratio in (16/9,854/480))
THEN
CALL SP_SET_VIDEO_TRANSCODING_16BY9(_id_account,_account_token,_id_video,_input_path,_output_path,_file_name,_source,_width,_height,_seconds,_aspect_ratio,_audio_codec,_audio_rate,_video_rate,_h264, _ogg, _webm, _web_version, _mobile_version,_id_storage,_id_cdn);
ELSE

IF(SELECT _ratio in (9/16,480/854))
THEN
CALL SP_SET_VIDEO_TRANSCODING_9BY16(_id_account,_account_token,_id_video,_input_path,_output_path,_file_name,_source,_width,_height,_seconds,_aspect_ratio,_audio_codec,_audio_rate,_video_rate,_h264, _ogg, _webm, _web_version, _mobile_version,_id_storage,_id_cdn);
ELSE

IF(SELECT _ratio in (4/3))
THEN
CALL SP_SET_VIDEO_TRANSCODING_4BY3(_id_account,_account_token,_id_video,_input_path,_output_path,_file_name,_source,_width,_height,_seconds,_aspect_ratio,_audio_codec,_audio_rate,_video_rate,_h264, _ogg, _webm, _web_version, _mobile_version,_id_storage,_id_cdn);
ELSE

IF(SELECT _ratio in (64/27))
THEN
CALL SP_SET_VIDEO_TRANSCODING_64BY27(_id_account,_account_token,_id_video,_input_path,_output_path,_file_name,_source,_width,_height,_seconds,_aspect_ratio,_audio_codec,_audio_rate,_video_rate,_h264, _ogg, _webm, _web_version, _mobile_version,_id_storage,_id_cdn);
ELSE

IF(SELECT _ratio in (40/17))
THEN
CALL SP_SET_VIDEO_TRANSCODING_40BY17(_id_account,_account_token,_id_video,_input_path,_output_path,_file_name,_source,_width,_height,_seconds,_aspect_ratio,_audio_codec,_audio_rate,_video_rate,_h264, _ogg, _webm, _web_version, _mobile_version,_id_storage,_id_cdn);
ELSE

IF(SELECT _ratio in (480/253))
THEN
CALL SP_SET_VIDEO_TRANSCODING_480BY253(_id_account,_account_token,_id_video,_input_path,_output_path,_file_name,_source,_width,_height,_seconds,_aspect_ratio,_audio_codec,_audio_rate,_video_rate,_h264, _ogg, _webm, _web_version, _mobile_version,_id_storage,_id_cdn);
ELSE

IF(SELECT _ratio in (1))
THEN
CALL SP_SET_VIDEO_TRANSCODING_1BY1(_id_account,_account_token,_id_video,_input_path,_output_path,_file_name,_source,_width,_height,_seconds,_aspect_ratio,_audio_codec,_audio_rate,_video_rate,_h264, _ogg, _webm, _web_version, _mobile_version,_id_storage,_id_cdn);
ELSE

SELECT 'x:x';
END IF;
END IF;
END IF;
END IF;
END IF;
END IF;
END IF;

SELECT 0 as return_code;

COMMIT;


END;

