create
    definer = skoiypp@`%` procedure SP_SET_VIDEO_VTT(IN _id_vtt int, IN _id_video int, IN _iso_language varchar(192),
                                                     IN _name varchar(192), IN _file_name varchar(192),
                                                     IN _extension varchar(8), IN _size bigint, IN _label varchar(50),
                                                     IN _vtt_type varchar(192), IN _is_default int(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS (SELECT id_video FROM videos WHERE id_video = _id_video)
THEN
	IF NOT EXISTS (SELECT id_vtt FROM video_text_tracks WHERE id_vtt = _id_vtt)
	THEN
		INSERT into video_text_tracks(id_video,iso_language,name,filename,extension,size,label,vtt_type,is_default,update_date,register_date) VALUES(_id_video,_iso_language,_name,_file_name,_extension,_size,_label,_vtt_type,_is_default,now(),now());
		SET p_last_id = last_insert_id();
		SELECT id_vtt,id_video,iso_language,name,filename,extension,size,label,vtt_type,is_default,register_date FROM video_text_tracks WHERE id_vtt = p_last_id;
	ELSE
		SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(25,_id_vtt) into _empty;
		UPDATE video_text_tracks SET iso_language = _iso_language, name = _name,filename = _file_name, extension = _extension,label = _label, vtt_type = _vtt_type, is_default = _is_default, update_date = now() WHERE id_vtt = _id_vtt;
		SELECT id_vtt,id_video,iso_language,name,filename,extension,size,label,vtt_type,is_default,register_date FROM video_text_tracks WHERE id_vtt = p_last_id;
	END IF;
ELSE
	SELECT -2 as return_code;
END IF;

COMMIT;

END;

