create
    definer = skoiypp@`%` procedure SP_SET_VIDEO_VTT(IN _id_vtt INT, IN _id_video INT, IN _iso_language VARCHAR(192),
                                                     IN _name VARCHAR(192), IN _file_name VARCHAR(192),
                                                     IN _extension VARCHAR(8), IN _size BIGINT, IN _label VARCHAR(50),
                                                     IN _vtt_type VARCHAR(192), IN _is_default INT(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS (SELECT id_video FROM videos WHERE id_video = _id_video)
THEN
	IF NOT EXISTS (SELECT id_vtt FROM video_text_tracks WHERE id_vtt = _id_vtt)
	THEN
		INSERT into video_text_tracks(id_video,iso_language,name,filename,extension,size,label,vtt_type,is_default,update_date,register_date) VALUES(_id_video,_iso_language,_name,_file_name,_extension,_size,_label,_vtt_type,_is_default,now(),now());
		SET p_last_id = last_insert_id();
		SELECT id_vtt,id_video,iso_language,name,filename,extension,size,label,vtt_type,is_default,register_date FROM video_text_tracks WHERE id_vtt = p_last_id;
	ELSE
		SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(25,_id_vtt) into _empty;
		UPDATE video_text_tracks SET iso_language = _iso_language, name = _name,filename = _file_name, extension = _extension,label = _label, vtt_type = _vtt_type, is_default = _is_default, update_date = now() WHERE id_vtt = _id_vtt;
		SELECT id_vtt,id_video,iso_language,name,filename,extension,size,label,vtt_type,is_default,register_date FROM video_text_tracks WHERE id_vtt = p_last_id;
	END IF;
ELSE
	SELECT -2 as return_code;
END IF;

COMMIT;

END;

